// =================================================================== //
// Copyright (C) 2020 Kimura Ryo                                       //
//                                                                     //
// This Source Code Form is subject to the terms of the Mozilla Public //
// License, v. 2.0. If a copy of the MPL was not distributed with this //
// file, You can obtain one at http://mozilla.org/MPL/2.0/.            //
// =================================================================== //

#include <libbsdf/Common/MunsellData.h>

using namespace lb;

const float MunsellData::NORMALIZING_CONSTANT_Y = 102.57f;

const char* MunsellData::H[] = {
"2.5GY",
"5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"5G",
"5G",
"7.5G",
"7.5G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"5B",
"5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"7.5R",
"7.5R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"7.5YR",
"10YR",
"2.5Y",
"5Y",
"7.5Y",
"10Y",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"5G",
"5G",
"7.5G",
"7.5G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"10YR",
"2.5Y",
"5Y",
"7.5Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"10Y",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"2.5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"7.5GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"10GY",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"2.5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"7.5G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"10G",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"2.5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"7.5BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"10BG",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"2.5B",
"5B",
"5B",
"5B",
"5B",
"7.5B",
"7.5B",
"7.5B",
"10B",
"10B",
"10B",
"2.5PB",
"2.5PB",
"2.5PB",
"5PB",
"5PB",
"5PB",
"7.5PB",
"7.5PB",
"7.5PB",
"10PB",
"10PB",
"10PB",
"2.5P",
"2.5P",
"2.5P",
"5P",
"5P",
"5P",
"5P",
"7.5P",
"7.5P",
"7.5P",
"7.5P",
"10P",
"10P",
"10P",
"10P",
"10P",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"2.5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"7.5RP",
"10RP",
"10RP",
"10RP",
"10RP",
"2.5R",
"2.5R",
"2.5R",
"2.5R",
"5R",
"5R",
"5R",
"5R",
"7.5R",
"7.5R",
"7.5R",
"7.5R",
"10R",
"10R",
"10R",
"10R",
"2.5YR",
"2.5YR",
"2.5YR",
"2.5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"7.5YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"10YR",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"2.5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y",
"7.5Y"
};

const float MunsellData::V[] = {
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.2f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.4f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.6f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
0.8f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
1.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
2.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
3.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
4.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
5.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
6.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
7.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
8.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
9.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f,
10.0f
};

const int MunsellData::C[] = {
2,
2,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
2,
4,
6,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
2,
2,
2,
2,
2,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
2,
4,
2,
2,
2,
2,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
2,
4,
2,
4,
2,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
2,
4,
6,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
2,
4,
2,
4,
2,
4,
2,
4,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
50,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
50,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
50,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
50,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
48,
50,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
44,
46,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
42,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
38,
40,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
36,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
34,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
32,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
30,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
28,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
26,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
24,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
14,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
2,
4,
6,
8,
10,
2,
4,
6,
8,
10,
12,
2,
4,
6,
8,
10,
12,
14,
16,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22,
2,
4,
6,
8,
10,
12,
14,
16,
18,
20,
22
};

const float MunsellData::xyY[] =
{
0.713f, 1.414f, 0.237f,
0.449f, 1.145f, 0.237f,
0.262f, 0.837f, 0.237f,
-0.078f, 2.16f, 0.237f,
0.185f, 0.676f, 0.237f,
-0.257f, 1.233f, 0.237f,
0.144f, 0.584f, 0.237f,
-0.235f, 0.891f, 0.237f,
0.117f, 0.516f, 0.237f,
-0.209f, 0.719f, 0.237f,
0.097f, 0.458f, 0.237f,
-0.181f, 0.575f, 0.237f,
0.08f, 0.397f, 0.237f,
-0.137f, 0.425f, 0.237f,
0.068f, 0.332f, 0.237f,
-0.1f, 0.325f, 0.237f,
0.066f, 0.261f, 0.237f,
-0.048f, 0.223f, 0.237f,
0.072f, 0.226f, 0.237f,
-0.016f, 0.181f, 0.237f,
0.085f, 0.195f, 0.237f,
0.015f, 0.148f, 0.237f,
0.097f, 0.177f, 0.237f,
0.039f, 0.128f, 0.237f,
0.111f, 0.164f, 0.237f,
0.063f, 0.114f, 0.237f,
0.121f, 0.157f, 0.237f,
0.074f, 0.109f, 0.237f,
0.133f, 0.149f, 0.237f,
0.088f, 0.102f, 0.237f,
0.063f, 0.074f, 0.237f,
0.147f, 0.143f, 0.237f,
0.109f, 0.094f, 0.237f,
0.087f, 0.067f, 0.237f,
0.165f, 0.136f, 0.237f,
0.133f, 0.09f, 0.237f,
0.115f, 0.062f, 0.237f,
0.104f, 0.045f, 0.237f,
0.096f, 0.032f, 0.237f,
0.086f, 0.018f, 0.237f,
0.192f, 0.13f, 0.237f,
0.171f, 0.087f, 0.237f,
0.159f, 0.061f, 0.237f,
0.152f, 0.045f, 0.237f,
0.148f, 0.034f, 0.237f,
0.145f, 0.025f, 0.237f,
0.142f, 0.018f, 0.237f,
0.139f, 0.012f, 0.237f,
0.137f, 0.006f, 0.237f,
0.136f, 0.0f, 0.237f,
0.227f, 0.126f, 0.237f,
0.213f, 0.088f, 0.237f,
0.206f, 0.064f, 0.237f,
0.202f, 0.049f, 0.237f,
0.2f, 0.04f, 0.237f,
0.198f, 0.031f, 0.237f,
0.196f, 0.024f, 0.237f,
0.195f, 0.018f, 0.237f,
0.193f, 0.012f, 0.237f,
0.192f, 0.006f, 0.237f,
0.25f, 0.127f, 0.237f,
0.241f, 0.09f, 0.237f,
0.236f, 0.067f, 0.237f,
0.232f, 0.052f, 0.237f,
0.231f, 0.043f, 0.237f,
0.229f, 0.035f, 0.237f,
0.228f, 0.028f, 0.237f,
0.227f, 0.022f, 0.237f,
0.226f, 0.016f, 0.237f,
0.275f, 0.129f, 0.237f,
0.269f, 0.093f, 0.237f,
0.266f, 0.072f, 0.237f,
0.264f, 0.056f, 0.237f,
0.263f, 0.047f, 0.237f,
0.263f, 0.039f, 0.237f,
0.262f, 0.032f, 0.237f,
0.288f, 0.131f, 0.237f,
0.283f, 0.094f, 0.237f,
0.28f, 0.074f, 0.237f,
0.277f, 0.058f, 0.237f,
0.276f, 0.049f, 0.237f,
0.275f, 0.04f, 0.237f,
0.3f, 0.134f, 0.237f,
0.296f, 0.097f, 0.237f,
0.293f, 0.075f, 0.237f,
0.291f, 0.06f, 0.237f,
0.29f, 0.051f, 0.237f,
0.315f, 0.137f, 0.237f,
0.313f, 0.1f, 0.237f,
0.312f, 0.078f, 0.237f,
0.31f, 0.064f, 0.237f,
0.31f, 0.053f, 0.237f,
0.337f, 0.143f, 0.237f,
0.341f, 0.106f, 0.237f,
0.342f, 0.084f, 0.237f,
0.342f, 0.069f, 0.237f,
0.37f, 0.152f, 0.237f,
0.381f, 0.115f, 0.237f,
0.388f, 0.093f, 0.237f,
0.393f, 0.077f, 0.237f,
0.404f, 0.164f, 0.237f,
0.424f, 0.125f, 0.237f,
0.435f, 0.103f, 0.237f,
0.451f, 0.183f, 0.237f,
0.488f, 0.142f, 0.237f,
0.51f, 0.119f, 0.237f,
0.501f, 0.204f, 0.237f,
0.556f, 0.159f, 0.237f,
0.543f, 0.224f, 0.237f,
0.626f, 0.178f, 0.237f,
0.592f, 0.246f, 0.237f,
0.696f, 0.198f, 0.237f,
0.679f, 0.29f, 0.237f,
0.843f, 0.245f, 0.237f,
0.837f, 0.375f, 0.237f,
1.174f, 0.355f, 0.237f,
1.0f, 0.48f, 0.237f,
1.29f, 0.74f, 0.237f,
1.43f, 0.97f, 0.237f,
1.495f, 1.284f, 0.237f,
1.434f, 1.459f, 0.237f,
0.542f, 0.67f, 0.467f,
0.423f, 0.59f, 0.467f,
0.735f, 1.82f, 0.467f,
0.358f, 0.528f, 0.467f,
0.323f, 1.467f, 0.467f,
0.312f, 0.482f, 0.467f,
0.128f, 1.141f, 0.467f,
0.277f, 0.445f, 0.467f,
0.041f, 0.906f, 0.467f,
0.258f, 0.423f, 0.467f,
0.005f, 0.743f, 0.467f,
0.239f, 0.399f, 0.467f,
-0.011f, 0.604f, 0.467f,
0.226f, 0.38f, 0.467f,
-0.011f, 0.501f, 0.467f,
0.213f, 0.361f, 0.467f,
-0.004f, 0.405f, 0.467f,
0.196f, 0.332f, 0.467f,
0.008f, 0.334f, 0.467f,
0.18f, 0.298f, 0.467f,
0.031f, 0.259f, 0.467f,
0.173f, 0.275f, 0.467f,
0.051f, 0.22f, 0.467f,
-0.005f, 0.193f, 0.467f,
0.169f, 0.249f, 0.467f,
0.074f, 0.187f, 0.467f,
0.032f, 0.149f, 0.467f,
0.169f, 0.236f, 0.467f,
0.087f, 0.172f, 0.467f,
0.048f, 0.134f, 0.467f,
0.172f, 0.223f, 0.467f,
0.102f, 0.159f, 0.467f,
0.067f, 0.119f, 0.467f,
0.176f, 0.213f, 0.467f,
0.113f, 0.151f, 0.467f,
0.081f, 0.111f, 0.467f,
0.183f, 0.203f, 0.467f,
0.126f, 0.145f, 0.467f,
0.093f, 0.105f, 0.467f,
0.067f, 0.067f, 0.467f,
0.19f, 0.196f, 0.467f,
0.141f, 0.139f, 0.467f,
0.113f, 0.098f, 0.467f,
0.093f, 0.065f, 0.467f,
0.202f, 0.188f, 0.467f,
0.161f, 0.134f, 0.467f,
0.135f, 0.095f, 0.467f,
0.116f, 0.066f, 0.467f,
0.107f, 0.053f, 0.467f,
0.099f, 0.042f, 0.467f,
0.096f, 0.036f, 0.467f,
0.094f, 0.03f, 0.467f,
0.091f, 0.025f, 0.467f,
0.086f, 0.018f, 0.467f,
0.22f, 0.18f, 0.467f,
0.192f, 0.13f, 0.467f,
0.175f, 0.095f, 0.467f,
0.165f, 0.072f, 0.467f,
0.16f, 0.058f, 0.467f,
0.155f, 0.046f, 0.467f,
0.152f, 0.04f, 0.467f,
0.15f, 0.032f, 0.467f,
0.147f, 0.026f, 0.467f,
0.145f, 0.02f, 0.467f,
0.143f, 0.016f, 0.467f,
0.141f, 0.01f, 0.467f,
0.139f, 0.005f, 0.467f,
0.137f, 0.001f, 0.467f,
0.241f, 0.176f, 0.467f,
0.223f, 0.131f, 0.467f,
0.212f, 0.1f, 0.467f,
0.206f, 0.078f, 0.467f,
0.202f, 0.062f, 0.467f,
0.199f, 0.05f, 0.467f,
0.197f, 0.043f, 0.467f,
0.195f, 0.036f, 0.467f,
0.193f, 0.029f, 0.467f,
0.192f, 0.024f, 0.467f,
0.191f, 0.018f, 0.467f,
0.19f, 0.013f, 0.467f,
0.188f, 0.008f, 0.467f,
0.187f, 0.004f, 0.467f,
0.259f, 0.177f, 0.467f,
0.246f, 0.134f, 0.467f,
0.238f, 0.104f, 0.467f,
0.233f, 0.082f, 0.467f,
0.23f, 0.064f, 0.467f,
0.227f, 0.054f, 0.467f,
0.226f, 0.045f, 0.467f,
0.224f, 0.038f, 0.467f,
0.223f, 0.031f, 0.467f,
0.222f, 0.026f, 0.467f,
0.22f, 0.02f, 0.467f,
0.219f, 0.016f, 0.467f,
0.218f, 0.01f, 0.467f,
0.281f, 0.182f, 0.467f,
0.272f, 0.138f, 0.467f,
0.265f, 0.11f, 0.467f,
0.26f, 0.087f, 0.467f,
0.257f, 0.069f, 0.467f,
0.253f, 0.057f, 0.467f,
0.252f, 0.048f, 0.467f,
0.25f, 0.04f, 0.467f,
0.248f, 0.034f, 0.467f,
0.247f, 0.028f, 0.467f,
0.296f, 0.185f, 0.467f,
0.289f, 0.142f, 0.467f,
0.284f, 0.114f, 0.467f,
0.28f, 0.091f, 0.467f,
0.276f, 0.072f, 0.467f,
0.273f, 0.059f, 0.467f,
0.272f, 0.049f, 0.467f,
0.27f, 0.042f, 0.467f,
0.269f, 0.034f, 0.467f,
0.309f, 0.189f, 0.467f,
0.304f, 0.146f, 0.467f,
0.302f, 0.119f, 0.467f,
0.298f, 0.095f, 0.467f,
0.296f, 0.073f, 0.467f,
0.294f, 0.061f, 0.467f,
0.293f, 0.052f, 0.467f,
0.291f, 0.043f, 0.467f,
0.32f, 0.193f, 0.467f,
0.32f, 0.151f, 0.467f,
0.32f, 0.123f, 0.467f,
0.32f, 0.1f, 0.467f,
0.32f, 0.078f, 0.467f,
0.32f, 0.065f, 0.467f,
0.32f, 0.054f, 0.467f,
0.337f, 0.199f, 0.467f,
0.344f, 0.158f, 0.467f,
0.348f, 0.131f, 0.467f,
0.35f, 0.106f, 0.467f,
0.353f, 0.082f, 0.467f,
0.353f, 0.07f, 0.467f,
0.36f, 0.209f, 0.467f,
0.374f, 0.169f, 0.467f,
0.384f, 0.141f, 0.467f,
0.391f, 0.117f, 0.467f,
0.398f, 0.09f, 0.467f,
0.381f, 0.22f, 0.467f,
0.406f, 0.181f, 0.467f,
0.423f, 0.153f, 0.467f,
0.437f, 0.128f, 0.467f,
0.454f, 0.098f, 0.467f,
0.411f, 0.236f, 0.467f,
0.45f, 0.198f, 0.467f,
0.477f, 0.17f, 0.467f,
0.501f, 0.143f, 0.467f,
0.529f, 0.113f, 0.467f,
0.441f, 0.255f, 0.467f,
0.498f, 0.219f, 0.467f,
0.537f, 0.19f, 0.467f,
0.575f, 0.161f, 0.467f,
0.466f, 0.272f, 0.467f,
0.539f, 0.238f, 0.467f,
0.588f, 0.208f, 0.467f,
0.635f, 0.176f, 0.467f,
0.49f, 0.289f, 0.467f,
0.582f, 0.258f, 0.467f,
0.649f, 0.229f, 0.467f,
0.706f, 0.196f, 0.467f,
0.534f, 0.324f, 0.467f,
0.665f, 0.298f, 0.467f,
0.755f, 0.27f, 0.467f,
0.844f, 0.241f, 0.467f,
0.585f, 0.367f, 0.467f,
0.775f, 0.362f, 0.467f,
0.889f, 0.344f, 0.467f,
0.638f, 0.42f, 0.467f,
0.908f, 0.452f, 0.467f,
0.698f, 0.499f, 0.467f,
0.729f, 0.588f, 0.467f,
0.721f, 0.656f, 0.467f,
0.659f, 0.7f, 0.467f,
0.432f, 0.501f, 0.699f,
0.902f, 1.223f, 0.699f,
0.377f, 0.468f, 0.699f,
0.603f, 1.169f, 0.699f,
0.342f, 0.442f, 0.699f,
0.41f, 0.995f, 0.699f,
0.315f, 0.42f, 0.699f,
0.274f, 0.792f, 0.699f,
-0.045f, 1.459f, 0.699f,
0.292f, 0.399f, 0.699f,
0.208f, 0.652f, 0.699f,
-0.128f, 1.125f, 0.699f,
0.281f, 0.388f, 0.699f,
0.175f, 0.561f, 0.699f,
-0.143f, 0.889f, 0.699f,
0.27f, 0.376f, 0.699f,
0.152f, 0.493f, 0.699f,
-0.128f, 0.682f, 0.699f,
0.259f, 0.363f, 0.699f,
0.137f, 0.44f, 0.699f,
-0.102f, 0.541f, 0.699f,
0.247f, 0.349f, 0.699f,
0.124f, 0.389f, 0.699f,
-0.068f, 0.425f, 0.699f,
0.236f, 0.334f, 0.699f,
0.117f, 0.341f, 0.699f,
-0.036f, 0.334f, 0.699f,
0.221f, 0.311f, 0.699f,
0.112f, 0.284f, 0.699f,
0.009f, 0.243f, 0.699f,
0.213f, 0.295f, 0.699f,
0.113f, 0.254f, 0.699f,
0.03f, 0.211f, 0.699f,
0.206f, 0.276f, 0.699f,
0.116f, 0.221f, 0.699f,
0.052f, 0.176f, 0.699f,
0.202f, 0.26f, 0.699f,
0.123f, 0.202f, 0.699f,
0.071f, 0.157f, 0.699f,
0.017f, 0.111f, 0.699f,
0.202f, 0.245f, 0.699f,
0.134f, 0.187f, 0.699f,
0.088f, 0.145f, 0.699f,
0.044f, 0.1f, 0.699f,
0.204f, 0.235f, 0.699f,
0.143f, 0.178f, 0.699f,
0.099f, 0.136f, 0.699f,
0.06f, 0.096f, 0.699f,
0.209f, 0.227f, 0.699f,
0.153f, 0.172f, 0.699f,
0.115f, 0.128f, 0.699f,
0.084f, 0.091f, 0.699f,
0.215f, 0.221f, 0.699f,
0.166f, 0.165f, 0.699f,
0.131f, 0.122f, 0.699f,
0.106f, 0.09f, 0.699f,
0.089f, 0.068f, 0.699f,
0.079f, 0.055f, 0.699f,
0.223f, 0.215f, 0.699f,
0.182f, 0.16f, 0.699f,
0.152f, 0.118f, 0.699f,
0.131f, 0.088f, 0.699f,
0.118f, 0.069f, 0.699f,
0.11f, 0.057f, 0.699f,
0.104f, 0.048f, 0.699f,
0.099f, 0.04f, 0.699f,
0.093f, 0.032f, 0.699f,
0.088f, 0.024f, 0.699f,
0.084f, 0.018f, 0.699f,
0.239f, 0.208f, 0.699f,
0.208f, 0.155f, 0.699f,
0.188f, 0.117f, 0.699f,
0.176f, 0.092f, 0.699f,
0.168f, 0.074f, 0.699f,
0.163f, 0.062f, 0.699f,
0.159f, 0.053f, 0.699f,
0.156f, 0.045f, 0.699f,
0.153f, 0.037f, 0.699f,
0.15f, 0.03f, 0.699f,
0.148f, 0.025f, 0.699f,
0.146f, 0.02f, 0.699f,
0.144f, 0.014f, 0.699f,
0.142f, 0.008f, 0.699f,
0.14f, 0.004f, 0.699f,
0.257f, 0.204f, 0.699f,
0.237f, 0.157f, 0.699f,
0.225f, 0.124f, 0.699f,
0.216f, 0.098f, 0.699f,
0.211f, 0.082f, 0.699f,
0.208f, 0.07f, 0.699f,
0.204f, 0.058f, 0.699f,
0.202f, 0.05f, 0.699f,
0.2f, 0.042f, 0.699f,
0.198f, 0.035f, 0.699f,
0.196f, 0.029f, 0.699f,
0.195f, 0.024f, 0.699f,
0.194f, 0.018f, 0.699f,
0.192f, 0.012f, 0.699f,
0.19f, 0.006f, 0.699f,
0.272f, 0.205f, 0.699f,
0.258f, 0.16f, 0.699f,
0.25f, 0.129f, 0.699f,
0.244f, 0.104f, 0.699f,
0.24f, 0.088f, 0.699f,
0.238f, 0.075f, 0.699f,
0.235f, 0.06f, 0.699f,
0.233f, 0.053f, 0.699f,
0.232f, 0.044f, 0.699f,
0.23f, 0.038f, 0.699f,
0.229f, 0.032f, 0.699f,
0.228f, 0.027f, 0.699f,
0.227f, 0.021f, 0.699f,
0.226f, 0.014f, 0.699f,
0.287f, 0.207f, 0.699f,
0.28f, 0.166f, 0.699f,
0.274f, 0.136f, 0.699f,
0.27f, 0.11f, 0.699f,
0.268f, 0.094f, 0.699f,
0.266f, 0.08f, 0.699f,
0.264f, 0.065f, 0.699f,
0.263f, 0.056f, 0.699f,
0.262f, 0.046f, 0.699f,
0.261f, 0.041f, 0.699f,
0.26f, 0.034f, 0.699f,
0.26f, 0.03f, 0.699f,
0.301f, 0.211f, 0.699f,
0.296f, 0.17f, 0.699f,
0.292f, 0.141f, 0.699f,
0.288f, 0.115f, 0.699f,
0.284f, 0.098f, 0.699f,
0.281f, 0.083f, 0.699f,
0.279f, 0.067f, 0.699f,
0.277f, 0.056f, 0.699f,
0.276f, 0.049f, 0.699f,
0.275f, 0.042f, 0.699f,
0.311f, 0.214f, 0.699f,
0.308f, 0.174f, 0.699f,
0.306f, 0.145f, 0.699f,
0.304f, 0.119f, 0.699f,
0.302f, 0.101f, 0.699f,
0.301f, 0.087f, 0.699f,
0.299f, 0.069f, 0.699f,
0.298f, 0.06f, 0.699f,
0.297f, 0.051f, 0.699f,
0.322f, 0.218f, 0.699f,
0.324f, 0.179f, 0.699f,
0.325f, 0.151f, 0.699f,
0.326f, 0.125f, 0.699f,
0.326f, 0.106f, 0.699f,
0.326f, 0.092f, 0.699f,
0.326f, 0.073f, 0.699f,
0.325f, 0.062f, 0.699f,
0.337f, 0.226f, 0.699f,
0.347f, 0.189f, 0.699f,
0.354f, 0.159f, 0.699f,
0.359f, 0.135f, 0.699f,
0.363f, 0.114f, 0.699f,
0.366f, 0.099f, 0.699f,
0.37f, 0.08f, 0.699f,
0.373f, 0.068f, 0.699f,
0.355f, 0.236f, 0.699f,
0.373f, 0.2f, 0.699f,
0.387f, 0.17f, 0.699f,
0.397f, 0.146f, 0.699f,
0.406f, 0.124f, 0.699f,
0.413f, 0.106f, 0.699f,
0.421f, 0.087f, 0.699f,
0.372f, 0.247f, 0.699f,
0.399f, 0.211f, 0.699f,
0.419f, 0.182f, 0.699f,
0.434f, 0.158f, 0.699f,
0.447f, 0.135f, 0.699f,
0.459f, 0.114f, 0.699f,
0.391f, 0.26f, 0.699f,
0.432f, 0.227f, 0.699f,
0.464f, 0.2f, 0.699f,
0.489f, 0.176f, 0.699f,
0.511f, 0.154f, 0.699f,
0.537f, 0.126f, 0.699f,
0.411f, 0.274f, 0.699f,
0.469f, 0.246f, 0.699f,
0.514f, 0.221f, 0.699f,
0.551f, 0.197f, 0.699f,
0.586f, 0.176f, 0.699f,
0.431f, 0.29f, 0.699f,
0.502f, 0.264f, 0.699f,
0.558f, 0.24f, 0.699f,
0.604f, 0.214f, 0.699f,
0.64f, 0.192f, 0.699f,
0.447f, 0.305f, 0.699f,
0.537f, 0.284f, 0.699f,
0.605f, 0.261f, 0.699f,
0.66f, 0.235f, 0.699f,
0.704f, 0.214f, 0.699f,
0.474f, 0.332f, 0.699f,
0.603f, 0.322f, 0.699f,
0.693f, 0.303f, 0.699f,
0.787f, 0.282f, 0.699f,
0.846f, 0.266f, 0.699f,
0.505f, 0.367f, 0.699f,
0.673f, 0.371f, 0.699f,
0.805f, 0.362f, 0.699f,
0.93f, 0.347f, 0.699f,
0.526f, 0.397f, 0.699f,
0.764f, 0.441f, 0.699f,
0.551f, 0.444f, 0.699f,
0.899f, 0.587f, 0.699f,
0.563f, 0.491f, 0.699f,
0.995f, 0.734f, 0.699f,
0.548f, 0.526f, 0.699f,
0.502f, 0.531f, 0.699f,
1.044f, 1.074f, 0.699f,
0.397f, 0.448f, 0.943f,
0.761f, 0.998f, 0.943f,
0.363f, 0.425f, 0.943f,
0.556f, 0.907f, 0.943f,
0.336f, 0.41f, 0.943f,
0.4f, 0.738f, 0.943f,
0.425f, 1.266f, 0.943f,
0.314f, 0.394f, 0.943f,
0.305f, 0.613f, 0.943f,
0.237f, 0.969f, 0.943f,
-0.119f, 1.632f, 0.943f,
0.298f, 0.381f, 0.943f,
0.254f, 0.537f, 0.943f,
0.15f, 0.791f, 0.943f,
-0.156f, 1.22f, 0.943f,
0.287f, 0.371f, 0.943f,
0.225f, 0.488f, 0.943f,
0.102f, 0.66f, 0.943f,
-0.213f, 0.967f, 0.943f,
0.28f, 0.363f, 0.943f,
0.205f, 0.447f, 0.943f,
0.082f, 0.553f, 0.943f,
-0.185f, 0.737f, 0.943f,
0.272f, 0.355f, 0.943f,
0.191f, 0.414f, 0.943f,
0.073f, 0.476f, 0.943f,
-0.143f, 0.561f, 0.943f,
0.265f, 0.346f, 0.943f,
0.178f, 0.382f, 0.943f,
0.07f, 0.408f, 0.943f,
-0.1f, 0.428f, 0.943f,
0.253f, 0.332f, 0.943f,
0.163f, 0.342f, 0.943f,
0.07f, 0.341f, 0.943f,
-0.062f, 0.33f, 0.943f,
0.241f, 0.315f, 0.943f,
0.15f, 0.299f, 0.943f,
0.072f, 0.275f, 0.943f,
-0.018f, 0.239f, 0.943f,
0.23f, 0.296f, 0.943f,
0.145f, 0.264f, 0.943f,
0.077f, 0.233f, 0.943f,
0.008f, 0.198f, 0.943f,
0.223f, 0.28f, 0.943f,
0.146f, 0.237f, 0.943f,
0.086f, 0.199f, 0.943f,
0.033f, 0.164f, 0.943f,
0.22f, 0.271f, 0.943f,
0.149f, 0.222f, 0.943f,
0.094f, 0.181f, 0.943f,
0.048f, 0.147f, 0.943f,
0.218f, 0.258f, 0.943f,
0.154f, 0.207f, 0.943f,
0.106f, 0.163f, 0.943f,
0.069f, 0.127f, 0.943f,
0.22f, 0.249f, 0.943f,
0.16f, 0.196f, 0.943f,
0.115f, 0.153f, 0.943f,
0.082f, 0.12f, 0.943f,
0.049f, 0.089f, 0.943f,
0.222f, 0.241f, 0.943f,
0.168f, 0.187f, 0.943f,
0.128f, 0.145f, 0.943f,
0.097f, 0.112f, 0.943f,
0.071f, 0.083f, 0.943f,
0.225f, 0.234f, 0.943f,
0.178f, 0.181f, 0.943f,
0.142f, 0.138f, 0.943f,
0.117f, 0.105f, 0.943f,
0.098f, 0.081f, 0.943f,
0.082f, 0.058f, 0.943f,
0.234f, 0.226f, 0.943f,
0.192f, 0.174f, 0.943f,
0.16f, 0.132f, 0.943f,
0.139f, 0.102f, 0.943f,
0.123f, 0.083f, 0.943f,
0.109f, 0.06f, 0.943f,
0.099f, 0.045f, 0.943f,
0.092f, 0.034f, 0.943f,
0.087f, 0.026f, 0.943f,
0.081f, 0.018f, 0.943f,
0.247f, 0.221f, 0.943f,
0.216f, 0.17f, 0.943f,
0.194f, 0.131f, 0.943f,
0.179f, 0.104f, 0.943f,
0.17f, 0.089f, 0.943f,
0.162f, 0.072f, 0.943f,
0.155f, 0.056f, 0.943f,
0.15f, 0.046f, 0.943f,
0.147f, 0.039f, 0.943f,
0.144f, 0.032f, 0.943f,
0.14f, 0.025f, 0.943f,
0.137f, 0.018f, 0.943f,
0.135f, 0.013f, 0.943f,
0.133f, 0.009f, 0.943f,
0.131f, 0.005f, 0.943f,
0.13f, 0.002f, 0.943f,
0.129f, -0.001f, 0.943f,
0.128f, -0.004f, 0.943f,
0.263f, 0.219f, 0.943f,
0.242f, 0.17f, 0.943f,
0.229f, 0.137f, 0.943f,
0.22f, 0.112f, 0.943f,
0.215f, 0.097f, 0.943f,
0.21f, 0.081f, 0.943f,
0.206f, 0.068f, 0.943f,
0.203f, 0.057f, 0.943f,
0.2f, 0.05f, 0.943f,
0.199f, 0.043f, 0.943f,
0.197f, 0.036f, 0.943f,
0.196f, 0.03f, 0.943f,
0.194f, 0.026f, 0.943f,
0.193f, 0.021f, 0.943f,
0.192f, 0.018f, 0.943f,
0.191f, 0.014f, 0.943f,
0.19f, 0.01f, 0.943f,
0.189f, 0.008f, 0.943f,
0.277f, 0.22f, 0.943f,
0.264f, 0.174f, 0.943f,
0.255f, 0.144f, 0.943f,
0.248f, 0.12f, 0.943f,
0.245f, 0.105f, 0.943f,
0.242f, 0.09f, 0.943f,
0.238f, 0.076f, 0.943f,
0.236f, 0.064f, 0.943f,
0.235f, 0.057f, 0.943f,
0.233f, 0.05f, 0.943f,
0.232f, 0.044f, 0.943f,
0.231f, 0.038f, 0.943f,
0.23f, 0.034f, 0.943f,
0.228f, 0.028f, 0.943f,
0.228f, 0.026f, 0.943f,
0.227f, 0.022f, 0.943f,
0.227f, 0.019f, 0.943f,
0.227f, 0.015f, 0.943f,
0.292f, 0.224f, 0.943f,
0.283f, 0.179f, 0.943f,
0.279f, 0.151f, 0.943f,
0.275f, 0.127f, 0.943f,
0.269f, 0.112f, 0.943f,
0.266f, 0.095f, 0.943f,
0.263f, 0.08f, 0.943f,
0.262f, 0.069f, 0.943f,
0.26f, 0.062f, 0.943f,
0.258f, 0.056f, 0.943f,
0.257f, 0.049f, 0.943f,
0.256f, 0.044f, 0.943f,
0.256f, 0.039f, 0.943f,
0.255f, 0.035f, 0.943f,
0.254f, 0.03f, 0.943f,
0.304f, 0.228f, 0.943f,
0.298f, 0.184f, 0.943f,
0.294f, 0.156f, 0.943f,
0.291f, 0.132f, 0.943f,
0.29f, 0.118f, 0.943f,
0.287f, 0.101f, 0.943f,
0.284f, 0.084f, 0.943f,
0.283f, 0.072f, 0.943f,
0.281f, 0.066f, 0.943f,
0.28f, 0.06f, 0.943f,
0.279f, 0.054f, 0.943f,
0.278f, 0.049f, 0.943f,
0.278f, 0.044f, 0.943f,
0.312f, 0.232f, 0.943f,
0.31f, 0.189f, 0.943f,
0.309f, 0.162f, 0.943f,
0.308f, 0.137f, 0.943f,
0.307f, 0.123f, 0.943f,
0.306f, 0.106f, 0.943f,
0.304f, 0.089f, 0.943f,
0.303f, 0.078f, 0.943f,
0.302f, 0.071f, 0.943f,
0.302f, 0.065f, 0.943f,
0.302f, 0.059f, 0.943f,
0.302f, 0.053f, 0.943f,
0.322f, 0.236f, 0.943f,
0.326f, 0.195f, 0.943f,
0.328f, 0.168f, 0.943f,
0.329f, 0.144f, 0.943f,
0.329f, 0.129f, 0.943f,
0.33f, 0.111f, 0.943f,
0.33f, 0.093f, 0.943f,
0.331f, 0.084f, 0.943f,
0.331f, 0.077f, 0.943f,
0.331f, 0.07f, 0.943f,
0.331f, 0.065f, 0.943f,
0.336f, 0.243f, 0.943f,
0.347f, 0.206f, 0.943f,
0.355f, 0.179f, 0.943f,
0.362f, 0.154f, 0.943f,
0.366f, 0.139f, 0.943f,
0.37f, 0.12f, 0.943f,
0.373f, 0.105f, 0.943f,
0.376f, 0.094f, 0.943f,
0.378f, 0.086f, 0.943f,
0.379f, 0.081f, 0.943f,
0.35f, 0.251f, 0.943f,
0.369f, 0.217f, 0.943f,
0.384f, 0.19f, 0.943f,
0.397f, 0.165f, 0.943f,
0.405f, 0.149f, 0.943f,
0.413f, 0.132f, 0.943f,
0.421f, 0.115f, 0.943f,
0.427f, 0.104f, 0.943f,
0.365f, 0.261f, 0.943f,
0.393f, 0.23f, 0.943f,
0.415f, 0.203f, 0.943f,
0.435f, 0.177f, 0.943f,
0.447f, 0.16f, 0.943f,
0.459f, 0.143f, 0.943f,
0.47f, 0.127f, 0.943f,
0.381f, 0.272f, 0.943f,
0.421f, 0.245f, 0.943f,
0.455f, 0.219f, 0.943f,
0.483f, 0.195f, 0.943f,
0.502f, 0.177f, 0.943f,
0.521f, 0.159f, 0.943f,
0.536f, 0.143f, 0.943f,
0.399f, 0.286f, 0.943f,
0.45f, 0.261f, 0.943f,
0.496f, 0.237f, 0.943f,
0.536f, 0.214f, 0.943f,
0.565f, 0.197f, 0.943f,
0.591f, 0.18f, 0.943f,
0.411f, 0.297f, 0.943f,
0.477f, 0.276f, 0.943f,
0.534f, 0.255f, 0.943f,
0.584f, 0.234f, 0.943f,
0.624f, 0.216f, 0.943f,
0.66f, 0.199f, 0.943f,
0.423f, 0.309f, 0.943f,
0.508f, 0.296f, 0.943f,
0.578f, 0.28f, 0.943f,
0.635f, 0.259f, 0.943f,
0.685f, 0.24f, 0.943f,
0.725f, 0.218f, 0.943f,
0.445f, 0.333f, 0.943f,
0.558f, 0.33f, 0.943f,
0.637f, 0.32f, 0.943f,
0.715f, 0.306f, 0.943f,
0.802f, 0.288f, 0.943f,
0.875f, 0.273f, 0.943f,
0.463f, 0.361f, 0.943f,
0.612f, 0.376f, 0.943f,
0.721f, 0.376f, 0.943f,
0.826f, 0.372f, 0.943f,
0.475f, 0.386f, 0.943f,
0.663f, 0.43f, 0.943f,
0.817f, 0.45f, 0.943f,
0.481f, 0.411f, 0.943f,
0.749f, 0.534f, 0.943f,
0.479f, 0.439f, 0.943f,
0.82f, 0.64f, 0.943f,
0.465f, 0.457f, 0.943f,
0.891f, 0.79f, 0.943f,
0.434f, 0.46f, 0.943f,
0.88f, 0.936f, 0.943f,
0.3802f, 0.4212f, 1.21f,
0.501f, 0.6f, 1.21f,
0.354f, 0.4088f, 1.21f,
0.439f, 0.615f, 1.21f,
0.48f, 0.723f, 1.21f,
0.3359f, 0.3982f, 1.21f,
0.3765f, 0.5942f, 1.21f,
0.398f, 0.74f, 1.21f,
0.3154f, 0.384f, 1.21f,
0.3133f, 0.538f, 1.21f,
0.29f, 0.706f, 1.21f,
0.235f, 0.944f, 1.21f,
0.3006f, 0.372f, 1.21f,
0.2722f, 0.4903f, 1.21f,
0.2232f, 0.6392f, 1.21f,
0.11f, 0.883f, 1.21f,
-0.013f, 1.065f, 1.21f,
0.291f, 0.3634f, 1.21f,
0.2454f, 0.4489f, 1.21f,
0.1711f, 0.5619f, 1.21f,
0.062f, 0.6896f, 1.21f,
-0.022f, 0.776f, 1.21f,
0.2833f, 0.3564f, 1.21f,
0.229f, 0.4218f, 1.21f,
0.1468f, 0.4996f, 1.21f,
0.0559f, 0.571f, 1.21f,
-0.02f, 0.62f, 1.21f,
0.2758f, 0.3484f, 1.21f,
0.2159f, 0.3967f, 1.21f,
0.1344f, 0.4505f, 1.21f,
0.053f, 0.4943f, 1.21f,
-0.02f, 0.528f, 1.21f,
0.2689f, 0.3407f, 1.21f,
0.204f, 0.3724f, 1.21f,
0.1249f, 0.4019f, 1.21f,
0.0511f, 0.4158f, 1.21f,
-0.018f, 0.424f, 1.21f,
0.26f, 0.3289f, 1.21f,
0.1883f, 0.3406f, 1.21f,
0.1169f, 0.3452f, 1.21f,
0.0476f, 0.3458f, 1.21f,
-0.017f, 0.344f, 1.21f,
0.25f, 0.3141f, 1.21f,
0.1753f, 0.3021f, 1.21f,
0.1093f, 0.286f, 1.21f,
0.046f, 0.264f, 1.21f,
-0.014f, 0.237f, 1.21f,
0.243f, 0.3023f, 1.21f,
0.1702f, 0.2768f, 1.21f,
0.1059f, 0.2485f, 1.21f,
0.05f, 0.218f, 1.21f,
0.2362f, 0.2882f, 1.21f,
0.1658f, 0.2496f, 1.21f,
0.1074f, 0.2129f, 1.21f,
0.06f, 0.18f, 1.21f,
0.2322f, 0.2781f, 1.21f,
0.1649f, 0.2324f, 1.21f,
0.1118f, 0.1908f, 1.21f,
0.071f, 0.155f, 1.21f,
0.2291f, 0.2677f, 1.21f,
0.1667f, 0.2168f, 1.21f,
0.1212f, 0.1745f, 1.21f,
0.084f, 0.139f, 1.21f,
0.055f, 0.103f, 1.21f,
0.2291f, 0.2579f, 1.21f,
0.1716f, 0.2048f, 1.21f,
0.1303f, 0.1639f, 1.21f,
0.0968f, 0.128f, 1.21f,
0.071f, 0.097f, 1.21f,
0.2309f, 0.2491f, 1.21f,
0.1783f, 0.1974f, 1.21f,
0.1392f, 0.1563f, 1.21f,
0.1077f, 0.1218f, 1.21f,
0.084f, 0.094f, 1.21f,
0.236f, 0.242f, 1.21f,
0.1895f, 0.1911f, 1.21f,
0.1539f, 0.1491f, 1.21f,
0.1273f, 0.1157f, 1.21f,
0.106f, 0.09f, 1.21f,
0.091f, 0.068f, 1.21f,
0.078f, 0.056f, 1.21f,
0.2427f, 0.2368f, 1.21f,
0.2012f, 0.1867f, 1.21f,
0.1678f, 0.1447f, 1.21f,
0.1447f, 0.1124f, 1.21f,
0.1285f, 0.087f, 1.21f,
0.117f, 0.07f, 1.21f,
0.112f, 0.06f, 1.21f,
0.106f, 0.05f, 1.21f,
0.104f, 0.044f, 1.21f,
0.1f, 0.038f, 1.21f,
0.098f, 0.034f, 1.21f,
0.096f, 0.03f, 1.21f,
0.095f, 0.027f, 1.21f,
0.094f, 0.024f, 1.21f,
0.093f, 0.022f, 1.21f,
0.092f, 0.02f, 1.21f,
0.091f, 0.018f, 1.21f,
0.09f, 0.016f, 1.21f,
0.089f, 0.014f, 1.21f,
0.088f, 0.012f, 1.21f,
0.088f, 0.01f, 1.21f,
0.087f, 0.008f, 1.21f,
0.2547f, 0.231f, 1.21f,
0.2232f, 0.1821f, 1.21f,
0.2f, 0.1422f, 1.21f,
0.1872f, 0.1141f, 1.21f,
0.1804f, 0.095f, 1.21f,
0.1763f, 0.0804f, 1.21f,
0.1738f, 0.0688f, 1.21f,
0.172f, 0.0583f, 1.21f,
0.1709f, 0.0518f, 1.21f,
0.1701f, 0.0454f, 1.21f,
0.1696f, 0.0402f, 1.21f,
0.1691f, 0.0352f, 1.21f,
0.1689f, 0.0309f, 1.21f,
0.1686f, 0.027f, 1.21f,
0.1684f, 0.0234f, 1.21f,
0.1682f, 0.0202f, 1.21f,
0.1682f, 0.018f, 1.21f,
0.1681f, 0.016f, 1.21f,
0.168f, 0.014f, 1.21f,
0.168f, 0.012f, 1.21f,
0.168f, 0.01f, 1.21f,
0.168f, 0.008f, 1.21f,
0.168f, 0.006f, 1.21f,
0.168f, 0.004f, 1.21f,
0.2677f, 0.228f, 1.21f,
0.2459f, 0.1828f, 1.21f,
0.229f, 0.147f, 1.21f,
0.219f, 0.1228f, 1.21f,
0.212f, 0.1029f, 1.21f,
0.207f, 0.0869f, 1.21f,
0.2038f, 0.0745f, 1.21f,
0.2008f, 0.0638f, 1.21f,
0.1991f, 0.0564f, 1.21f,
0.1976f, 0.0493f, 1.21f,
0.1965f, 0.0436f, 1.21f,
0.1952f, 0.038f, 1.21f,
0.1942f, 0.0326f, 1.21f,
0.1936f, 0.0281f, 1.21f,
0.1928f, 0.024f, 1.21f,
0.193f, 0.021f, 1.21f,
0.193f, 0.019f, 1.21f,
0.193f, 0.016f, 1.21f,
0.193f, 0.014f, 1.21f,
0.193f, 0.013f, 1.21f,
0.192f, 0.011f, 1.21f,
0.192f, 0.009f, 1.21f,
0.192f, 0.007f, 1.21f,
0.192f, 0.005f, 1.21f,
0.2808f, 0.2296f, 1.21f,
0.2668f, 0.1874f, 1.21f,
0.257f, 0.1559f, 1.21f,
0.2496f, 0.1303f, 1.21f,
0.2441f, 0.1112f, 1.21f,
0.2394f, 0.094f, 1.21f,
0.2361f, 0.081f, 1.21f,
0.2331f, 0.0696f, 1.21f,
0.2312f, 0.0618f, 1.21f,
0.2295f, 0.0542f, 1.21f,
0.2279f, 0.0473f, 1.21f,
0.2266f, 0.0418f, 1.21f,
0.2251f, 0.0355f, 1.21f,
0.225f, 0.031f, 1.21f,
0.224f, 0.026f, 1.21f,
0.224f, 0.022f, 1.21f,
0.223f, 0.02f, 1.21f,
0.222f, 0.018f, 1.21f,
0.222f, 0.015f, 1.21f,
0.222f, 0.013f, 1.21f,
0.222f, 0.011f, 1.21f,
0.2936f, 0.233f, 1.21f,
0.2854f, 0.1927f, 1.21f,
0.2794f, 0.1628f, 1.21f,
0.2742f, 0.1375f, 1.21f,
0.2701f, 0.1178f, 1.21f,
0.267f, 0.1006f, 1.21f,
0.2645f, 0.0863f, 1.21f,
0.2625f, 0.0746f, 1.21f,
0.2612f, 0.0667f, 1.21f,
0.2601f, 0.0586f, 1.21f,
0.259f, 0.0509f, 1.21f,
0.258f, 0.046f, 1.21f,
0.258f, 0.039f, 1.21f,
0.257f, 0.034f, 1.21f,
0.256f, 0.028f, 1.21f,
0.256f, 0.024f, 1.21f,
0.303f, 0.2361f, 1.21f,
0.2991f, 0.1974f, 1.21f,
0.296f, 0.1682f, 1.21f,
0.2932f, 0.1429f, 1.21f,
0.2905f, 0.1229f, 1.21f,
0.2884f, 0.1059f, 1.21f,
0.2868f, 0.0903f, 1.21f,
0.2852f, 0.079f, 1.21f,
0.2841f, 0.0706f, 1.21f,
0.2831f, 0.0625f, 1.21f,
0.282f, 0.055f, 1.21f,
0.282f, 0.049f, 1.21f,
0.281f, 0.042f, 1.21f,
0.3132f, 0.2404f, 1.21f,
0.3132f, 0.2032f, 1.21f,
0.3126f, 0.1737f, 1.21f,
0.3114f, 0.1481f, 1.21f,
0.3102f, 0.1282f, 1.21f,
0.3094f, 0.111f, 1.21f,
0.3084f, 0.0952f, 1.21f,
0.3078f, 0.0839f, 1.21f,
0.3069f, 0.0748f, 1.21f,
0.307f, 0.066f, 1.21f,
0.306f, 0.058f, 1.21f,
0.305f, 0.051f, 1.21f,
0.324f, 0.2459f, 1.21f,
0.329f, 0.2095f, 1.21f,
0.3321f, 0.1811f, 1.21f,
0.3342f, 0.1551f, 1.21f,
0.3354f, 0.1351f, 1.21f,
0.3361f, 0.1181f, 1.21f,
0.3368f, 0.102f, 1.21f,
0.3368f, 0.0902f, 1.21f,
0.337f, 0.08f, 1.21f,
0.336f, 0.07f, 1.21f,
0.336f, 0.061f, 1.21f,
0.3378f, 0.2542f, 1.21f,
0.3503f, 0.2196f, 1.21f,
0.3588f, 0.192f, 1.21f,
0.366f, 0.1662f, 1.21f,
0.3727f, 0.1458f, 1.21f,
0.3772f, 0.1283f, 1.21f,
0.3811f, 0.1138f, 1.21f,
0.384f, 0.102f, 1.21f,
0.386f, 0.092f, 1.21f,
0.389f, 0.079f, 1.21f,
0.3498f, 0.2617f, 1.21f,
0.3705f, 0.23f, 1.21f,
0.3865f, 0.2036f, 1.21f,
0.4005f, 0.1793f, 1.21f,
0.4132f, 0.158f, 1.21f,
0.424f, 0.14f, 1.21f,
0.433f, 0.125f, 1.21f,
0.44f, 0.113f, 1.21f,
0.3629f, 0.271f, 1.21f,
0.392f, 0.2423f, 1.21f,
0.4151f, 0.2169f, 1.21f,
0.4357f, 0.1921f, 1.21f,
0.4521f, 0.171f, 1.21f,
0.4668f, 0.1514f, 1.21f,
0.479f, 0.136f, 1.21f,
0.488f, 0.124f, 1.21f,
0.3768f, 0.2816f, 1.21f,
0.4166f, 0.2569f, 1.21f,
0.4515f, 0.2329f, 1.21f,
0.4812f, 0.2103f, 1.21f,
0.5058f, 0.19f, 1.21f,
0.533f, 0.169f, 1.21f,
0.548f, 0.156f, 1.21f,
0.3908f, 0.2929f, 1.21f,
0.442f, 0.2728f, 1.21f,
0.4885f, 0.2515f, 1.21f,
0.5282f, 0.2297f, 1.21f,
0.5604f, 0.21f, 1.21f,
0.595f, 0.187f, 1.21f,
0.402f, 0.3034f, 1.21f,
0.466f, 0.2888f, 1.21f,
0.5235f, 0.2698f, 1.21f,
0.5722f, 0.2487f, 1.21f,
0.6111f, 0.229f, 1.21f,
0.654f, 0.204f, 1.21f,
0.4128f, 0.3154f, 1.21f,
0.4933f, 0.3068f, 1.21f,
0.5584f, 0.2921f, 1.21f,
0.6178f, 0.2713f, 1.21f,
0.6661f, 0.2499f, 1.21f,
0.711f, 0.227f, 1.21f,
0.4258f, 0.3344f, 1.21f,
0.5311f, 0.3371f, 1.21f,
0.6048f, 0.327f, 1.21f,
0.6721f, 0.3058f, 1.21f,
0.727f, 0.279f, 1.21f,
0.778f, 0.248f, 1.21f,
0.4377f, 0.358f, 1.21f,
0.566f, 0.3795f, 1.21f,
0.656f, 0.384f, 1.21f,
0.736f, 0.385f, 1.21f,
0.829f, 0.385f, 1.21f,
0.443f, 0.3775f, 1.21f,
0.585f, 0.422f, 1.21f,
0.685f, 0.442f, 1.21f,
0.4446f, 0.3982f, 1.21f,
0.591f, 0.464f, 1.21f,
0.4362f, 0.4177f, 1.21f,
0.581f, 0.505f, 1.21f,
0.423f, 0.4265f, 1.21f,
0.565f, 0.543f, 1.21f,
0.4042f, 0.4287f, 1.21f,
0.543f, 0.57f, 1.21f,
0.3556f, 0.3848f, 3.126f,
0.4188f, 0.4789f, 3.126f,
0.482f, 0.576f, 3.126f,
0.3421f, 0.3803f, 3.126f,
0.3881f, 0.4752f, 3.126f,
0.434f, 0.59f, 3.126f,
0.476f, 0.716f, 3.126f,
0.3309f, 0.3743f, 3.126f,
0.3582f, 0.465f, 3.126f,
0.3839f, 0.5748f, 3.126f,
0.409f, 0.71f, 3.126f,
0.418f, 0.825f, 3.126f,
0.3165f, 0.365f, 3.126f,
0.3248f, 0.4457f, 3.126f,
0.326f, 0.5379f, 3.126f,
0.316f, 0.6509f, 3.126f,
0.297f, 0.768f, 3.126f,
0.274f, 0.879f, 3.126f,
0.243f, 1.01f, 3.126f,
0.3069f, 0.358f, 3.126f,
0.2986f, 0.424f, 3.126f,
0.2852f, 0.4972f, 3.126f,
0.2628f, 0.5837f, 3.126f,
0.2307f, 0.6814f, 3.126f,
0.1907f, 0.7798f, 3.126f,
0.141f, 0.876f, 3.126f,
0.061f, 0.998f, 3.126f,
-0.03f, 1.11f, 3.126f,
0.2978f, 0.3507f, 3.126f,
0.2763f, 0.3998f, 3.126f,
0.2493f, 0.4522f, 3.126f,
0.2192f, 0.5042f, 3.126f,
0.1773f, 0.5698f, 3.126f,
0.1307f, 0.6308f, 3.126f,
0.082f, 0.686f, 3.126f,
0.0329f, 0.7358f, 3.126f,
-0.02f, 0.788f, 3.126f,
0.2918f, 0.345f, 3.126f,
0.264f, 0.3845f, 3.126f,
0.2318f, 0.4231f, 3.126f,
0.1979f, 0.4583f, 3.126f,
0.156f, 0.4981f, 3.126f,
0.112f, 0.5358f, 3.126f,
0.0688f, 0.5691f, 3.126f,
0.0277f, 0.5986f, 3.126f,
-0.015f, 0.625f, 3.126f,
0.2869f, 0.34f, 3.126f,
0.254f, 0.3705f, 3.126f,
0.22f, 0.3983f, 3.126f,
0.1842f, 0.4244f, 3.126f,
0.1442f, 0.4505f, 3.126f,
0.1022f, 0.4759f, 3.126f,
0.0629f, 0.4973f, 3.126f,
0.0276f, 0.5153f, 3.126f,
-0.01f, 0.532f, 3.126f,
0.282f, 0.3341f, 3.126f,
0.2442f, 0.3559f, 3.126f,
0.2092f, 0.3739f, 3.126f,
0.1705f, 0.3911f, 3.126f,
0.1321f, 0.4059f, 3.126f,
0.0934f, 0.4183f, 3.126f,
0.0599f, 0.427f, 3.126f,
0.0285f, 0.4327f, 3.126f,
-0.007f, 0.441f, 3.126f,
0.2765f, 0.3271f, 3.126f,
0.2343f, 0.3378f, 3.126f,
0.1971f, 0.3452f, 3.126f,
0.1557f, 0.3517f, 3.126f,
0.119f, 0.3551f, 3.126f,
0.0851f, 0.3576f, 3.126f,
0.0555f, 0.3588f, 3.126f,
0.029f, 0.359f, 3.126f,
-0.002f, 0.36f, 3.126f,
0.2697f, 0.3175f, 3.126f,
0.2234f, 0.315f, 3.126f,
0.1843f, 0.311f, 3.126f,
0.1405f, 0.3037f, 3.126f,
0.105f, 0.2956f, 3.126f,
0.0769f, 0.288f, 3.126f,
0.051f, 0.28f, 3.126f,
0.028f, 0.274f, 3.126f,
0.2651f, 0.3098f, 3.126f,
0.2162f, 0.2981f, 3.126f,
0.1747f, 0.2853f, 3.126f,
0.1325f, 0.271f, 3.126f,
0.0991f, 0.2582f, 3.126f,
0.0724f, 0.2478f, 3.126f,
0.05f, 0.237f, 3.126f,
0.028f, 0.228f, 3.126f,
0.2606f, 0.301f, 3.126f,
0.2096f, 0.279f, 3.126f,
0.1669f, 0.257f, 3.126f,
0.1258f, 0.2331f, 3.126f,
0.0929f, 0.2133f, 3.126f,
0.068f, 0.194f, 3.126f,
0.05f, 0.181f, 3.126f,
0.2578f, 0.294f, 3.126f,
0.206f, 0.2649f, 3.126f,
0.1621f, 0.2358f, 3.126f,
0.123f, 0.2076f, 3.126f,
0.0911f, 0.1828f, 3.126f,
0.067f, 0.165f, 3.126f,
0.2559f, 0.2874f, 3.126f,
0.2048f, 0.2518f, 3.126f,
0.1617f, 0.2162f, 3.126f,
0.1245f, 0.1827f, 3.126f,
0.0965f, 0.1558f, 3.126f,
0.077f, 0.136f, 3.126f,
0.2545f, 0.2799f, 3.126f,
0.2063f, 0.24f, 3.126f,
0.1658f, 0.2026f, 3.126f,
0.1313f, 0.1692f, 3.126f,
0.1051f, 0.1422f, 3.126f,
0.088f, 0.124f, 3.126f,
0.07f, 0.106f, 3.126f,
0.2558f, 0.2725f, 3.126f,
0.2102f, 0.2313f, 3.126f,
0.1716f, 0.1937f, 3.126f,
0.1396f, 0.1603f, 3.126f,
0.1157f, 0.1346f, 3.126f,
0.099f, 0.115f, 3.126f,
0.083f, 0.097f, 3.126f,
0.2592f, 0.2675f, 3.126f,
0.2175f, 0.2245f, 3.126f,
0.1825f, 0.1857f, 3.126f,
0.154f, 0.153f, 3.126f,
0.1332f, 0.1278f, 3.126f,
0.1166f, 0.1076f, 3.126f,
0.102f, 0.089f, 3.126f,
0.092f, 0.076f, 3.126f,
0.084f, 0.064f, 3.126f,
0.2638f, 0.2624f, 3.126f,
0.2263f, 0.2192f, 3.126f,
0.1942f, 0.1811f, 3.126f,
0.1685f, 0.1491f, 3.126f,
0.15f, 0.124f, 3.126f,
0.1363f, 0.1048f, 3.126f,
0.1253f, 0.0873f, 3.126f,
0.117f, 0.074f, 3.126f,
0.111f, 0.064f, 3.126f,
0.108f, 0.058f, 3.126f,
0.104f, 0.052f, 3.126f,
0.1f, 0.046f, 3.126f,
0.098f, 0.042f, 3.126f,
0.097f, 0.04f, 3.126f,
0.096f, 0.038f, 3.126f,
0.095f, 0.036f, 3.126f,
0.093f, 0.033f, 3.126f,
0.092f, 0.031f, 3.126f,
0.09f, 0.028f, 3.126f,
0.089f, 0.025f, 3.126f,
0.087f, 0.022f, 3.126f,
0.086f, 0.019f, 3.126f,
0.084f, 0.016f, 3.126f,
0.2712f, 0.2582f, 3.126f,
0.242f, 0.2148f, 3.126f,
0.2189f, 0.179f, 3.126f,
0.2005f, 0.1495f, 3.126f,
0.1882f, 0.1258f, 3.126f,
0.1813f, 0.1094f, 3.126f,
0.1762f, 0.0955f, 3.126f,
0.1728f, 0.0839f, 3.126f,
0.1701f, 0.0742f, 3.126f,
0.1685f, 0.0666f, 3.126f,
0.167f, 0.0594f, 3.126f,
0.166f, 0.0538f, 3.126f,
0.1653f, 0.0492f, 3.126f,
0.1647f, 0.0451f, 3.126f,
0.164f, 0.0409f, 3.126f,
0.1635f, 0.0373f, 3.126f,
0.163f, 0.034f, 3.126f,
0.1628f, 0.031f, 3.126f,
0.1623f, 0.028f, 3.126f,
0.162f, 0.025f, 3.126f,
0.162f, 0.022f, 3.126f,
0.162f, 0.019f, 3.126f,
0.161f, 0.016f, 3.126f,
0.161f, 0.013f, 3.126f,
0.16f, 0.01f, 3.126f,
0.2803f, 0.2567f, 3.126f,
0.26f, 0.2162f, 3.126f,
0.244f, 0.184f, 3.126f,
0.2294f, 0.1551f, 3.126f,
0.22f, 0.133f, 3.126f,
0.2139f, 0.117f, 3.126f,
0.2087f, 0.1026f, 3.126f,
0.2052f, 0.091f, 3.126f,
0.2021f, 0.0808f, 3.126f,
0.1998f, 0.0718f, 3.126f,
0.1978f, 0.0643f, 3.126f,
0.1962f, 0.0578f, 3.126f,
0.1949f, 0.052f, 3.126f,
0.1937f, 0.0471f, 3.126f,
0.1925f, 0.042f, 3.126f,
0.1918f, 0.0379f, 3.126f,
0.1911f, 0.0344f, 3.126f,
0.19f, 0.031f, 3.126f,
0.19f, 0.028f, 3.126f,
0.19f, 0.025f, 3.126f,
0.189f, 0.022f, 3.126f,
0.189f, 0.019f, 3.126f,
0.189f, 0.016f, 3.126f,
0.188f, 0.013f, 3.126f,
0.188f, 0.01f, 3.126f,
0.2892f, 0.2583f, 3.126f,
0.2758f, 0.2208f, 3.126f,
0.2661f, 0.1921f, 3.126f,
0.257f, 0.1635f, 3.126f,
0.2501f, 0.1422f, 3.126f,
0.2449f, 0.1245f, 3.126f,
0.2406f, 0.11f, 3.126f,
0.2372f, 0.098f, 3.126f,
0.2345f, 0.0873f, 3.126f,
0.232f, 0.0779f, 3.126f,
0.2298f, 0.0696f, 3.126f,
0.2277f, 0.0621f, 3.126f,
0.226f, 0.0555f, 3.126f,
0.2245f, 0.0491f, 3.126f,
0.2231f, 0.0432f, 3.126f,
0.222f, 0.038f, 3.126f,
0.221f, 0.035f, 3.126f,
0.22f, 0.031f, 3.126f,
0.219f, 0.028f, 3.126f,
0.219f, 0.025f, 3.126f,
0.218f, 0.022f, 3.126f,
0.217f, 0.019f, 3.126f,
0.2984f, 0.2612f, 3.126f,
0.2908f, 0.2261f, 3.126f,
0.285f, 0.1992f, 3.126f,
0.2791f, 0.1707f, 3.126f,
0.2748f, 0.15f, 3.126f,
0.2709f, 0.132f, 3.126f,
0.2676f, 0.1163f, 3.126f,
0.2652f, 0.1045f, 3.126f,
0.2632f, 0.0935f, 3.126f,
0.2612f, 0.0838f, 3.126f,
0.2597f, 0.075f, 3.126f,
0.2582f, 0.0669f, 3.126f,
0.2569f, 0.0594f, 3.126f,
0.2559f, 0.0525f, 3.126f,
0.255f, 0.045f, 3.126f,
0.254f, 0.039f, 3.126f,
0.253f, 0.035f, 3.126f,
0.252f, 0.031f, 3.126f,
0.3071f, 0.2647f, 3.126f,
0.3048f, 0.2321f, 3.126f,
0.3025f, 0.2058f, 3.126f,
0.3f, 0.1781f, 3.126f,
0.2979f, 0.1569f, 3.126f,
0.2956f, 0.1392f, 3.126f,
0.2938f, 0.1235f, 3.126f,
0.2922f, 0.1106f, 3.126f,
0.2912f, 0.0995f, 3.126f,
0.2902f, 0.0901f, 3.126f,
0.289f, 0.0799f, 3.126f,
0.2882f, 0.0719f, 3.126f,
0.287f, 0.064f, 3.126f,
0.286f, 0.055f, 3.126f,
0.284f, 0.046f, 3.126f,
0.3161f, 0.2691f, 3.126f,
0.3189f, 0.239f, 3.126f,
0.3207f, 0.2132f, 3.126f,
0.3219f, 0.1862f, 3.126f,
0.323f, 0.1659f, 3.126f,
0.3233f, 0.1477f, 3.126f,
0.3235f, 0.1317f, 3.126f,
0.3235f, 0.1181f, 3.126f,
0.3233f, 0.1063f, 3.126f,
0.3231f, 0.0962f, 3.126f,
0.323f, 0.0861f, 3.126f,
0.322f, 0.076f, 3.126f,
0.322f, 0.068f, 3.126f,
0.322f, 0.058f, 3.126f,
0.3279f, 0.2754f, 3.126f,
0.3382f, 0.2496f, 3.126f,
0.347f, 0.2259f, 3.126f,
0.3555f, 0.2003f, 3.126f,
0.3617f, 0.18f, 3.126f,
0.3668f, 0.1618f, 3.126f,
0.3711f, 0.1449f, 3.126f,
0.3748f, 0.131f, 3.126f,
0.3778f, 0.1188f, 3.126f,
0.3802f, 0.108f, 3.126f,
0.383f, 0.096f, 3.126f,
0.386f, 0.086f, 3.126f,
0.388f, 0.076f, 3.126f,
0.3383f, 0.2829f, 3.126f,
0.3558f, 0.2597f, 3.126f,
0.3708f, 0.238f, 3.126f,
0.3858f, 0.214f, 3.126f,
0.3971f, 0.1939f, 3.126f,
0.408f, 0.1764f, 3.126f,
0.418f, 0.1598f, 3.126f,
0.4269f, 0.1454f, 3.126f,
0.4338f, 0.134f, 3.126f,
0.442f, 0.121f, 3.126f,
0.448f, 0.11f, 3.126f,
0.3459f, 0.2892f, 3.126f,
0.3702f, 0.2683f, 3.126f,
0.3918f, 0.249f, 3.126f,
0.4137f, 0.2276f, 3.126f,
0.4321f, 0.2082f, 3.126f,
0.4481f, 0.1903f, 3.126f,
0.4624f, 0.1737f, 3.126f,
0.4744f, 0.1595f, 3.126f,
0.485f, 0.146f, 3.126f,
0.497f, 0.132f, 3.126f,
0.3532f, 0.2957f, 3.126f,
0.385f, 0.2778f, 3.126f,
0.4139f, 0.2608f, 3.126f,
0.4428f, 0.2419f, 3.126f,
0.4678f, 0.2237f, 3.126f,
0.4911f, 0.206f, 3.126f,
0.5129f, 0.1888f, 3.126f,
0.531f, 0.174f, 3.126f,
0.546f, 0.161f, 3.126f,
0.3614f, 0.3033f, 3.126f,
0.4021f, 0.29f, 3.126f,
0.439f, 0.276f, 3.126f,
0.4776f, 0.2593f, 3.126f,
0.5122f, 0.2428f, 3.126f,
0.5438f, 0.2254f, 3.126f,
0.5734f, 0.2083f, 3.126f,
0.601f, 0.192f, 3.126f,
0.3692f, 0.3111f, 3.126f,
0.4184f, 0.3032f, 3.126f,
0.4642f, 0.2934f, 3.126f,
0.5143f, 0.28f, 3.126f,
0.5557f, 0.2633f, 3.126f,
0.593f, 0.2465f, 3.126f,
0.6302f, 0.2287f, 3.126f,
0.659f, 0.212f, 3.126f,
0.3751f, 0.3181f, 3.126f,
0.4335f, 0.3169f, 3.126f,
0.4875f, 0.3123f, 3.126f,
0.5433f, 0.3027f, 3.126f,
0.5952f, 0.2874f, 3.126f,
0.6392f, 0.2704f, 3.126f,
0.6791f, 0.252f, 3.126f,
0.714f, 0.234f, 3.126f,
0.3811f, 0.3274f, 3.126f,
0.4481f, 0.333f, 3.126f,
0.5095f, 0.3331f, 3.126f,
0.5713f, 0.3259f, 3.126f,
0.6247f, 0.312f, 3.126f,
0.6732f, 0.2937f, 3.126f,
0.7165f, 0.2734f, 3.126f,
0.752f, 0.254f, 3.126f,
0.3852f, 0.3365f, 3.126f,
0.4598f, 0.3508f, 3.126f,
0.528f, 0.3581f, 3.126f,
0.5995f, 0.359f, 3.126f,
0.659f, 0.35f, 3.126f,
0.718f, 0.34f, 3.126f,
0.779f, 0.323f, 3.126f,
0.824f, 0.309f, 3.126f,
0.388f, 0.3476f, 3.126f,
0.4674f, 0.3738f, 3.126f,
0.5426f, 0.3925f, 3.126f,
0.62f, 0.406f, 3.126f,
0.684f, 0.415f, 3.126f,
0.3889f, 0.359f, 3.126f,
0.469f, 0.3964f, 3.126f,
0.5475f, 0.4271f, 3.126f,
0.62f, 0.456f, 3.126f,
0.3872f, 0.3688f, 3.126f,
0.4676f, 0.4168f, 3.126f,
0.545f, 0.458f, 3.126f,
0.612f, 0.493f, 3.126f,
0.3825f, 0.3785f, 3.126f,
0.4627f, 0.4392f, 3.126f,
0.538f, 0.486f, 3.126f,
0.604f, 0.526f, 3.126f,
0.3757f, 0.3839f, 3.126f,
0.4543f, 0.4573f, 3.126f,
0.526f, 0.519f, 3.126f,
0.366f, 0.3858f, 3.126f,
0.4401f, 0.4723f, 3.126f,
0.51f, 0.547f, 3.126f,
0.3513f, 0.3789f, 6.55f,
0.3961f, 0.4452f, 6.55f,
0.4345f, 0.5026f, 6.55f,
0.47f, 0.555f, 6.55f,
0.3412f, 0.3768f, 6.55f,
0.3772f, 0.4484f, 6.55f,
0.4069f, 0.511f, 6.55f,
0.432f, 0.576f, 6.55f,
0.455f, 0.638f, 6.55f,
0.3319f, 0.3729f, 6.55f,
0.3554f, 0.4429f, 6.55f,
0.375f, 0.5109f, 6.55f,
0.3924f, 0.5832f, 6.55f,
0.404f, 0.65f, 6.55f,
0.413f, 0.718f, 6.55f,
0.318f, 0.3644f, 6.55f,
0.327f, 0.4288f, 6.55f,
0.3333f, 0.4967f, 6.55f,
0.3341f, 0.57f, 6.55f,
0.3266f, 0.6448f, 6.55f,
0.315f, 0.72f, 6.55f,
0.3f, 0.793f, 6.55f,
0.3088f, 0.3578f, 6.55f,
0.3053f, 0.4123f, 6.55f,
0.2992f, 0.4717f, 6.55f,
0.2887f, 0.5361f, 6.55f,
0.2724f, 0.6026f, 6.55f,
0.2531f, 0.67f, 6.55f,
0.2283f, 0.7423f, 6.55f,
0.202f, 0.807f, 6.55f,
0.168f, 0.88f, 6.55f,
0.13f, 0.948f, 6.55f,
0.089f, 1.014f, 6.55f,
0.046f, 1.078f, 6.55f,
0.2999f, 0.35f, 6.55f,
0.2836f, 0.3915f, 6.55f,
0.2642f, 0.4342f, 6.55f,
0.2435f, 0.4752f, 6.55f,
0.217f, 0.5211f, 6.55f,
0.1902f, 0.5642f, 6.55f,
0.1626f, 0.6052f, 6.55f,
0.1341f, 0.642f, 6.55f,
0.1049f, 0.6766f, 6.55f,
0.072f, 0.7127f, 6.55f,
0.039f, 0.7468f, 6.55f,
0.009f, 0.776f, 6.55f,
0.2935f, 0.3439f, 6.55f,
0.2711f, 0.378f, 6.55f,
0.2471f, 0.41f, 6.55f,
0.2228f, 0.438f, 6.55f,
0.1935f, 0.4682f, 6.55f,
0.166f, 0.4948f, 6.55f,
0.1382f, 0.5197f, 6.55f,
0.112f, 0.5414f, 6.55f,
0.0882f, 0.5605f, 6.55f,
0.062f, 0.5802f, 6.55f,
0.034f, 0.6011f, 6.55f,
0.004f, 0.622f, 6.55f,
0.289f, 0.3391f, 6.55f,
0.2618f, 0.3667f, 6.55f,
0.2346f, 0.3901f, 6.55f,
0.2088f, 0.4101f, 6.55f,
0.18f, 0.431f, 6.55f,
0.1516f, 0.4505f, 6.55f,
0.1262f, 0.4667f, 6.55f,
0.1023f, 0.4818f, 6.55f,
0.0798f, 0.4954f, 6.55f,
0.0568f, 0.5082f, 6.55f,
0.0332f, 0.5206f, 6.55f,
0.006f, 0.534f, 6.55f,
0.2844f, 0.3337f, 6.55f,
0.2525f, 0.3537f, 6.55f,
0.224f, 0.3699f, 6.55f,
0.197f, 0.3841f, 6.55f,
0.1688f, 0.3974f, 6.55f,
0.1411f, 0.4095f, 6.55f,
0.1161f, 0.4192f, 6.55f,
0.0925f, 0.4275f, 6.55f,
0.0718f, 0.434f, 6.55f,
0.0528f, 0.4393f, 6.55f,
0.0333f, 0.4444f, 6.55f,
0.009f, 0.45f, 6.55f,
0.2799f, 0.3271f, 6.55f,
0.2437f, 0.3386f, 6.55f,
0.2132f, 0.3468f, 6.55f,
0.1845f, 0.3531f, 6.55f,
0.1552f, 0.358f, 6.55f,
0.1288f, 0.362f, 6.55f,
0.1051f, 0.3648f, 6.55f,
0.0843f, 0.3667f, 6.55f,
0.0648f, 0.3682f, 6.55f,
0.0482f, 0.3695f, 6.55f,
0.032f, 0.37f, 6.55f,
0.012f, 0.371f, 6.55f,
0.2742f, 0.3192f, 6.55f,
0.2343f, 0.32f, 6.55f,
0.202f, 0.3188f, 6.55f,
0.1703f, 0.3159f, 6.55f,
0.141f, 0.3118f, 6.55f,
0.1158f, 0.3071f, 6.55f,
0.094f, 0.3027f, 6.55f,
0.0735f, 0.2979f, 6.55f,
0.058f, 0.294f, 6.55f,
0.043f, 0.291f, 6.55f,
0.028f, 0.286f, 6.55f,
0.2699f, 0.312f, 6.55f,
0.2272f, 0.3041f, 6.55f,
0.1928f, 0.2958f, 6.55f,
0.162f, 0.2872f, 6.55f,
0.1326f, 0.2784f, 6.55f,
0.1086f, 0.2706f, 6.55f,
0.0874f, 0.2627f, 6.55f,
0.0691f, 0.2559f, 6.55f,
0.053f, 0.249f, 6.55f,
0.039f, 0.242f, 6.55f,
0.266f, 0.305f, 6.55f,
0.2221f, 0.2886f, 6.55f,
0.1861f, 0.2722f, 6.55f,
0.1551f, 0.2571f, 6.55f,
0.125f, 0.2411f, 6.55f,
0.1018f, 0.2281f, 6.55f,
0.0798f, 0.2151f, 6.55f,
0.065f, 0.206f, 6.55f,
0.053f, 0.199f, 6.55f,
0.2636f, 0.2983f, 6.55f,
0.2183f, 0.2748f, 6.55f,
0.1826f, 0.2536f, 6.55f,
0.1511f, 0.2331f, 6.55f,
0.122f, 0.2132f, 6.55f,
0.0989f, 0.1963f, 6.55f,
0.08f, 0.18f, 6.55f,
0.065f, 0.17f, 6.55f,
0.2617f, 0.2921f, 6.55f,
0.2176f, 0.2632f, 6.55f,
0.1835f, 0.2375f, 6.55f,
0.1527f, 0.2119f, 6.55f,
0.1259f, 0.1879f, 6.55f,
0.1042f, 0.1681f, 6.55f,
0.086f, 0.15f, 6.55f,
0.071f, 0.137f, 6.55f,
0.2616f, 0.2857f, 6.55f,
0.22f, 0.2536f, 6.55f,
0.1875f, 0.2258f, 6.55f,
0.1583f, 0.1987f, 6.55f,
0.1343f, 0.1756f, 6.55f,
0.1131f, 0.1542f, 6.55f,
0.095f, 0.136f, 6.55f,
0.083f, 0.123f, 6.55f,
0.2631f, 0.2801f, 6.55f,
0.2246f, 0.2467f, 6.55f,
0.1933f, 0.2173f, 6.55f,
0.1658f, 0.1905f, 6.55f,
0.1432f, 0.1675f, 6.55f,
0.1228f, 0.146f, 6.55f,
0.1065f, 0.1285f, 6.55f,
0.095f, 0.115f, 6.55f,
0.084f, 0.1f, 6.55f,
0.2663f, 0.2756f, 6.55f,
0.2312f, 0.2405f, 6.55f,
0.2022f, 0.2101f, 6.55f,
0.178f, 0.1833f, 6.55f,
0.1576f, 0.16f, 6.55f,
0.1398f, 0.1395f, 6.55f,
0.1251f, 0.1218f, 6.55f,
0.113f, 0.107f, 6.55f,
0.102f, 0.093f, 6.55f,
0.095f, 0.083f, 6.55f,
0.088f, 0.073f, 6.55f,
0.2708f, 0.2719f, 6.55f,
0.2393f, 0.2361f, 6.55f,
0.2122f, 0.2052f, 6.55f,
0.1908f, 0.1799f, 6.55f,
0.1718f, 0.1562f, 6.55f,
0.1557f, 0.1356f, 6.55f,
0.1431f, 0.1184f, 6.55f,
0.1318f, 0.1024f, 6.55f,
0.1228f, 0.0895f, 6.55f,
0.117f, 0.08f, 6.55f,
0.112f, 0.072f, 6.55f,
0.107f, 0.064f, 6.55f,
0.104f, 0.059f, 6.55f,
0.102f, 0.054f, 6.55f,
0.099f, 0.05f, 6.55f,
0.097f, 0.045f, 6.55f,
0.095f, 0.042f, 6.55f,
0.094f, 0.04f, 6.55f,
0.092f, 0.037f, 6.55f,
0.091f, 0.034f, 6.55f,
0.09f, 0.032f, 6.55f,
0.089f, 0.03f, 6.55f,
0.088f, 0.028f, 6.55f,
0.087f, 0.025f, 6.55f,
0.086f, 0.022f, 6.55f,
0.2777f, 0.2687f, 6.55f,
0.252f, 0.2319f, 6.55f,
0.2311f, 0.201f, 6.55f,
0.2149f, 0.1761f, 6.55f,
0.2005f, 0.1536f, 6.55f,
0.1903f, 0.1353f, 6.55f,
0.1824f, 0.1188f, 6.55f,
0.1765f, 0.1048f, 6.55f,
0.173f, 0.0948f, 6.55f,
0.1702f, 0.0867f, 6.55f,
0.1677f, 0.0782f, 6.55f,
0.1658f, 0.0711f, 6.55f,
0.1642f, 0.0655f, 6.55f,
0.1632f, 0.0609f, 6.55f,
0.1621f, 0.0556f, 6.55f,
0.1612f, 0.0511f, 6.55f,
0.1608f, 0.048f, 6.55f,
0.159f, 0.044f, 6.55f,
0.158f, 0.04f, 6.55f,
0.158f, 0.037f, 6.55f,
0.157f, 0.034f, 6.55f,
0.157f, 0.031f, 6.55f,
0.157f, 0.028f, 6.55f,
0.156f, 0.025f, 6.55f,
0.156f, 0.022f, 6.55f,
0.2847f, 0.267f, 6.55f,
0.266f, 0.2319f, 6.55f,
0.2511f, 0.2031f, 6.55f,
0.2387f, 0.1786f, 6.55f,
0.2278f, 0.1565f, 6.55f,
0.2206f, 0.1407f, 6.55f,
0.2142f, 0.125f, 6.55f,
0.2092f, 0.1118f, 6.55f,
0.206f, 0.102f, 6.55f,
0.203f, 0.093f, 6.55f,
0.2004f, 0.0847f, 6.55f,
0.1982f, 0.0772f, 6.55f,
0.1963f, 0.0708f, 6.55f,
0.195f, 0.065f, 6.55f,
0.1938f, 0.0599f, 6.55f,
0.1926f, 0.0542f, 6.55f,
0.1918f, 0.0503f, 6.55f,
0.19f, 0.046f, 6.55f,
0.19f, 0.042f, 6.55f,
0.189f, 0.038f, 6.55f,
0.189f, 0.034f, 6.55f,
0.188f, 0.031f, 6.55f,
0.188f, 0.028f, 6.55f,
0.188f, 0.025f, 6.55f,
0.188f, 0.022f, 6.55f,
0.2922f, 0.268f, 6.55f,
0.2792f, 0.2342f, 6.55f,
0.2691f, 0.2072f, 6.55f,
0.2615f, 0.1845f, 6.55f,
0.2548f, 0.1638f, 6.55f,
0.2498f, 0.148f, 6.55f,
0.2449f, 0.1325f, 6.55f,
0.241f, 0.1198f, 6.55f,
0.238f, 0.1094f, 6.55f,
0.2354f, 0.1003f, 6.55f,
0.2329f, 0.0911f, 6.55f,
0.2305f, 0.0832f, 6.55f,
0.2286f, 0.0765f, 6.55f,
0.2268f, 0.0698f, 6.55f,
0.2252f, 0.0638f, 6.55f,
0.2242f, 0.0587f, 6.55f,
0.223f, 0.0543f, 6.55f,
0.222f, 0.048f, 6.55f,
0.221f, 0.044f, 6.55f,
0.22f, 0.04f, 6.55f,
0.22f, 0.035f, 6.55f,
0.219f, 0.032f, 6.55f,
0.218f, 0.028f, 6.55f,
0.2997f, 0.27f, 6.55f,
0.2928f, 0.2386f, 6.55f,
0.287f, 0.2135f, 6.55f,
0.2819f, 0.191f, 6.55f,
0.2772f, 0.1707f, 6.55f,
0.2739f, 0.1539f, 6.55f,
0.2707f, 0.1397f, 6.55f,
0.268f, 0.1272f, 6.55f,
0.2657f, 0.1163f, 6.55f,
0.2639f, 0.1074f, 6.55f,
0.262f, 0.0978f, 6.55f,
0.2602f, 0.0891f, 6.55f,
0.259f, 0.0822f, 6.55f,
0.2579f, 0.075f, 6.55f,
0.2568f, 0.069f, 6.55f,
0.2557f, 0.063f, 6.55f,
0.255f, 0.056f, 6.55f,
0.254f, 0.051f, 6.55f,
0.253f, 0.046f, 6.55f,
0.252f, 0.041f, 6.55f,
0.251f, 0.036f, 6.55f,
0.3088f, 0.274f, 6.55f,
0.3072f, 0.2448f, 6.55f,
0.3057f, 0.2208f, 6.55f,
0.3037f, 0.1981f, 6.55f,
0.302f, 0.1794f, 6.55f,
0.3003f, 0.1618f, 6.55f,
0.2992f, 0.1475f, 6.55f,
0.2981f, 0.1356f, 6.55f,
0.2969f, 0.1239f, 6.55f,
0.2961f, 0.1151f, 6.55f,
0.2953f, 0.1057f, 6.55f,
0.2944f, 0.0967f, 6.55f,
0.2938f, 0.0892f, 6.55f,
0.293f, 0.0812f, 6.55f,
0.2922f, 0.075f, 6.55f,
0.292f, 0.067f, 6.55f,
0.291f, 0.06f, 6.55f,
0.29f, 0.054f, 6.55f,
0.289f, 0.048f, 6.55f,
0.317f, 0.279f, 6.55f,
0.3214f, 0.2517f, 6.55f,
0.3243f, 0.2293f, 6.55f,
0.3269f, 0.2075f, 6.55f,
0.3286f, 0.1889f, 6.55f,
0.3301f, 0.1715f, 6.55f,
0.3309f, 0.1572f, 6.55f,
0.332f, 0.1456f, 6.55f,
0.3329f, 0.1332f, 6.55f,
0.3332f, 0.124f, 6.55f,
0.334f, 0.1146f, 6.55f,
0.3341f, 0.1055f, 6.55f,
0.3343f, 0.0978f, 6.55f,
0.335f, 0.088f, 6.55f,
0.335f, 0.081f, 6.55f,
0.335f, 0.072f, 6.55f,
0.335f, 0.063f, 6.55f,
0.3272f, 0.2861f, 6.55f,
0.34f, 0.2624f, 6.55f,
0.3501f, 0.2425f, 6.55f,
0.3598f, 0.2233f, 6.55f,
0.3681f, 0.2054f, 6.55f,
0.3754f, 0.1898f, 6.55f,
0.3818f, 0.1758f, 6.55f,
0.3876f, 0.1629f, 6.55f,
0.3929f, 0.1506f, 6.55f,
0.3969f, 0.1413f, 6.55f,
0.4018f, 0.1304f, 6.55f,
0.405f, 0.122f, 6.55f,
0.408f, 0.114f, 6.55f,
0.414f, 0.102f, 6.55f,
0.417f, 0.094f, 6.55f,
0.337f, 0.294f, 6.55f,
0.3586f, 0.2742f, 6.55f,
0.3765f, 0.2569f, 6.55f,
0.393f, 0.2395f, 6.55f,
0.4073f, 0.2235f, 6.55f,
0.4199f, 0.2089f, 6.55f,
0.4313f, 0.1944f, 6.55f,
0.4418f, 0.1809f, 6.55f,
0.4503f, 0.1695f, 6.55f,
0.4577f, 0.1593f, 6.55f,
0.467f, 0.145f, 6.55f,
0.472f, 0.136f, 6.55f,
0.479f, 0.127f, 6.55f,
0.345f, 0.3001f, 6.55f,
0.3739f, 0.2851f, 6.55f,
0.399f, 0.2708f, 6.55f,
0.4234f, 0.2556f, 6.55f,
0.4445f, 0.2419f, 6.55f,
0.4654f, 0.2273f, 6.55f,
0.4831f, 0.214f, 6.55f,
0.4991f, 0.2011f, 6.55f,
0.513f, 0.1893f, 6.55f,
0.528f, 0.178f, 6.55f,
0.542f, 0.165f, 6.55f,
0.3526f, 0.3068f, 6.55f,
0.3889f, 0.2969f, 6.55f,
0.4218f, 0.2864f, 6.55f,
0.4552f, 0.2741f, 6.55f,
0.4851f, 0.2618f, 6.55f,
0.5139f, 0.2489f, 6.55f,
0.538f, 0.2369f, 6.55f,
0.5628f, 0.2241f, 6.55f,
0.584f, 0.212f, 6.55f,
0.602f, 0.2f, 6.55f,
0.3591f, 0.313f, 6.55f,
0.4021f, 0.3076f, 6.55f,
0.4409f, 0.3009f, 6.55f,
0.4821f, 0.2918f, 6.55f,
0.5191f, 0.2811f, 6.55f,
0.5536f, 0.2691f, 6.55f,
0.5828f, 0.2579f, 6.55f,
0.6116f, 0.2456f, 6.55f,
0.64f, 0.232f, 6.55f,
0.667f, 0.217f, 6.55f,
0.3645f, 0.319f, 6.55f,
0.4148f, 0.319f, 6.55f,
0.4592f, 0.3168f, 6.55f,
0.5064f, 0.3114f, 6.55f,
0.55f, 0.3024f, 6.55f,
0.5884f, 0.2904f, 6.55f,
0.6204f, 0.2789f, 6.55f,
0.652f, 0.266f, 6.55f,
0.682f, 0.251f, 6.55f,
0.71f, 0.234f, 6.55f,
0.369f, 0.3248f, 6.55f,
0.424f, 0.3302f, 6.55f,
0.4738f, 0.3316f, 6.55f,
0.5251f, 0.3297f, 6.55f,
0.573f, 0.324f, 6.55f,
0.6158f, 0.3129f, 6.55f,
0.6492f, 0.3012f, 6.55f,
0.6817f, 0.2872f, 6.55f,
0.714f, 0.271f, 6.55f,
0.747f, 0.251f, 6.55f,
0.3728f, 0.3314f, 6.55f,
0.4308f, 0.3412f, 6.55f,
0.4854f, 0.3467f, 6.55f,
0.5393f, 0.3477f, 6.55f,
0.5871f, 0.344f, 6.55f,
0.6322f, 0.3361f, 6.55f,
0.6703f, 0.3249f, 6.55f,
0.703f, 0.314f, 6.55f,
0.739f, 0.302f, 6.55f,
0.778f, 0.286f, 6.55f,
0.3757f, 0.3391f, 6.55f,
0.436f, 0.3563f, 6.55f,
0.4954f, 0.3692f, 6.55f,
0.5475f, 0.3771f, 6.55f,
0.5941f, 0.3818f, 6.55f,
0.637f, 0.381f, 6.55f,
0.674f, 0.379f, 6.55f,
0.708f, 0.374f, 6.55f,
0.3771f, 0.3476f, 6.55f,
0.4376f, 0.3715f, 6.55f,
0.4966f, 0.3908f, 6.55f,
0.5456f, 0.404f, 6.55f,
0.59f, 0.414f, 6.55f,
0.629f, 0.423f, 6.55f,
0.3771f, 0.3549f, 6.55f,
0.4378f, 0.3865f, 6.55f,
0.493f, 0.4116f, 6.55f,
0.539f, 0.4306f, 6.55f,
0.581f, 0.448f, 6.55f,
0.3747f, 0.363f, 6.55f,
0.4341f, 0.4018f, 6.55f,
0.4872f, 0.4326f, 6.55f,
0.5305f, 0.4559f, 6.55f,
0.572f, 0.475f, 6.55f,
0.3703f, 0.37f, 6.55f,
0.4277f, 0.4166f, 6.55f,
0.4784f, 0.4531f, 6.55f,
0.521f, 0.482f, 6.55f,
0.56f, 0.505f, 6.55f,
0.3646f, 0.3748f, 6.55f,
0.4191f, 0.4283f, 6.55f,
0.467f, 0.4711f, 6.55f,
0.509f, 0.509f, 6.55f,
0.3589f, 0.3778f, 6.55f,
0.4086f, 0.4379f, 6.55f,
0.4526f, 0.4889f, 6.55f,
0.492f, 0.535f, 6.55f,
0.3476f, 0.3732f, 12.0f,
0.3871f, 0.4321f, 12.0f,
0.419f, 0.4795f, 12.0f,
0.443f, 0.5153f, 12.0f,
0.462f, 0.543f, 12.0f,
0.473f, 0.562f, 12.0f,
0.3382f, 0.3706f, 12.0f,
0.3708f, 0.4329f, 12.0f,
0.3968f, 0.4857f, 12.0f,
0.4174f, 0.53f, 12.0f,
0.433f, 0.568f, 12.0f,
0.443f, 0.594f, 12.0f,
0.3312f, 0.3678f, 12.0f,
0.3538f, 0.4284f, 12.0f,
0.3718f, 0.4852f, 12.0f,
0.3868f, 0.5384f, 12.0f,
0.3983f, 0.585f, 12.0f,
0.407f, 0.619f, 12.0f,
0.415f, 0.659f, 12.0f,
0.3185f, 0.3604f, 12.0f,
0.3281f, 0.4157f, 12.0f,
0.3355f, 0.4739f, 12.0f,
0.34f, 0.5348f, 12.0f,
0.3395f, 0.5913f, 12.0f,
0.3348f, 0.6468f, 12.0f,
0.327f, 0.698f, 12.0f,
0.315f, 0.757f, 12.0f,
0.303f, 0.809f, 12.0f,
0.3109f, 0.355f, 12.0f,
0.31f, 0.4018f, 12.0f,
0.3069f, 0.455f, 12.0f,
0.3008f, 0.5095f, 12.0f,
0.2908f, 0.5672f, 12.0f,
0.2758f, 0.6282f, 12.0f,
0.259f, 0.6858f, 12.0f,
0.2422f, 0.736f, 12.0f,
0.221f, 0.793f, 12.0f,
0.192f, 0.86f, 12.0f,
0.165f, 0.917f, 12.0f,
0.142f, 0.964f, 12.0f,
0.106f, 1.028f, 12.0f,
0.058f, 1.1f, 12.0f,
0.3012f, 0.347f, 12.0f,
0.2891f, 0.3821f, 12.0f,
0.2735f, 0.4215f, 12.0f,
0.2561f, 0.4597f, 12.0f,
0.2355f, 0.5006f, 12.0f,
0.2128f, 0.5425f, 12.0f,
0.1909f, 0.5779f, 12.0f,
0.1682f, 0.6111f, 12.0f,
0.1446f, 0.6431f, 12.0f,
0.123f, 0.6706f, 12.0f,
0.1009f, 0.6975f, 12.0f,
0.076f, 0.725f, 12.0f,
0.0528f, 0.7502f, 12.0f,
0.028f, 0.78f, 12.0f,
-0.005f, 0.816f, 12.0f,
0.2959f, 0.3417f, 12.0f,
0.2781f, 0.3704f, 12.0f,
0.2581f, 0.3992f, 12.0f,
0.2359f, 0.4266f, 12.0f,
0.2115f, 0.4532f, 12.0f,
0.1843f, 0.4807f, 12.0f,
0.1627f, 0.5015f, 12.0f,
0.1402f, 0.5214f, 12.0f,
0.1188f, 0.54f, 12.0f,
0.1018f, 0.5543f, 12.0f,
0.0841f, 0.5684f, 12.0f,
0.0614f, 0.5857f, 12.0f,
0.0407f, 0.601f, 12.0f,
0.02f, 0.618f, 12.0f,
-0.003f, 0.632f, 12.0f,
0.2919f, 0.3371f, 12.0f,
0.2702f, 0.3602f, 12.0f,
0.2467f, 0.3822f, 12.0f,
0.2232f, 0.4022f, 12.0f,
0.1989f, 0.4219f, 12.0f,
0.1706f, 0.4419f, 12.0f,
0.15f, 0.4562f, 12.0f,
0.1293f, 0.4703f, 12.0f,
0.1086f, 0.4842f, 12.0f,
0.0928f, 0.4942f, 12.0f,
0.077f, 0.504f, 12.0f,
0.0581f, 0.5151f, 12.0f,
0.0392f, 0.5258f, 12.0f,
0.02f, 0.536f, 12.0f,
0.002f, 0.546f, 12.0f,
0.288f, 0.3327f, 12.0f,
0.2628f, 0.3498f, 12.0f,
0.2374f, 0.3655f, 12.0f,
0.2124f, 0.3799f, 12.0f,
0.1876f, 0.3933f, 12.0f,
0.1602f, 0.407f, 12.0f,
0.1398f, 0.4168f, 12.0f,
0.1212f, 0.4245f, 12.0f,
0.1006f, 0.433f, 12.0f,
0.085f, 0.4388f, 12.0f,
0.0702f, 0.444f, 12.0f,
0.0553f, 0.4492f, 12.0f,
0.04f, 0.4545f, 12.0f,
0.023f, 0.46f, 12.0f,
0.008f, 0.465f, 12.0f,
0.284f, 0.327f, 12.0f,
0.2552f, 0.3375f, 12.0f,
0.2278f, 0.3463f, 12.0f,
0.2006f, 0.354f, 12.0f,
0.1738f, 0.36f, 12.0f,
0.1492f, 0.3649f, 12.0f,
0.1283f, 0.3688f, 12.0f,
0.1102f, 0.372f, 12.0f,
0.0915f, 0.3754f, 12.0f,
0.0768f, 0.3773f, 12.0f,
0.0636f, 0.3788f, 12.0f,
0.051f, 0.38f, 12.0f,
0.038f, 0.382f, 12.0f,
0.025f, 0.383f, 12.0f,
0.2799f, 0.3208f, 12.0f,
0.248f, 0.3232f, 12.0f,
0.2182f, 0.324f, 12.0f,
0.189f, 0.3234f, 12.0f,
0.1618f, 0.3219f, 12.0f,
0.1379f, 0.3198f, 12.0f,
0.117f, 0.317f, 12.0f,
0.0992f, 0.3141f, 12.0f,
0.0828f, 0.3108f, 12.0f,
0.0675f, 0.3075f, 12.0f,
0.056f, 0.305f, 12.0f,
0.047f, 0.304f, 12.0f,
0.036f, 0.303f, 12.0f,
0.2764f, 0.3148f, 12.0f,
0.2429f, 0.3108f, 12.0f,
0.2113f, 0.3052f, 12.0f,
0.1815f, 0.2985f, 12.0f,
0.154f, 0.291f, 12.0f,
0.1298f, 0.284f, 12.0f,
0.1092f, 0.2774f, 12.0f,
0.0922f, 0.2718f, 12.0f,
0.0768f, 0.2667f, 12.0f,
0.065f, 0.262f, 12.0f,
0.054f, 0.258f, 12.0f,
0.045f, 0.255f, 12.0f,
0.274f, 0.3091f, 12.0f,
0.2384f, 0.2984f, 12.0f,
0.2065f, 0.2863f, 12.0f,
0.176f, 0.273f, 12.0f,
0.148f, 0.26f, 12.0f,
0.1248f, 0.2484f, 12.0f,
0.1033f, 0.2376f, 12.0f,
0.0888f, 0.2298f, 12.0f,
0.073f, 0.221f, 12.0f,
0.062f, 0.214f, 12.0f,
0.051f, 0.207f, 12.0f,
0.2727f, 0.3038f, 12.0f,
0.236f, 0.2872f, 12.0f,
0.2048f, 0.2708f, 12.0f,
0.1737f, 0.2524f, 12.0f,
0.1463f, 0.2354f, 12.0f,
0.1247f, 0.2209f, 12.0f,
0.1027f, 0.2057f, 12.0f,
0.09f, 0.1973f, 12.0f,
0.073f, 0.184f, 12.0f,
0.062f, 0.177f, 12.0f,
0.2723f, 0.2992f, 12.0f,
0.2363f, 0.2782f, 12.0f,
0.206f, 0.2572f, 12.0f,
0.1759f, 0.2345f, 12.0f,
0.1512f, 0.2148f, 12.0f,
0.1299f, 0.1963f, 12.0f,
0.1098f, 0.1785f, 12.0f,
0.094f, 0.163f, 12.0f,
0.079f, 0.15f, 12.0f,
0.2733f, 0.2947f, 12.0f,
0.2388f, 0.2704f, 12.0f,
0.2102f, 0.247f, 12.0f,
0.1821f, 0.2232f, 12.0f,
0.1601f, 0.2028f, 12.0f,
0.1393f, 0.1837f, 12.0f,
0.1204f, 0.1655f, 12.0f,
0.102f, 0.149f, 12.0f,
0.091f, 0.138f, 12.0f,
0.2753f, 0.291f, 12.0f,
0.2429f, 0.2648f, 12.0f,
0.2157f, 0.2407f, 12.0f,
0.1893f, 0.216f, 12.0f,
0.1681f, 0.1954f, 12.0f,
0.1487f, 0.176f, 12.0f,
0.131f, 0.158f, 12.0f,
0.1155f, 0.1416f, 12.0f,
0.103f, 0.128f, 12.0f,
0.092f, 0.117f, 12.0f,
0.2782f, 0.2876f, 12.0f,
0.2487f, 0.2597f, 12.0f,
0.2235f, 0.2343f, 12.0f,
0.1995f, 0.2094f, 12.0f,
0.1805f, 0.1888f, 12.0f,
0.1634f, 0.1698f, 12.0f,
0.1473f, 0.1513f, 12.0f,
0.1336f, 0.1349f, 12.0f,
0.1218f, 0.1208f, 12.0f,
0.112f, 0.108f, 12.0f,
0.104f, 0.096f, 12.0f,
0.098f, 0.089f, 12.0f,
0.2816f, 0.2842f, 12.0f,
0.2562f, 0.256f, 12.0f,
0.2325f, 0.23f, 12.0f,
0.2103f, 0.205f, 12.0f,
0.1925f, 0.1843f, 12.0f,
0.1773f, 0.1659f, 12.0f,
0.1627f, 0.1479f, 12.0f,
0.1504f, 0.1317f, 12.0f,
0.1392f, 0.1167f, 12.0f,
0.1288f, 0.1027f, 12.0f,
0.122f, 0.092f, 12.0f,
0.118f, 0.084f, 12.0f,
0.115f, 0.078f, 12.0f,
0.111f, 0.073f, 12.0f,
0.108f, 0.068f, 12.0f,
0.106f, 0.064f, 12.0f,
0.104f, 0.06f, 12.0f,
0.102f, 0.055f, 12.0f,
0.098f, 0.048f, 12.0f,
0.096f, 0.044f, 12.0f,
0.2861f, 0.2819f, 12.0f,
0.2657f, 0.2528f, 12.0f,
0.2471f, 0.2266f, 12.0f,
0.2304f, 0.2023f, 12.0f,
0.2158f, 0.1811f, 12.0f,
0.2037f, 0.1629f, 12.0f,
0.1941f, 0.1468f, 12.0f,
0.1861f, 0.1316f, 12.0f,
0.1798f, 0.1185f, 12.0f,
0.1742f, 0.1058f, 12.0f,
0.1713f, 0.098f, 12.0f,
0.1684f, 0.0899f, 12.0f,
0.1659f, 0.0825f, 12.0f,
0.164f, 0.077f, 12.0f,
0.162f, 0.072f, 12.0f,
0.16f, 0.066f, 12.0f,
0.158f, 0.06f, 12.0f,
0.157f, 0.054f, 12.0f,
0.155f, 0.049f, 12.0f,
0.153f, 0.044f, 12.0f,
0.2911f, 0.2804f, 12.0f,
0.2759f, 0.2522f, 12.0f,
0.2618f, 0.2263f, 12.0f,
0.2497f, 0.2038f, 12.0f,
0.2388f, 0.1837f, 12.0f,
0.2298f, 0.1659f, 12.0f,
0.222f, 0.1503f, 12.0f,
0.217f, 0.1373f, 12.0f,
0.212f, 0.1256f, 12.0f,
0.2075f, 0.114f, 12.0f,
0.2048f, 0.1064f, 12.0f,
0.202f, 0.0985f, 12.0f,
0.1994f, 0.0904f, 12.0f,
0.1971f, 0.084f, 12.0f,
0.1952f, 0.0778f, 12.0f,
0.192f, 0.071f, 12.0f,
0.191f, 0.064f, 12.0f,
0.189f, 0.058f, 12.0f,
0.187f, 0.052f, 12.0f,
0.184f, 0.046f, 12.0f,
0.2962f, 0.2807f, 12.0f,
0.2855f, 0.2531f, 12.0f,
0.2763f, 0.23f, 12.0f,
0.2685f, 0.2089f, 12.0f,
0.2619f, 0.1903f, 12.0f,
0.2559f, 0.173f, 12.0f,
0.2509f, 0.1585f, 12.0f,
0.2467f, 0.1452f, 12.0f,
0.243f, 0.1332f, 12.0f,
0.2394f, 0.1221f, 12.0f,
0.2371f, 0.1143f, 12.0f,
0.2348f, 0.1062f, 12.0f,
0.2322f, 0.0978f, 12.0f,
0.2302f, 0.0909f, 12.0f,
0.2285f, 0.0847f, 12.0f,
0.2265f, 0.0774f, 12.0f,
0.224f, 0.07f, 12.0f,
0.222f, 0.064f, 12.0f,
0.22f, 0.057f, 12.0f,
0.218f, 0.051f, 12.0f,
0.3022f, 0.2825f, 12.0f,
0.2958f, 0.2565f, 12.0f,
0.2903f, 0.2347f, 12.0f,
0.2855f, 0.215f, 12.0f,
0.2814f, 0.1967f, 12.0f,
0.2778f, 0.1808f, 12.0f,
0.2747f, 0.166f, 12.0f,
0.2718f, 0.152f, 12.0f,
0.2693f, 0.1408f, 12.0f,
0.267f, 0.13f, 12.0f,
0.2652f, 0.1218f, 12.0f,
0.2635f, 0.1132f, 12.0f,
0.2618f, 0.1052f, 12.0f,
0.26f, 0.0971f, 12.0f,
0.2588f, 0.0907f, 12.0f,
0.2574f, 0.0833f, 12.0f,
0.256f, 0.074f, 12.0f,
0.255f, 0.069f, 12.0f,
0.254f, 0.063f, 12.0f,
0.254f, 0.056f, 12.0f,
0.3093f, 0.2859f, 12.0f,
0.3084f, 0.2622f, 12.0f,
0.3076f, 0.2416f, 12.0f,
0.3066f, 0.2228f, 12.0f,
0.3056f, 0.206f, 12.0f,
0.3045f, 0.1905f, 12.0f,
0.3035f, 0.1755f, 12.0f,
0.3028f, 0.1621f, 12.0f,
0.3016f, 0.15f, 12.0f,
0.301f, 0.1396f, 12.0f,
0.3001f, 0.1306f, 12.0f,
0.2993f, 0.1225f, 12.0f,
0.2986f, 0.1135f, 12.0f,
0.2979f, 0.1062f, 12.0f,
0.2969f, 0.0979f, 12.0f,
0.2962f, 0.0906f, 12.0f,
0.295f, 0.082f, 12.0f,
0.295f, 0.075f, 12.0f,
0.294f, 0.069f, 12.0f,
0.293f, 0.062f, 12.0f,
0.3162f, 0.2902f, 12.0f,
0.321f, 0.2686f, 12.0f,
0.3248f, 0.2493f, 12.0f,
0.328f, 0.2318f, 12.0f,
0.3306f, 0.2162f, 12.0f,
0.3331f, 0.2014f, 12.0f,
0.3351f, 0.1875f, 12.0f,
0.337f, 0.1756f, 12.0f,
0.3386f, 0.1626f, 12.0f,
0.34f, 0.15f, 12.0f,
0.3411f, 0.1424f, 12.0f,
0.3421f, 0.1337f, 12.0f,
0.3428f, 0.1248f, 12.0f,
0.3432f, 0.1172f, 12.0f,
0.344f, 0.108f, 12.0f,
0.345f, 0.1f, 12.0f,
0.346f, 0.093f, 12.0f,
0.346f, 0.085f, 12.0f,
0.347f, 0.078f, 12.0f,
0.3231f, 0.2951f, 12.0f,
0.334f, 0.277f, 12.0f,
0.3442f, 0.2595f, 12.0f,
0.3533f, 0.2438f, 12.0f,
0.3608f, 0.2301f, 12.0f,
0.3683f, 0.2162f, 12.0f,
0.3748f, 0.2039f, 12.0f,
0.3807f, 0.1923f, 12.0f,
0.3865f, 0.1802f, 12.0f,
0.3926f, 0.1679f, 12.0f,
0.3967f, 0.1593f, 12.0f,
0.4011f, 0.1504f, 12.0f,
0.4048f, 0.1428f, 12.0f,
0.409f, 0.134f, 12.0f,
0.414f, 0.122f, 12.0f,
0.417f, 0.115f, 12.0f,
0.419f, 0.108f, 12.0f,
0.331f, 0.301f, 12.0f,
0.3491f, 0.2872f, 12.0f,
0.3671f, 0.2733f, 12.0f,
0.3833f, 0.26f, 12.0f,
0.396f, 0.2489f, 12.0f,
0.4104f, 0.2361f, 12.0f,
0.4225f, 0.2249f, 12.0f,
0.4339f, 0.2139f, 12.0f,
0.4455f, 0.2023f, 12.0f,
0.4571f, 0.1906f, 12.0f,
0.4656f, 0.1821f, 12.0f,
0.473f, 0.172f, 12.0f,
0.482f, 0.162f, 12.0f,
0.489f, 0.154f, 12.0f,
0.499f, 0.143f, 12.0f,
0.3371f, 0.3061f, 12.0f,
0.3612f, 0.2963f, 12.0f,
0.385f, 0.2859f, 12.0f,
0.4072f, 0.275f, 12.0f,
0.4259f, 0.2651f, 12.0f,
0.445f, 0.2541f, 12.0f,
0.4629f, 0.2437f, 12.0f,
0.4799f, 0.2329f, 12.0f,
0.4965f, 0.2217f, 12.0f,
0.513f, 0.2101f, 12.0f,
0.523f, 0.202f, 12.0f,
0.536f, 0.192f, 12.0f,
0.549f, 0.181f, 12.0f,
0.3417f, 0.3106f, 12.0f,
0.3715f, 0.3042f, 12.0f,
0.3999f, 0.2972f, 12.0f,
0.4282f, 0.289f, 12.0f,
0.4528f, 0.2811f, 12.0f,
0.4789f, 0.2717f, 12.0f,
0.502f, 0.2623f, 12.0f,
0.5234f, 0.253f, 12.0f,
0.5466f, 0.2424f, 12.0f,
0.5674f, 0.2319f, 12.0f,
0.582f, 0.224f, 12.0f,
0.598f, 0.214f, 12.0f,
0.3461f, 0.315f, 12.0f,
0.3806f, 0.3125f, 12.0f,
0.4141f, 0.3085f, 12.0f,
0.4472f, 0.3031f, 12.0f,
0.4774f, 0.2969f, 12.0f,
0.5072f, 0.2897f, 12.0f,
0.5369f, 0.281f, 12.0f,
0.562f, 0.2724f, 12.0f,
0.5898f, 0.2622f, 12.0f,
0.615f, 0.253f, 12.0f,
0.633f, 0.244f, 12.0f,
0.654f, 0.236f, 12.0f,
0.3508f, 0.32f, 12.0f,
0.3916f, 0.3223f, 12.0f,
0.4299f, 0.3226f, 12.0f,
0.469f, 0.3209f, 12.0f,
0.5043f, 0.3176f, 12.0f,
0.5385f, 0.3129f, 12.0f,
0.5734f, 0.3057f, 12.0f,
0.6039f, 0.2978f, 12.0f,
0.6329f, 0.2881f, 12.0f,
0.658f, 0.278f, 12.0f,
0.678f, 0.27f, 12.0f,
0.699f, 0.26f, 12.0f,
0.3538f, 0.3236f, 12.0f,
0.399f, 0.33f, 12.0f,
0.4415f, 0.334f, 12.0f,
0.485f, 0.3359f, 12.0f,
0.5235f, 0.3351f, 12.0f,
0.5603f, 0.3321f, 12.0f,
0.5959f, 0.3269f, 12.0f,
0.626f, 0.3192f, 12.0f,
0.6538f, 0.31f, 12.0f,
0.6806f, 0.2988f, 12.0f,
0.703f, 0.291f, 12.0f,
0.726f, 0.28f, 12.0f,
0.3582f, 0.3294f, 12.0f,
0.4078f, 0.3412f, 12.0f,
0.4535f, 0.35f, 12.0f,
0.4995f, 0.3557f, 12.0f,
0.5418f, 0.358f, 12.0f,
0.5801f, 0.3588f, 12.0f,
0.6154f, 0.3568f, 12.0f,
0.6409f, 0.3533f, 12.0f,
0.671f, 0.348f, 12.0f,
0.698f, 0.344f, 12.0f,
0.726f, 0.338f, 12.0f,
0.756f, 0.332f, 12.0f,
0.3624f, 0.3367f, 12.0f,
0.4141f, 0.3539f, 12.0f,
0.4612f, 0.3674f, 12.0f,
0.5071f, 0.3777f, 12.0f,
0.5475f, 0.3856f, 12.0f,
0.5809f, 0.391f, 12.0f,
0.614f, 0.396f, 12.0f,
0.639f, 0.4f, 12.0f,
0.669f, 0.404f, 12.0f,
0.3651f, 0.3442f, 12.0f,
0.4187f, 0.3679f, 12.0f,
0.4651f, 0.3859f, 12.0f,
0.507f, 0.3994f, 12.0f,
0.5432f, 0.4097f, 12.0f,
0.5729f, 0.4169f, 12.0f,
0.603f, 0.423f, 12.0f,
0.3662f, 0.3504f, 12.0f,
0.4208f, 0.3809f, 12.0f,
0.4655f, 0.4029f, 12.0f,
0.5038f, 0.4204f, 12.0f,
0.5356f, 0.4342f, 12.0f,
0.559f, 0.445f, 12.0f,
0.587f, 0.456f, 12.0f,
0.366f, 0.359f, 12.0f,
0.4189f, 0.3948f, 12.0f,
0.4618f, 0.4213f, 12.0f,
0.4965f, 0.4414f, 12.0f,
0.525f, 0.4573f, 12.0f,
0.545f, 0.468f, 12.0f,
0.3633f, 0.3654f, 12.0f,
0.4138f, 0.4076f, 12.0f,
0.4542f, 0.4391f, 12.0f,
0.4865f, 0.4625f, 12.0f,
0.512f, 0.48f, 12.0f,
0.529f, 0.492f, 12.0f,
0.359f, 0.3701f, 12.0f,
0.4069f, 0.4188f, 12.0f,
0.4451f, 0.455f, 12.0f,
0.4745f, 0.481f, 12.0f,
0.496f, 0.503f, 12.0f,
0.512f, 0.516f, 12.0f,
0.3542f, 0.3727f, 12.0f,
0.3982f, 0.4272f, 12.0f,
0.4331f, 0.4688f, 12.0f,
0.4595f, 0.499f, 12.0f,
0.481f, 0.523f, 12.0f,
0.494f, 0.538f, 12.0f,
0.3422f, 0.3648f, 19.77f,
0.3762f, 0.4158f, 19.77f,
0.4072f, 0.4621f, 19.77f,
0.4307f, 0.4967f, 19.77f,
0.4468f, 0.5209f, 19.77f,
0.459f, 0.539f, 19.77f,
0.469f, 0.554f, 19.77f,
0.3352f, 0.3636f, 19.77f,
0.3621f, 0.4143f, 19.77f,
0.3879f, 0.4646f, 19.77f,
0.4088f, 0.5068f, 19.77f,
0.4224f, 0.5369f, 19.77f,
0.4333f, 0.5602f, 19.77f,
0.44f, 0.58f, 19.77f,
0.3289f, 0.3612f, 19.77f,
0.3482f, 0.4097f, 19.77f,
0.3663f, 0.4614f, 19.77f,
0.3815f, 0.5093f, 19.77f,
0.3928f, 0.5485f, 19.77f,
0.4011f, 0.5802f, 19.77f,
0.407f, 0.604f, 19.77f,
0.41f, 0.626f, 19.77f,
0.3188f, 0.356f, 19.77f,
0.3274f, 0.3994f, 19.77f,
0.3354f, 0.4483f, 19.77f,
0.3412f, 0.4976f, 19.77f,
0.3451f, 0.549f, 19.77f,
0.345f, 0.5949f, 19.77f,
0.3429f, 0.6335f, 19.77f,
0.341f, 0.666f, 19.77f,
0.339f, 0.697f, 19.77f,
0.333f, 0.733f, 19.77f,
0.311f, 0.3508f, 19.77f,
0.3111f, 0.3881f, 19.77f,
0.3108f, 0.4301f, 19.77f,
0.308f, 0.4759f, 19.77f,
0.3028f, 0.5237f, 19.77f,
0.294f, 0.5751f, 19.77f,
0.2838f, 0.6208f, 19.77f,
0.2702f, 0.67f, 19.77f,
0.2549f, 0.7179f, 19.77f,
0.237f, 0.767f, 19.77f,
0.221f, 0.808f, 19.77f,
0.202f, 0.852f, 19.77f,
0.179f, 0.898f, 19.77f,
0.154f, 0.949f, 19.77f,
0.125f, 1.0f, 19.77f,
0.097f, 1.048f, 19.77f,
0.303f, 0.3445f, 19.77f,
0.2943f, 0.3735f, 19.77f,
0.2841f, 0.4045f, 19.77f,
0.271f, 0.438f, 19.77f,
0.2565f, 0.4705f, 19.77f,
0.2385f, 0.5071f, 19.77f,
0.2211f, 0.5411f, 19.77f,
0.2005f, 0.5759f, 19.77f,
0.1782f, 0.6095f, 19.77f,
0.1579f, 0.6392f, 19.77f,
0.1377f, 0.6674f, 19.77f,
0.1188f, 0.6918f, 19.77f,
0.0992f, 0.7155f, 19.77f,
0.0794f, 0.7385f, 19.77f,
0.055f, 0.766f, 19.77f,
0.034f, 0.789f, 19.77f,
0.2978f, 0.3392f, 19.77f,
0.2841f, 0.3628f, 19.77f,
0.269f, 0.386f, 19.77f,
0.2511f, 0.4107f, 19.77f,
0.2329f, 0.4331f, 19.77f,
0.2104f, 0.4578f, 19.77f,
0.1912f, 0.4773f, 19.77f,
0.1695f, 0.4981f, 19.77f,
0.1489f, 0.5171f, 19.77f,
0.1318f, 0.5321f, 19.77f,
0.1144f, 0.5463f, 19.77f,
0.0953f, 0.5628f, 19.77f,
0.0784f, 0.5761f, 19.77f,
0.0609f, 0.5898f, 19.77f,
0.04f, 0.605f, 19.77f,
0.02f, 0.622f, 19.77f,
0.2945f, 0.3355f, 19.77f,
0.2775f, 0.3545f, 19.77f,
0.2598f, 0.3724f, 19.77f,
0.2395f, 0.3915f, 19.77f,
0.22f, 0.4082f, 19.77f,
0.1964f, 0.4271f, 19.77f,
0.1776f, 0.4415f, 19.77f,
0.1571f, 0.4561f, 19.77f,
0.1372f, 0.4705f, 19.77f,
0.1212f, 0.4817f, 19.77f,
0.105f, 0.4927f, 19.77f,
0.0878f, 0.5039f, 19.77f,
0.073f, 0.5131f, 19.77f,
0.0585f, 0.5224f, 19.77f,
0.041f, 0.532f, 19.77f,
0.021f, 0.542f, 19.77f,
0.291f, 0.331f, 19.77f,
0.2711f, 0.3455f, 19.77f,
0.2519f, 0.3587f, 19.77f,
0.2297f, 0.373f, 19.77f,
0.2095f, 0.3853f, 19.77f,
0.1852f, 0.3992f, 19.77f,
0.1671f, 0.4089f, 19.77f,
0.1469f, 0.4192f, 19.77f,
0.1275f, 0.4288f, 19.77f,
0.112f, 0.436f, 19.77f,
0.0958f, 0.4428f, 19.77f,
0.0811f, 0.4491f, 19.77f,
0.069f, 0.4542f, 19.77f,
0.0572f, 0.459f, 19.77f,
0.041f, 0.466f, 19.77f,
0.023f, 0.474f, 19.77f,
0.288f, 0.327f, 19.77f,
0.2659f, 0.3369f, 19.77f,
0.2448f, 0.3452f, 19.77f,
0.2205f, 0.3537f, 19.77f,
0.198f, 0.3606f, 19.77f,
0.1735f, 0.3668f, 19.77f,
0.1559f, 0.3708f, 19.77f,
0.1348f, 0.375f, 19.77f,
0.1165f, 0.3785f, 19.77f,
0.1005f, 0.3814f, 19.77f,
0.0861f, 0.3832f, 19.77f,
0.0738f, 0.3851f, 19.77f,
0.064f, 0.386f, 19.77f,
0.053f, 0.388f, 19.77f,
0.042f, 0.389f, 19.77f,
0.027f, 0.391f, 19.77f,
0.2841f, 0.321f, 19.77f,
0.2591f, 0.3246f, 19.77f,
0.236f, 0.327f, 19.77f,
0.21f, 0.328f, 19.77f,
0.185f, 0.328f, 19.77f,
0.1614f, 0.328f, 19.77f,
0.1448f, 0.3275f, 19.77f,
0.1243f, 0.3261f, 19.77f,
0.1046f, 0.3244f, 19.77f,
0.0904f, 0.3231f, 19.77f,
0.0781f, 0.3211f, 19.77f,
0.067f, 0.32f, 19.77f,
0.058f, 0.318f, 19.77f,
0.05f, 0.317f, 19.77f,
0.042f, 0.316f, 19.77f,
0.2812f, 0.3161f, 19.77f,
0.255f, 0.315f, 19.77f,
0.2292f, 0.3125f, 19.77f,
0.203f, 0.3082f, 19.77f,
0.1776f, 0.3032f, 19.77f,
0.1537f, 0.2976f, 19.77f,
0.1364f, 0.2932f, 19.77f,
0.1167f, 0.288f, 19.77f,
0.0982f, 0.2828f, 19.77f,
0.083f, 0.278f, 19.77f,
0.071f, 0.274f, 19.77f,
0.062f, 0.27f, 19.77f,
0.055f, 0.268f, 19.77f,
0.2796f, 0.3111f, 19.77f,
0.2512f, 0.304f, 19.77f,
0.2234f, 0.2952f, 19.77f,
0.197f, 0.286f, 19.77f,
0.1716f, 0.276f, 19.77f,
0.1485f, 0.2662f, 19.77f,
0.1308f, 0.2582f, 19.77f,
0.1108f, 0.2489f, 19.77f,
0.093f, 0.24f, 19.77f,
0.079f, 0.232f, 19.77f,
0.066f, 0.226f, 19.77f,
0.058f, 0.221f, 19.77f,
0.2791f, 0.3071f, 19.77f,
0.2492f, 0.2954f, 19.77f,
0.221f, 0.2823f, 19.77f,
0.1947f, 0.2687f, 19.77f,
0.1697f, 0.2549f, 19.77f,
0.1461f, 0.2406f, 19.77f,
0.1283f, 0.2292f, 19.77f,
0.109f, 0.2166f, 19.77f,
0.094f, 0.206f, 19.77f,
0.077f, 0.194f, 19.77f,
0.2794f, 0.3032f, 19.77f,
0.2493f, 0.2879f, 19.77f,
0.2215f, 0.2701f, 19.77f,
0.1958f, 0.2519f, 19.77f,
0.1729f, 0.2347f, 19.77f,
0.1505f, 0.2172f, 19.77f,
0.132f, 0.2021f, 19.77f,
0.1132f, 0.1863f, 19.77f,
0.098f, 0.172f, 19.77f,
0.086f, 0.16f, 19.77f,
0.2803f, 0.3f, 19.77f,
0.2511f, 0.2808f, 19.77f,
0.2248f, 0.2612f, 19.77f,
0.2007f, 0.2417f, 19.77f,
0.1792f, 0.223f, 19.77f,
0.1584f, 0.2042f, 19.77f,
0.1404f, 0.1878f, 19.77f,
0.123f, 0.1711f, 19.77f,
0.109f, 0.157f, 19.77f,
0.098f, 0.146f, 19.77f,
0.2821f, 0.2966f, 19.77f,
0.2547f, 0.2757f, 19.77f,
0.2299f, 0.2548f, 19.77f,
0.2067f, 0.2344f, 19.77f,
0.186f, 0.2149f, 19.77f,
0.1666f, 0.1964f, 19.77f,
0.1492f, 0.1797f, 19.77f,
0.1326f, 0.1632f, 19.77f,
0.1203f, 0.1505f, 19.77f,
0.108f, 0.137f, 19.77f,
0.096f, 0.126f, 19.77f,
0.2847f, 0.2942f, 19.77f,
0.26f, 0.272f, 19.77f,
0.2365f, 0.2488f, 19.77f,
0.2157f, 0.2278f, 19.77f,
0.1968f, 0.2078f, 19.77f,
0.1793f, 0.1894f, 19.77f,
0.1642f, 0.1728f, 19.77f,
0.1495f, 0.1559f, 19.77f,
0.1363f, 0.141f, 19.77f,
0.124f, 0.128f, 19.77f,
0.114f, 0.116f, 19.77f,
0.103f, 0.104f, 19.77f,
0.2882f, 0.2923f, 19.77f,
0.2662f, 0.2687f, 19.77f,
0.2447f, 0.2449f, 19.77f,
0.2255f, 0.2239f, 19.77f,
0.208f, 0.2041f, 19.77f,
0.1918f, 0.1858f, 19.77f,
0.1773f, 0.1689f, 19.77f,
0.1638f, 0.1521f, 19.77f,
0.1518f, 0.1365f, 19.77f,
0.142f, 0.123f, 19.77f,
0.134f, 0.113f, 19.77f,
0.124f, 0.1f, 19.77f,
0.116f, 0.089f, 19.77f,
0.109f, 0.079f, 19.77f,
0.104f, 0.07f, 19.77f,
0.097f, 0.062f, 19.77f,
0.2918f, 0.2908f, 19.77f,
0.2739f, 0.2666f, 19.77f,
0.2563f, 0.2417f, 19.77f,
0.2417f, 0.2204f, 19.77f,
0.2285f, 0.202f, 19.77f,
0.2157f, 0.183f, 19.77f,
0.2042f, 0.1661f, 19.77f,
0.1945f, 0.1511f, 19.77f,
0.1862f, 0.1365f, 19.77f,
0.1794f, 0.1239f, 19.77f,
0.175f, 0.114f, 19.77f,
0.17f, 0.103f, 19.77f,
0.165f, 0.094f, 19.77f,
0.162f, 0.086f, 19.77f,
0.158f, 0.078f, 19.77f,
0.154f, 0.07f, 19.77f,
0.15f, 0.062f, 19.77f,
0.2959f, 0.2905f, 19.77f,
0.2821f, 0.2659f, 19.77f,
0.2686f, 0.2412f, 19.77f,
0.2572f, 0.2211f, 19.77f,
0.2478f, 0.203f, 19.77f,
0.2384f, 0.1857f, 19.77f,
0.2299f, 0.1698f, 19.77f,
0.2224f, 0.1555f, 19.77f,
0.2174f, 0.1444f, 19.77f,
0.2121f, 0.1329f, 19.77f,
0.2082f, 0.1225f, 19.77f,
0.204f, 0.113f, 19.77f,
0.2f, 0.103f, 19.77f,
0.197f, 0.095f, 19.77f,
0.193f, 0.086f, 19.77f,
0.189f, 0.078f, 19.77f,
0.186f, 0.071f, 19.77f,
0.183f, 0.063f, 19.77f,
0.3f, 0.2912f, 19.77f,
0.2898f, 0.2667f, 19.77f,
0.2806f, 0.2444f, 19.77f,
0.2728f, 0.224f, 19.77f,
0.2665f, 0.2075f, 19.77f,
0.2608f, 0.1913f, 19.77f,
0.256f, 0.1774f, 19.77f,
0.2515f, 0.1644f, 19.77f,
0.2476f, 0.1532f, 19.77f,
0.2438f, 0.1419f, 19.77f,
0.2402f, 0.1315f, 19.77f,
0.2372f, 0.1223f, 19.77f,
0.2348f, 0.114f, 19.77f,
0.231f, 0.104f, 19.77f,
0.229f, 0.097f, 19.77f,
0.226f, 0.088f, 19.77f,
0.223f, 0.08f, 19.77f,
0.221f, 0.072f, 19.77f,
0.219f, 0.066f, 19.77f,
0.3045f, 0.2928f, 19.77f,
0.2986f, 0.2699f, 19.77f,
0.2932f, 0.2487f, 19.77f,
0.2885f, 0.2296f, 19.77f,
0.2845f, 0.2137f, 19.77f,
0.2806f, 0.1977f, 19.77f,
0.2775f, 0.1847f, 19.77f,
0.2744f, 0.1718f, 19.77f,
0.2718f, 0.1604f, 19.77f,
0.2694f, 0.1499f, 19.77f,
0.2673f, 0.1398f, 19.77f,
0.2652f, 0.1304f, 19.77f,
0.2635f, 0.1224f, 19.77f,
0.2618f, 0.1135f, 19.77f,
0.259f, 0.105f, 19.77f,
0.256f, 0.096f, 19.77f,
0.255f, 0.088f, 19.77f,
0.253f, 0.081f, 19.77f,
0.252f, 0.075f, 19.77f,
0.251f, 0.069f, 19.77f,
0.3103f, 0.2959f, 19.77f,
0.31f, 0.275f, 19.77f,
0.3093f, 0.2555f, 19.77f,
0.3087f, 0.2375f, 19.77f,
0.308f, 0.223f, 19.77f,
0.3071f, 0.208f, 19.77f,
0.3068f, 0.1951f, 19.77f,
0.306f, 0.183f, 19.77f,
0.3052f, 0.1711f, 19.77f,
0.3042f, 0.1606f, 19.77f,
0.3038f, 0.15f, 19.77f,
0.303f, 0.1423f, 19.77f,
0.3022f, 0.1331f, 19.77f,
0.3018f, 0.1253f, 19.77f,
0.301f, 0.117f, 19.77f,
0.3f, 0.108f, 19.77f,
0.3f, 0.1f, 19.77f,
0.299f, 0.093f, 19.77f,
0.298f, 0.088f, 19.77f,
0.298f, 0.081f, 19.77f,
0.3148f, 0.2986f, 19.77f,
0.3198f, 0.2807f, 19.77f,
0.3243f, 0.263f, 19.77f,
0.328f, 0.2464f, 19.77f,
0.3308f, 0.2328f, 19.77f,
0.3335f, 0.2187f, 19.77f,
0.336f, 0.2066f, 19.77f,
0.3382f, 0.1951f, 19.77f,
0.3401f, 0.184f, 19.77f,
0.3422f, 0.1735f, 19.77f,
0.3437f, 0.1644f, 19.77f,
0.345f, 0.1555f, 19.77f,
0.3468f, 0.146f, 19.77f,
0.3478f, 0.1388f, 19.77f,
0.349f, 0.1308f, 19.77f,
0.35f, 0.124f, 19.77f,
0.351f, 0.115f, 19.77f,
0.352f, 0.107f, 19.77f,
0.353f, 0.102f, 19.77f,
0.354f, 0.096f, 19.77f,
0.3199f, 0.3019f, 19.77f,
0.3298f, 0.2869f, 19.77f,
0.3396f, 0.2718f, 19.77f,
0.349f, 0.257f, 19.77f,
0.356f, 0.2452f, 19.77f,
0.3635f, 0.2325f, 19.77f,
0.3703f, 0.2211f, 19.77f,
0.3763f, 0.2108f, 19.77f,
0.3821f, 0.2007f, 19.77f,
0.3873f, 0.1909f, 19.77f,
0.3924f, 0.1814f, 19.77f,
0.3965f, 0.1738f, 19.77f,
0.4011f, 0.1652f, 19.77f,
0.405f, 0.157f, 19.77f,
0.409f, 0.149f, 19.77f,
0.413f, 0.142f, 19.77f,
0.416f, 0.135f, 19.77f,
0.421f, 0.126f, 19.77f,
0.3256f, 0.3065f, 19.77f,
0.3421f, 0.2954f, 19.77f,
0.3585f, 0.2842f, 19.77f,
0.3748f, 0.2729f, 19.77f,
0.388f, 0.263f, 19.77f,
0.4022f, 0.2523f, 19.77f,
0.4142f, 0.2428f, 19.77f,
0.4261f, 0.2331f, 19.77f,
0.4372f, 0.2242f, 19.77f,
0.4484f, 0.215f, 19.77f,
0.4581f, 0.2068f, 19.77f,
0.4683f, 0.1978f, 19.77f,
0.476f, 0.19f, 19.77f,
0.483f, 0.183f, 19.77f,
0.491f, 0.176f, 19.77f,
0.498f, 0.169f, 19.77f,
0.3296f, 0.3098f, 19.77f,
0.3515f, 0.3024f, 19.77f,
0.3726f, 0.2941f, 19.77f,
0.3932f, 0.2852f, 19.77f,
0.4108f, 0.2773f, 19.77f,
0.4303f, 0.2675f, 19.77f,
0.4454f, 0.2596f, 19.77f,
0.4617f, 0.2506f, 19.77f,
0.4761f, 0.2421f, 19.77f,
0.4915f, 0.233f, 19.77f,
0.5045f, 0.2248f, 19.77f,
0.517f, 0.217f, 19.77f,
0.526f, 0.21f, 19.77f,
0.536f, 0.204f, 19.77f,
0.546f, 0.197f, 19.77f,
0.3332f, 0.3131f, 19.77f,
0.3594f, 0.309f, 19.77f,
0.3851f, 0.3039f, 19.77f,
0.4105f, 0.298f, 19.77f,
0.4332f, 0.2918f, 19.77f,
0.4579f, 0.2841f, 19.77f,
0.4767f, 0.2776f, 19.77f,
0.4986f, 0.2695f, 19.77f,
0.5185f, 0.262f, 19.77f,
0.5396f, 0.2535f, 19.77f,
0.554f, 0.246f, 19.77f,
0.57f, 0.24f, 19.77f,
0.582f, 0.234f, 19.77f,
0.593f, 0.229f, 19.77f,
0.336f, 0.3158f, 19.77f,
0.366f, 0.3148f, 19.77f,
0.396f, 0.313f, 19.77f,
0.4252f, 0.3101f, 19.77f,
0.4533f, 0.3058f, 19.77f,
0.482f, 0.3002f, 19.77f,
0.5047f, 0.295f, 19.77f,
0.53f, 0.288f, 19.77f,
0.554f, 0.2804f, 19.77f,
0.5784f, 0.2719f, 19.77f,
0.593f, 0.265f, 19.77f,
0.607f, 0.259f, 19.77f,
0.62f, 0.253f, 19.77f,
0.631f, 0.248f, 19.77f,
0.3392f, 0.3192f, 19.77f,
0.374f, 0.322f, 19.77f,
0.4078f, 0.3238f, 19.77f,
0.4413f, 0.324f, 19.77f,
0.4747f, 0.3227f, 19.77f,
0.5071f, 0.3194f, 19.77f,
0.5341f, 0.3158f, 19.77f,
0.5637f, 0.3102f, 19.77f,
0.5918f, 0.3038f, 19.77f,
0.6142f, 0.297f, 19.77f,
0.634f, 0.29f, 19.77f,
0.648f, 0.284f, 19.77f,
0.662f, 0.279f, 19.77f,
0.674f, 0.274f, 19.77f,
0.3425f, 0.3229f, 19.77f,
0.3806f, 0.3294f, 19.77f,
0.418f, 0.3348f, 19.77f,
0.4563f, 0.3387f, 19.77f,
0.4927f, 0.3399f, 19.77f,
0.528f, 0.3389f, 19.77f,
0.559f, 0.337f, 19.77f,
0.5901f, 0.3331f, 19.77f,
0.6161f, 0.3277f, 19.77f,
0.6388f, 0.3216f, 19.77f,
0.661f, 0.317f, 19.77f,
0.68f, 0.312f, 19.77f,
0.692f, 0.307f, 19.77f,
0.708f, 0.302f, 19.77f,
0.3465f, 0.3278f, 19.77f,
0.3879f, 0.3398f, 19.77f,
0.4299f, 0.3499f, 19.77f,
0.4713f, 0.3575f, 19.77f,
0.5113f, 0.363f, 19.77f,
0.5481f, 0.366f, 19.77f,
0.5771f, 0.3664f, 19.77f,
0.6037f, 0.3657f, 19.77f,
0.6297f, 0.3642f, 19.77f,
0.655f, 0.361f, 19.77f,
0.68f, 0.357f, 19.77f,
0.702f, 0.354f, 19.77f,
0.721f, 0.35f, 19.77f,
0.3506f, 0.3337f, 19.77f,
0.3925f, 0.3494f, 19.77f,
0.4365f, 0.364f, 19.77f,
0.4795f, 0.3758f, 19.77f,
0.5175f, 0.3844f, 19.77f,
0.5482f, 0.3909f, 19.77f,
0.5731f, 0.3953f, 19.77f,
0.5933f, 0.3989f, 19.77f,
0.617f, 0.402f, 19.77f,
0.636f, 0.406f, 19.77f,
0.353f, 0.3395f, 19.77f,
0.3968f, 0.3614f, 19.77f,
0.442f, 0.3808f, 19.77f,
0.483f, 0.396f, 19.77f,
0.5161f, 0.4064f, 19.77f,
0.5422f, 0.4141f, 19.77f,
0.5642f, 0.4201f, 19.77f,
0.584f, 0.425f, 19.77f,
0.601f, 0.429f, 19.77f,
0.354f, 0.3445f, 19.77f,
0.3991f, 0.3714f, 19.77f,
0.444f, 0.3954f, 19.77f,
0.482f, 0.4141f, 19.77f,
0.5108f, 0.4276f, 19.77f,
0.5335f, 0.4378f, 19.77f,
0.5506f, 0.445f, 19.77f,
0.568f, 0.453f, 19.77f,
0.3546f, 0.3514f, 19.77f,
0.3995f, 0.384f, 19.77f,
0.4428f, 0.4128f, 19.77f,
0.477f, 0.4338f, 19.77f,
0.5025f, 0.4489f, 19.77f,
0.5211f, 0.46f, 19.77f,
0.539f, 0.468f, 19.77f,
0.552f, 0.477f, 19.77f,
0.3534f, 0.357f, 19.77f,
0.3968f, 0.3954f, 19.77f,
0.438f, 0.4292f, 19.77f,
0.4685f, 0.4524f, 19.77f,
0.4905f, 0.4683f, 19.77f,
0.5082f, 0.4812f, 19.77f,
0.523f, 0.491f, 19.77f,
0.35f, 0.362f, 19.77f,
0.3915f, 0.4057f, 19.77f,
0.4302f, 0.4435f, 19.77f,
0.4579f, 0.4692f, 19.77f,
0.4777f, 0.4876f, 19.77f,
0.4932f, 0.5019f, 19.77f,
0.507f, 0.512f, 19.77f,
0.347f, 0.364f, 19.77f,
0.385f, 0.412f, 19.77f,
0.4199f, 0.4551f, 19.77f,
0.445f, 0.485f, 19.77f,
0.4632f, 0.5057f, 19.77f,
0.4767f, 0.5208f, 19.77f,
0.489f, 0.535f, 19.77f,
0.3398f, 0.3611f, 30.03f,
0.3679f, 0.4033f, 30.03f,
0.396f, 0.4452f, 30.03f,
0.4201f, 0.4812f, 30.03f,
0.4372f, 0.5068f, 30.03f,
0.4488f, 0.5237f, 30.03f,
0.4593f, 0.5392f, 30.03f,
0.465f, 0.546f, 30.03f,
0.3342f, 0.3607f, 30.03f,
0.3572f, 0.4038f, 30.03f,
0.3799f, 0.447f, 30.03f,
0.4006f, 0.4885f, 30.03f,
0.4159f, 0.519f, 30.03f,
0.4269f, 0.5414f, 30.03f,
0.4354f, 0.5594f, 30.03f,
0.439f, 0.568f, 30.03f,
0.3288f, 0.3592f, 30.03f,
0.3461f, 0.4008f, 30.03f,
0.3622f, 0.4438f, 30.03f,
0.3772f, 0.488f, 30.03f,
0.3891f, 0.5264f, 30.03f,
0.398f, 0.5564f, 30.03f,
0.4042f, 0.5788f, 30.03f,
0.409f, 0.594f, 30.03f,
0.413f, 0.607f, 30.03f,
0.3193f, 0.355f, 30.03f,
0.3275f, 0.3922f, 30.03f,
0.3351f, 0.4321f, 30.03f,
0.3418f, 0.4768f, 30.03f,
0.3463f, 0.5196f, 30.03f,
0.3488f, 0.5596f, 30.03f,
0.3498f, 0.5985f, 30.03f,
0.3498f, 0.6282f, 30.03f,
0.349f, 0.65f, 30.03f,
0.348f, 0.667f, 30.03f,
0.347f, 0.688f, 30.03f,
0.3112f, 0.3496f, 30.03f,
0.3124f, 0.3822f, 30.03f,
0.3128f, 0.4175f, 30.03f,
0.3116f, 0.4563f, 30.03f,
0.3086f, 0.4949f, 30.03f,
0.3037f, 0.5358f, 30.03f,
0.2962f, 0.5802f, 30.03f,
0.2872f, 0.6199f, 30.03f,
0.2763f, 0.6616f, 30.03f,
0.2648f, 0.7004f, 30.03f,
0.253f, 0.738f, 30.03f,
0.238f, 0.782f, 30.03f,
0.225f, 0.82f, 30.03f,
0.208f, 0.863f, 30.03f,
0.188f, 0.905f, 30.03f,
0.171f, 0.939f, 30.03f,
0.3039f, 0.3437f, 30.03f,
0.2967f, 0.3695f, 30.03f,
0.2892f, 0.3963f, 30.03f,
0.2799f, 0.4239f, 30.03f,
0.269f, 0.453f, 30.03f,
0.2574f, 0.4814f, 30.03f,
0.2426f, 0.5133f, 30.03f,
0.2278f, 0.543f, 30.03f,
0.2102f, 0.5737f, 30.03f,
0.1922f, 0.6035f, 30.03f,
0.1739f, 0.6318f, 30.03f,
0.1536f, 0.6605f, 30.03f,
0.134f, 0.6871f, 30.03f,
0.1145f, 0.7122f, 30.03f,
0.092f, 0.738f, 30.03f,
0.069f, 0.764f, 30.03f,
0.047f, 0.789f, 30.03f,
0.2988f, 0.3382f, 30.03f,
0.2868f, 0.3595f, 30.03f,
0.2748f, 0.3795f, 30.03f,
0.2612f, 0.399f, 30.03f,
0.2466f, 0.4181f, 30.03f,
0.2293f, 0.439f, 30.03f,
0.213f, 0.4571f, 30.03f,
0.196f, 0.4751f, 30.03f,
0.1785f, 0.4924f, 30.03f,
0.1609f, 0.5091f, 30.03f,
0.1432f, 0.5252f, 30.03f,
0.1252f, 0.5408f, 30.03f,
0.1079f, 0.556f, 30.03f,
0.0908f, 0.5695f, 30.03f,
0.071f, 0.586f, 30.03f,
0.053f, 0.599f, 30.03f,
0.031f, 0.614f, 30.03f,
0.2958f, 0.3344f, 30.03f,
0.2807f, 0.3522f, 30.03f,
0.2662f, 0.3672f, 30.03f,
0.251f, 0.3829f, 30.03f,
0.235f, 0.3979f, 30.03f,
0.2171f, 0.4138f, 30.03f,
0.2001f, 0.4278f, 30.03f,
0.1832f, 0.4414f, 30.03f,
0.1654f, 0.4551f, 30.03f,
0.1485f, 0.4677f, 30.03f,
0.1325f, 0.4795f, 30.03f,
0.1159f, 0.491f, 30.03f,
0.101f, 0.5018f, 30.03f,
0.0858f, 0.5127f, 30.03f,
0.068f, 0.524f, 30.03f,
0.052f, 0.535f, 30.03f,
0.034f, 0.546f, 30.03f,
0.2929f, 0.3303f, 30.03f,
0.2749f, 0.3443f, 30.03f,
0.2591f, 0.3558f, 30.03f,
0.242f, 0.3679f, 30.03f,
0.2247f, 0.3796f, 30.03f,
0.206f, 0.3914f, 30.03f,
0.1895f, 0.4015f, 30.03f,
0.1722f, 0.4113f, 30.03f,
0.1551f, 0.4208f, 30.03f,
0.1382f, 0.4299f, 30.03f,
0.123f, 0.4378f, 30.03f,
0.107f, 0.4458f, 30.03f,
0.0941f, 0.452f, 30.03f,
0.081f, 0.458f, 30.03f,
0.066f, 0.465f, 30.03f,
0.052f, 0.471f, 30.03f,
0.035f, 0.48f, 30.03f,
0.2902f, 0.3268f, 30.03f,
0.2702f, 0.3369f, 30.03f,
0.2526f, 0.3448f, 30.03f,
0.2332f, 0.3522f, 30.03f,
0.2148f, 0.3584f, 30.03f,
0.1954f, 0.3645f, 30.03f,
0.1779f, 0.3699f, 30.03f,
0.16f, 0.3748f, 30.03f,
0.1428f, 0.379f, 30.03f,
0.1269f, 0.3829f, 30.03f,
0.112f, 0.386f, 30.03f,
0.096f, 0.389f, 30.03f,
0.083f, 0.392f, 30.03f,
0.074f, 0.394f, 30.03f,
0.062f, 0.397f, 30.03f,
0.05f, 0.398f, 30.03f,
0.2872f, 0.3219f, 30.03f,
0.2648f, 0.3262f, 30.03f,
0.2441f, 0.329f, 30.03f,
0.2236f, 0.3311f, 30.03f,
0.2037f, 0.3329f, 30.03f,
0.1844f, 0.3337f, 30.03f,
0.1662f, 0.3343f, 30.03f,
0.1491f, 0.3345f, 30.03f,
0.1325f, 0.3345f, 30.03f,
0.1168f, 0.3344f, 30.03f,
0.101f, 0.332f, 30.03f,
0.086f, 0.332f, 30.03f,
0.075f, 0.331f, 30.03f,
0.068f, 0.33f, 30.03f,
0.06f, 0.33f, 30.03f,
0.2849f, 0.3172f, 30.03f,
0.2604f, 0.3169f, 30.03f,
0.2384f, 0.3155f, 30.03f,
0.2171f, 0.3138f, 30.03f,
0.1961f, 0.311f, 30.03f,
0.1762f, 0.3081f, 30.03f,
0.1585f, 0.3052f, 30.03f,
0.1408f, 0.3017f, 30.03f,
0.1248f, 0.2981f, 30.03f,
0.108f, 0.294f, 30.03f,
0.092f, 0.29f, 30.03f,
0.078f, 0.287f, 30.03f,
0.068f, 0.283f, 30.03f,
0.2837f, 0.3132f, 30.03f,
0.2578f, 0.3078f, 30.03f,
0.2335f, 0.3015f, 30.03f,
0.2116f, 0.295f, 30.03f,
0.1909f, 0.2881f, 30.03f,
0.1698f, 0.2802f, 30.03f,
0.1518f, 0.2729f, 30.03f,
0.1337f, 0.2651f, 30.03f,
0.1181f, 0.2581f, 30.03f,
0.101f, 0.251f, 30.03f,
0.086f, 0.244f, 30.03f,
0.072f, 0.237f, 30.03f,
0.2835f, 0.3097f, 30.03f,
0.2571f, 0.3008f, 30.03f,
0.2312f, 0.2899f, 30.03f,
0.208f, 0.2789f, 30.03f,
0.1879f, 0.2682f, 30.03f,
0.166f, 0.2561f, 30.03f,
0.148f, 0.2459f, 30.03f,
0.1294f, 0.2348f, 30.03f,
0.114f, 0.226f, 30.03f,
0.099f, 0.216f, 30.03f,
0.085f, 0.205f, 30.03f,
0.2842f, 0.3063f, 30.03f,
0.2579f, 0.2938f, 30.03f,
0.232f, 0.2789f, 30.03f,
0.2088f, 0.2635f, 30.03f,
0.1883f, 0.2487f, 30.03f,
0.1685f, 0.2339f, 30.03f,
0.1496f, 0.2193f, 30.03f,
0.131f, 0.2048f, 30.03f,
0.117f, 0.192f, 30.03f,
0.102f, 0.181f, 30.03f,
0.2854f, 0.3037f, 30.03f,
0.2602f, 0.2881f, 30.03f,
0.2352f, 0.2708f, 30.03f,
0.2132f, 0.2537f, 30.03f,
0.1934f, 0.2374f, 30.03f,
0.1734f, 0.2203f, 30.03f,
0.1556f, 0.2043f, 30.03f,
0.1376f, 0.1879f, 30.03f,
0.123f, 0.174f, 30.03f,
0.111f, 0.162f, 30.03f,
0.1f, 0.151f, 30.03f,
0.2871f, 0.3012f, 30.03f,
0.2637f, 0.284f, 30.03f,
0.2399f, 0.265f, 30.03f,
0.2189f, 0.2468f, 30.03f,
0.2f, 0.2298f, 30.03f,
0.1803f, 0.2114f, 30.03f,
0.1629f, 0.1947f, 30.03f,
0.1454f, 0.1778f, 30.03f,
0.131f, 0.164f, 30.03f,
0.12f, 0.153f, 30.03f,
0.111f, 0.144f, 30.03f,
0.099f, 0.133f, 30.03f,
0.2897f, 0.2991f, 30.03f,
0.2684f, 0.2804f, 30.03f,
0.2465f, 0.2599f, 30.03f,
0.2274f, 0.2406f, 30.03f,
0.2095f, 0.2225f, 30.03f,
0.1913f, 0.2038f, 30.03f,
0.1754f, 0.1868f, 30.03f,
0.159f, 0.169f, 30.03f,
0.148f, 0.156f, 30.03f,
0.137f, 0.144f, 30.03f,
0.127f, 0.134f, 30.03f,
0.117f, 0.123f, 30.03f,
0.2923f, 0.2978f, 30.03f,
0.2734f, 0.2778f, 30.03f,
0.2533f, 0.2558f, 30.03f,
0.236f, 0.2365f, 30.03f,
0.2197f, 0.2188f, 30.03f,
0.2026f, 0.1999f, 30.03f,
0.1873f, 0.1822f, 30.03f,
0.171f, 0.164f, 30.03f,
0.162f, 0.153f, 30.03f,
0.151f, 0.14f, 30.03f,
0.143f, 0.129f, 30.03f,
0.135f, 0.118f, 30.03f,
0.126f, 0.107f, 30.03f,
0.2955f, 0.2963f, 30.03f,
0.2798f, 0.2752f, 30.03f,
0.2638f, 0.2531f, 30.03f,
0.2505f, 0.2347f, 30.03f,
0.2378f, 0.2168f, 30.03f,
0.2241f, 0.1975f, 30.03f,
0.2119f, 0.1799f, 30.03f,
0.199f, 0.163f, 30.03f,
0.192f, 0.151f, 30.03f,
0.185f, 0.139f, 30.03f,
0.179f, 0.128f, 30.03f,
0.173f, 0.118f, 30.03f,
0.166f, 0.105f, 30.03f,
0.2988f, 0.2961f, 30.03f,
0.2863f, 0.2747f, 30.03f,
0.274f, 0.2533f, 30.03f,
0.2637f, 0.2352f, 30.03f,
0.254f, 0.2176f, 30.03f,
0.244f, 0.1998f, 30.03f,
0.2352f, 0.1839f, 30.03f,
0.2265f, 0.1671f, 30.03f,
0.221f, 0.156f, 30.03f,
0.214f, 0.143f, 30.03f,
0.208f, 0.132f, 30.03f,
0.204f, 0.123f, 30.03f,
0.199f, 0.111f, 30.03f,
0.194f, 0.101f, 30.03f,
0.3016f, 0.296f, 30.03f,
0.2932f, 0.2759f, 30.03f,
0.2842f, 0.255f, 30.03f,
0.277f, 0.2372f, 30.03f,
0.2703f, 0.2204f, 30.03f,
0.2647f, 0.2052f, 30.03f,
0.2593f, 0.1909f, 30.03f,
0.2548f, 0.1768f, 30.03f,
0.2504f, 0.1658f, 30.03f,
0.246f, 0.153f, 30.03f,
0.242f, 0.142f, 30.03f,
0.239f, 0.132f, 30.03f,
0.235f, 0.121f, 30.03f,
0.231f, 0.112f, 30.03f,
0.228f, 0.102f, 30.03f,
0.225f, 0.093f, 30.03f,
0.305f, 0.2967f, 30.03f,
0.3001f, 0.2778f, 30.03f,
0.295f, 0.2585f, 30.03f,
0.2905f, 0.2421f, 30.03f,
0.2862f, 0.226f, 30.03f,
0.2829f, 0.2121f, 30.03f,
0.2794f, 0.1979f, 30.03f,
0.2761f, 0.1852f, 30.03f,
0.2731f, 0.1738f, 30.03f,
0.2702f, 0.1621f, 30.03f,
0.267f, 0.149f, 30.03f,
0.265f, 0.14f, 30.03f,
0.263f, 0.13f, 30.03f,
0.26f, 0.12f, 30.03f,
0.258f, 0.111f, 30.03f,
0.256f, 0.103f, 30.03f,
0.254f, 0.095f, 30.03f,
0.252f, 0.089f, 30.03f,
0.3107f, 0.2993f, 30.03f,
0.3107f, 0.2831f, 30.03f,
0.3101f, 0.265f, 30.03f,
0.3099f, 0.2502f, 30.03f,
0.3092f, 0.235f, 30.03f,
0.309f, 0.2222f, 30.03f,
0.3084f, 0.2095f, 30.03f,
0.308f, 0.1976f, 30.03f,
0.3075f, 0.187f, 30.03f,
0.3069f, 0.1745f, 30.03f,
0.3062f, 0.1638f, 30.03f,
0.3058f, 0.1547f, 30.03f,
0.305f, 0.144f, 30.03f,
0.304f, 0.136f, 30.03f,
0.303f, 0.126f, 30.03f,
0.302f, 0.118f, 30.03f,
0.301f, 0.111f, 30.03f,
0.301f, 0.105f, 30.03f,
0.3146f, 0.3018f, 30.03f,
0.3181f, 0.2871f, 30.03f,
0.3226f, 0.2716f, 30.03f,
0.3259f, 0.2584f, 30.03f,
0.3293f, 0.245f, 30.03f,
0.3321f, 0.2329f, 30.03f,
0.3349f, 0.2203f, 30.03f,
0.337f, 0.2095f, 30.03f,
0.3388f, 0.1995f, 30.03f,
0.3409f, 0.1882f, 30.03f,
0.3426f, 0.1785f, 30.03f,
0.3441f, 0.1698f, 30.03f,
0.3457f, 0.1604f, 30.03f,
0.347f, 0.151f, 30.03f,
0.349f, 0.144f, 30.03f,
0.35f, 0.136f, 30.03f,
0.351f, 0.129f, 30.03f,
0.352f, 0.123f, 30.03f,
0.3188f, 0.3048f, 30.03f,
0.3272f, 0.2929f, 30.03f,
0.3362f, 0.2799f, 30.03f,
0.3437f, 0.2688f, 30.03f,
0.3509f, 0.2578f, 30.03f,
0.3582f, 0.2462f, 30.03f,
0.3652f, 0.2355f, 30.03f,
0.3718f, 0.2251f, 30.03f,
0.3773f, 0.2158f, 30.03f,
0.3833f, 0.2056f, 30.03f,
0.3877f, 0.1978f, 30.03f,
0.3927f, 0.1892f, 30.03f,
0.397f, 0.181f, 30.03f,
0.401f, 0.174f, 30.03f,
0.406f, 0.166f, 30.03f,
0.41f, 0.159f, 30.03f,
0.413f, 0.153f, 30.03f,
0.416f, 0.148f, 30.03f,
0.3232f, 0.3085f, 30.03f,
0.3371f, 0.3001f, 30.03f,
0.352f, 0.2904f, 30.03f,
0.3648f, 0.282f, 30.03f,
0.3769f, 0.2738f, 30.03f,
0.39f, 0.2646f, 30.03f,
0.4023f, 0.2552f, 30.03f,
0.4136f, 0.2467f, 30.03f,
0.4245f, 0.2382f, 30.03f,
0.4368f, 0.2283f, 30.03f,
0.4449f, 0.2219f, 30.03f,
0.452f, 0.215f, 30.03f,
0.462f, 0.207f, 30.03f,
0.468f, 0.201f, 30.03f,
0.474f, 0.196f, 30.03f,
0.481f, 0.189f, 30.03f,
0.3261f, 0.3113f, 30.03f,
0.3439f, 0.3056f, 30.03f,
0.3635f, 0.2987f, 30.03f,
0.3791f, 0.2929f, 30.03f,
0.396f, 0.286f, 30.03f,
0.4125f, 0.2784f, 30.03f,
0.4285f, 0.2705f, 30.03f,
0.4448f, 0.2622f, 30.03f,
0.4581f, 0.2549f, 30.03f,
0.4735f, 0.2464f, 30.03f,
0.486f, 0.24f, 30.03f,
0.496f, 0.233f, 30.03f,
0.505f, 0.227f, 30.03f,
0.513f, 0.221f, 30.03f,
0.519f, 0.216f, 30.03f,
0.3292f, 0.3141f, 30.03f,
0.3508f, 0.3112f, 30.03f,
0.374f, 0.3074f, 30.03f,
0.393f, 0.3038f, 30.03f,
0.415f, 0.2989f, 30.03f,
0.436f, 0.2936f, 30.03f,
0.4552f, 0.2881f, 30.03f,
0.4781f, 0.2812f, 30.03f,
0.4961f, 0.2751f, 30.03f,
0.513f, 0.268f, 30.03f,
0.527f, 0.262f, 30.03f,
0.541f, 0.256f, 30.03f,
0.552f, 0.25f, 30.03f,
0.563f, 0.246f, 30.03f,
0.3318f, 0.3166f, 30.03f,
0.3566f, 0.3163f, 30.03f,
0.3832f, 0.3158f, 30.03f,
0.4065f, 0.3144f, 30.03f,
0.432f, 0.3118f, 30.03f,
0.4568f, 0.3082f, 30.03f,
0.479f, 0.3041f, 30.03f,
0.5041f, 0.2983f, 30.03f,
0.5262f, 0.2928f, 30.03f,
0.545f, 0.288f, 30.03f,
0.561f, 0.282f, 30.03f,
0.574f, 0.276f, 30.03f,
0.588f, 0.271f, 30.03f,
0.597f, 0.265f, 30.03f,
0.3343f, 0.319f, 30.03f,
0.3628f, 0.3221f, 30.03f,
0.3921f, 0.3244f, 30.03f,
0.4187f, 0.3251f, 30.03f,
0.448f, 0.325f, 30.03f,
0.476f, 0.3234f, 30.03f,
0.502f, 0.3212f, 30.03f,
0.5297f, 0.3179f, 30.03f,
0.5552f, 0.3138f, 30.03f,
0.575f, 0.309f, 30.03f,
0.593f, 0.304f, 30.03f,
0.607f, 0.299f, 30.03f,
0.618f, 0.295f, 30.03f,
0.632f, 0.289f, 30.03f,
0.643f, 0.283f, 30.03f,
0.3381f, 0.3228f, 30.03f,
0.3692f, 0.3291f, 30.03f,
0.4f, 0.334f, 30.03f,
0.4318f, 0.3383f, 30.03f,
0.4655f, 0.3412f, 30.03f,
0.4961f, 0.3428f, 30.03f,
0.5265f, 0.3431f, 30.03f,
0.556f, 0.342f, 30.03f,
0.5829f, 0.3396f, 30.03f,
0.603f, 0.336f, 30.03f,
0.625f, 0.333f, 30.03f,
0.639f, 0.33f, 30.03f,
0.652f, 0.326f, 30.03f,
0.667f, 0.321f, 30.03f,
0.679f, 0.316f, 30.03f,
0.3417f, 0.3268f, 30.03f,
0.3768f, 0.3381f, 30.03f,
0.4103f, 0.3473f, 30.03f,
0.4449f, 0.355f, 30.03f,
0.4812f, 0.3619f, 30.03f,
0.515f, 0.3667f, 30.03f,
0.5468f, 0.3697f, 30.03f,
0.5741f, 0.3713f, 30.03f,
0.6009f, 0.372f, 30.03f,
0.624f, 0.371f, 30.03f,
0.646f, 0.37f, 30.03f,
0.664f, 0.37f, 30.03f,
0.679f, 0.369f, 30.03f,
0.696f, 0.368f, 30.03f,
0.714f, 0.365f, 30.03f,
0.3453f, 0.3321f, 30.03f,
0.3806f, 0.3467f, 30.03f,
0.418f, 0.36f, 30.03f,
0.4533f, 0.3708f, 30.03f,
0.4891f, 0.3806f, 30.03f,
0.5215f, 0.3887f, 30.03f,
0.5488f, 0.3947f, 30.03f,
0.5698f, 0.399f, 30.03f,
0.5879f, 0.4021f, 30.03f,
0.604f, 0.403f, 30.03f,
0.614f, 0.406f, 30.03f,
0.3474f, 0.3373f, 30.03f,
0.384f, 0.3564f, 30.03f,
0.4229f, 0.375f, 30.03f,
0.4592f, 0.39f, 30.03f,
0.4921f, 0.4022f, 30.03f,
0.5199f, 0.4119f, 30.03f,
0.5423f, 0.4188f, 30.03f,
0.5597f, 0.4239f, 30.03f,
0.5715f, 0.427f, 30.03f,
0.585f, 0.431f, 30.03f,
0.3487f, 0.3421f, 30.03f,
0.386f, 0.3652f, 30.03f,
0.4242f, 0.3876f, 30.03f,
0.4596f, 0.4064f, 30.03f,
0.4904f, 0.422f, 30.03f,
0.5145f, 0.4331f, 30.03f,
0.532f, 0.4412f, 30.03f,
0.5468f, 0.4478f, 30.03f,
0.555f, 0.452f, 30.03f,
0.564f, 0.455f, 30.03f,
0.3491f, 0.3483f, 30.03f,
0.3861f, 0.3767f, 30.03f,
0.424f, 0.403f, 30.03f,
0.457f, 0.4249f, 30.03f,
0.4843f, 0.4416f, 30.03f,
0.505f, 0.4536f, 30.03f,
0.52f, 0.4623f, 30.03f,
0.531f, 0.469f, 30.03f,
0.539f, 0.472f, 30.03f,
0.348f, 0.354f, 30.03f,
0.384f, 0.3867f, 30.03f,
0.4203f, 0.4176f, 30.03f,
0.4517f, 0.4421f, 30.03f,
0.476f, 0.4607f, 30.03f,
0.4928f, 0.473f, 30.03f,
0.5061f, 0.4829f, 30.03f,
0.516f, 0.489f, 30.03f,
0.523f, 0.494f, 30.03f,
0.3457f, 0.358f, 30.03f,
0.3794f, 0.3955f, 30.03f,
0.414f, 0.4305f, 30.03f,
0.4426f, 0.4588f, 30.03f,
0.4639f, 0.479f, 30.03f,
0.478f, 0.492f, 30.03f,
0.4905f, 0.5038f, 30.03f,
0.499f, 0.51f, 30.03f,
0.3431f, 0.3601f, 30.03f,
0.3745f, 0.4004f, 30.03f,
0.406f, 0.44f, 30.03f,
0.4321f, 0.4719f, 30.03f,
0.4512f, 0.4943f, 30.03f,
0.4638f, 0.5087f, 30.03f,
0.4754f, 0.522f, 30.03f,
0.482f, 0.528f, 30.03f,
0.3369f, 0.3569f, 43.06f,
0.3624f, 0.3951f, 43.06f,
0.3864f, 0.4305f, 43.06f,
0.409f, 0.4641f, 43.06f,
0.4289f, 0.4937f, 43.06f,
0.442f, 0.5131f, 43.06f,
0.4516f, 0.5277f, 43.06f,
0.4582f, 0.5375f, 43.06f,
0.462f, 0.543f, 43.06f,
0.3328f, 0.3569f, 43.06f,
0.3534f, 0.3953f, 43.06f,
0.3728f, 0.4316f, 43.06f,
0.3919f, 0.4684f, 43.06f,
0.4091f, 0.503f, 43.06f,
0.4213f, 0.527f, 43.06f,
0.4309f, 0.5459f, 43.06f,
0.4366f, 0.5578f, 43.06f,
0.439f, 0.564f, 43.06f,
0.3284f, 0.3559f, 43.06f,
0.3437f, 0.3929f, 43.06f,
0.3581f, 0.4291f, 43.06f,
0.3722f, 0.4669f, 43.06f,
0.3852f, 0.5051f, 43.06f,
0.3949f, 0.5367f, 43.06f,
0.4027f, 0.5615f, 43.06f,
0.4076f, 0.5783f, 43.06f,
0.41f, 0.589f, 43.06f,
0.413f, 0.601f, 43.06f,
0.319f, 0.3516f, 43.06f,
0.3267f, 0.3848f, 43.06f,
0.3341f, 0.4191f, 43.06f,
0.3406f, 0.4558f, 43.06f,
0.3461f, 0.495f, 43.06f,
0.3502f, 0.5328f, 43.06f,
0.3532f, 0.57f, 43.06f,
0.3549f, 0.6f, 43.06f,
0.3555f, 0.6242f, 43.06f,
0.356f, 0.642f, 43.06f,
0.356f, 0.661f, 43.06f,
0.356f, 0.676f, 43.06f,
0.3117f, 0.3469f, 43.06f,
0.3133f, 0.3764f, 43.06f,
0.3142f, 0.4058f, 43.06f,
0.314f, 0.4387f, 43.06f,
0.3123f, 0.4732f, 43.06f,
0.3092f, 0.5095f, 43.06f,
0.3047f, 0.5458f, 43.06f,
0.2981f, 0.5835f, 43.06f,
0.2905f, 0.6186f, 43.06f,
0.2816f, 0.6563f, 43.06f,
0.2728f, 0.6893f, 43.06f,
0.262f, 0.727f, 43.06f,
0.252f, 0.758f, 43.06f,
0.242f, 0.79f, 43.06f,
0.233f, 0.819f, 43.06f,
0.224f, 0.851f, 43.06f,
0.3047f, 0.3413f, 43.06f,
0.2992f, 0.3644f, 43.06f,
0.2933f, 0.3873f, 43.06f,
0.2861f, 0.4129f, 43.06f,
0.2775f, 0.4395f, 43.06f,
0.2672f, 0.4667f, 43.06f,
0.2568f, 0.4931f, 43.06f,
0.2448f, 0.5203f, 43.06f,
0.2328f, 0.5467f, 43.06f,
0.2181f, 0.5744f, 43.06f,
0.2029f, 0.6017f, 43.06f,
0.1875f, 0.6265f, 43.06f,
0.1689f, 0.6549f, 43.06f,
0.149f, 0.681f, 43.06f,
0.126f, 0.709f, 43.06f,
0.106f, 0.733f, 43.06f,
0.081f, 0.759f, 43.06f,
0.3001f, 0.3366f, 43.06f,
0.2902f, 0.3548f, 43.06f,
0.2801f, 0.3721f, 43.06f,
0.2687f, 0.3901f, 43.06f,
0.2554f, 0.4087f, 43.06f,
0.2416f, 0.4267f, 43.06f,
0.2262f, 0.445f, 43.06f,
0.2111f, 0.4616f, 43.06f,
0.1967f, 0.4771f, 43.06f,
0.1805f, 0.4933f, 43.06f,
0.1659f, 0.5074f, 43.06f,
0.1521f, 0.52f, 43.06f,
0.1397f, 0.5312f, 43.06f,
0.123f, 0.546f, 43.06f,
0.105f, 0.56f, 43.06f,
0.088f, 0.573f, 43.06f,
0.069f, 0.587f, 43.06f,
0.2972f, 0.3333f, 43.06f,
0.285f, 0.3482f, 43.06f,
0.2728f, 0.3622f, 43.06f,
0.2595f, 0.3764f, 43.06f,
0.2445f, 0.3914f, 43.06f,
0.2295f, 0.4058f, 43.06f,
0.2139f, 0.4199f, 43.06f,
0.1982f, 0.433f, 43.06f,
0.1841f, 0.4448f, 43.06f,
0.1688f, 0.457f, 43.06f,
0.1539f, 0.4683f, 43.06f,
0.1415f, 0.4778f, 43.06f,
0.1303f, 0.4858f, 43.06f,
0.115f, 0.497f, 43.06f,
0.099f, 0.507f, 43.06f,
0.084f, 0.517f, 43.06f,
0.069f, 0.527f, 43.06f,
0.2945f, 0.3297f, 43.06f,
0.2803f, 0.3415f, 43.06f,
0.2662f, 0.3526f, 43.06f,
0.2513f, 0.3635f, 43.06f,
0.2352f, 0.3748f, 43.06f,
0.2195f, 0.3854f, 43.06f,
0.2033f, 0.3956f, 43.06f,
0.1881f, 0.4049f, 43.06f,
0.1734f, 0.4135f, 43.06f,
0.1589f, 0.422f, 43.06f,
0.1434f, 0.4306f, 43.06f,
0.131f, 0.4377f, 43.06f,
0.121f, 0.443f, 43.06f,
0.108f, 0.449f, 43.06f,
0.094f, 0.457f, 43.06f,
0.083f, 0.463f, 43.06f,
0.2927f, 0.3269f, 43.06f,
0.2764f, 0.3354f, 43.06f,
0.2608f, 0.343f, 43.06f,
0.2439f, 0.3508f, 43.06f,
0.2264f, 0.3576f, 43.06f,
0.2102f, 0.3636f, 43.06f,
0.1932f, 0.3694f, 43.06f,
0.1788f, 0.3739f, 43.06f,
0.1626f, 0.3788f, 43.06f,
0.149f, 0.3827f, 43.06f,
0.1334f, 0.387f, 43.06f,
0.122f, 0.39f, 43.06f,
0.111f, 0.392f, 43.06f,
0.099f, 0.394f, 43.06f,
0.088f, 0.397f, 43.06f,
0.079f, 0.398f, 43.06f,
0.2898f, 0.3225f, 43.06f,
0.2712f, 0.3269f, 43.06f,
0.2543f, 0.3302f, 43.06f,
0.2354f, 0.3335f, 43.06f,
0.2163f, 0.3361f, 43.06f,
0.1997f, 0.3379f, 43.06f,
0.1838f, 0.339f, 43.06f,
0.1675f, 0.3401f, 43.06f,
0.1515f, 0.341f, 43.06f,
0.138f, 0.3412f, 43.06f,
0.122f, 0.34f, 43.06f,
0.11f, 0.34f, 43.06f,
0.101f, 0.34f, 43.06f,
0.092f, 0.34f, 43.06f,
0.083f, 0.339f, 43.06f,
0.2878f, 0.3182f, 43.06f,
0.2671f, 0.3189f, 43.06f,
0.249f, 0.3186f, 43.06f,
0.2292f, 0.3178f, 43.06f,
0.2094f, 0.3165f, 43.06f,
0.1914f, 0.3148f, 43.06f,
0.1751f, 0.3129f, 43.06f,
0.1584f, 0.3101f, 43.06f,
0.1427f, 0.3076f, 43.06f,
0.13f, 0.305f, 43.06f,
0.114f, 0.302f, 43.06f,
0.102f, 0.3f, 43.06f,
0.094f, 0.298f, 43.06f,
0.2869f, 0.3143f, 43.06f,
0.2642f, 0.3109f, 43.06f,
0.2448f, 0.3069f, 43.06f,
0.2235f, 0.3014f, 43.06f,
0.2035f, 0.2956f, 43.06f,
0.1841f, 0.2892f, 43.06f,
0.1671f, 0.2832f, 43.06f,
0.1489f, 0.2768f, 43.06f,
0.134f, 0.271f, 43.06f,
0.122f, 0.266f, 43.06f,
0.108f, 0.26f, 43.06f,
0.094f, 0.253f, 43.06f,
0.2867f, 0.311f, 43.06f,
0.2629f, 0.3038f, 43.06f,
0.2418f, 0.296f, 43.06f,
0.2208f, 0.2871f, 43.06f,
0.1994f, 0.2775f, 43.06f,
0.1797f, 0.2672f, 43.06f,
0.1624f, 0.2581f, 43.06f,
0.1435f, 0.2472f, 43.06f,
0.13f, 0.239f, 43.06f,
0.117f, 0.231f, 43.06f,
0.104f, 0.222f, 43.06f,
0.2875f, 0.3078f, 43.06f,
0.2633f, 0.2972f, 43.06f,
0.241f, 0.2854f, 43.06f,
0.2204f, 0.2729f, 43.06f,
0.1986f, 0.2579f, 43.06f,
0.1778f, 0.243f, 43.06f,
0.1615f, 0.2307f, 43.06f,
0.145f, 0.219f, 43.06f,
0.128f, 0.206f, 43.06f,
0.114f, 0.195f, 43.06f,
0.2888f, 0.3058f, 43.06f,
0.2651f, 0.2927f, 43.06f,
0.2436f, 0.2787f, 43.06f,
0.2225f, 0.2631f, 43.06f,
0.2016f, 0.2466f, 43.06f,
0.1818f, 0.2303f, 43.06f,
0.165f, 0.216f, 43.06f,
0.149f, 0.202f, 43.06f,
0.132f, 0.187f, 43.06f,
0.121f, 0.175f, 43.06f,
0.2908f, 0.3039f, 43.06f,
0.2685f, 0.2886f, 43.06f,
0.2478f, 0.2728f, 43.06f,
0.2277f, 0.2559f, 43.06f,
0.2078f, 0.2382f, 43.06f,
0.1883f, 0.2203f, 43.06f,
0.172f, 0.206f, 43.06f,
0.156f, 0.19f, 43.06f,
0.141f, 0.176f, 43.06f,
0.128f, 0.162f, 43.06f,
0.2932f, 0.3025f, 43.06f,
0.2729f, 0.2848f, 43.06f,
0.2538f, 0.2677f, 43.06f,
0.2352f, 0.2498f, 43.06f,
0.2162f, 0.2309f, 43.06f,
0.199f, 0.213f, 43.06f,
0.183f, 0.195f, 43.06f,
0.168f, 0.179f, 43.06f,
0.156f, 0.165f, 43.06f,
0.2952f, 0.3011f, 43.06f,
0.2773f, 0.2828f, 43.06f,
0.2596f, 0.2643f, 43.06f,
0.2427f, 0.2458f, 43.06f,
0.2254f, 0.2267f, 43.06f,
0.208f, 0.208f, 43.06f,
0.194f, 0.191f, 43.06f,
0.181f, 0.175f, 43.06f,
0.17f, 0.161f, 43.06f,
0.2982f, 0.3003f, 43.06f,
0.2833f, 0.2809f, 43.06f,
0.2687f, 0.2612f, 43.06f,
0.2546f, 0.2418f, 43.06f,
0.241f, 0.2224f, 43.06f,
0.228f, 0.204f, 43.06f,
0.217f, 0.189f, 43.06f,
0.207f, 0.173f, 43.06f,
0.198f, 0.16f, 43.06f,
0.188f, 0.146f, 43.06f,
0.3005f, 0.3f, 43.06f,
0.2886f, 0.2801f, 43.06f,
0.2776f, 0.2612f, 43.06f,
0.267f, 0.2425f, 43.06f,
0.2563f, 0.224f, 43.06f,
0.2465f, 0.2058f, 43.06f,
0.239f, 0.191f, 43.06f,
0.232f, 0.178f, 43.06f,
0.225f, 0.166f, 43.06f,
0.219f, 0.152f, 43.06f,
0.212f, 0.14f, 43.06f,
0.3031f, 0.3f, 43.06f,
0.295f, 0.281f, 43.06f,
0.2873f, 0.2633f, 43.06f,
0.2799f, 0.2459f, 43.06f,
0.2729f, 0.2289f, 43.06f,
0.2664f, 0.2127f, 43.06f,
0.261f, 0.198f, 43.06f,
0.256f, 0.185f, 43.06f,
0.252f, 0.176f, 43.06f,
0.248f, 0.162f, 43.06f,
0.244f, 0.15f, 43.06f,
0.24f, 0.14f, 43.06f,
0.3059f, 0.301f, 43.06f,
0.3009f, 0.2831f, 43.06f,
0.2961f, 0.2663f, 43.06f,
0.2918f, 0.2504f, 43.06f,
0.2872f, 0.2343f, 43.06f,
0.2833f, 0.2197f, 43.06f,
0.2801f, 0.2068f, 43.06f,
0.277f, 0.194f, 43.06f,
0.274f, 0.182f, 43.06f,
0.271f, 0.17f, 43.06f,
0.268f, 0.158f, 43.06f,
0.265f, 0.148f, 43.06f,
0.262f, 0.137f, 43.06f,
0.26f, 0.128f, 43.06f,
0.3109f, 0.3037f, 43.06f,
0.3111f, 0.288f, 43.06f,
0.3111f, 0.273f, 43.06f,
0.3109f, 0.2584f, 43.06f,
0.3108f, 0.2442f, 43.06f,
0.3104f, 0.232f, 43.06f,
0.3101f, 0.2192f, 43.06f,
0.3099f, 0.2074f, 43.06f,
0.3093f, 0.1962f, 43.06f,
0.308f, 0.185f, 43.06f,
0.308f, 0.174f, 43.06f,
0.307f, 0.164f, 43.06f,
0.306f, 0.154f, 43.06f,
0.305f, 0.145f, 43.06f,
0.304f, 0.136f, 43.06f,
0.3138f, 0.3054f, 43.06f,
0.3181f, 0.292f, 43.06f,
0.3221f, 0.2786f, 43.06f,
0.3256f, 0.2654f, 43.06f,
0.3288f, 0.2531f, 43.06f,
0.3314f, 0.2423f, 43.06f,
0.3341f, 0.2308f, 43.06f,
0.3368f, 0.2192f, 43.06f,
0.3391f, 0.2088f, 43.06f,
0.341f, 0.1988f, 43.06f,
0.343f, 0.1883f, 43.06f,
0.344f, 0.179f, 43.06f,
0.344f, 0.17f, 43.06f,
0.345f, 0.162f, 43.06f,
0.346f, 0.154f, 43.06f,
0.317f, 0.3076f, 43.06f,
0.3254f, 0.2971f, 43.06f,
0.3338f, 0.2854f, 43.06f,
0.3417f, 0.2745f, 43.06f,
0.3487f, 0.2648f, 43.06f,
0.3555f, 0.2545f, 43.06f,
0.362f, 0.2448f, 43.06f,
0.3688f, 0.2342f, 43.06f,
0.3751f, 0.2241f, 43.06f,
0.3811f, 0.2143f, 43.06f,
0.385f, 0.206f, 43.06f,
0.389f, 0.2f, 43.06f,
0.394f, 0.192f, 43.06f,
0.398f, 0.184f, 43.06f,
0.402f, 0.178f, 43.06f,
0.3206f, 0.3104f, 43.06f,
0.3332f, 0.3032f, 43.06f,
0.347f, 0.2949f, 43.06f,
0.3603f, 0.2869f, 43.06f,
0.3713f, 0.2798f, 43.06f,
0.3841f, 0.271f, 43.06f,
0.3958f, 0.2628f, 43.06f,
0.4076f, 0.254f, 43.06f,
0.4186f, 0.2459f, 43.06f,
0.426f, 0.239f, 43.06f,
0.436f, 0.232f, 43.06f,
0.443f, 0.226f, 43.06f,
0.452f, 0.217f, 43.06f,
0.46f, 0.211f, 43.06f,
0.3232f, 0.3125f, 43.06f,
0.3389f, 0.3079f, 43.06f,
0.3562f, 0.3022f, 43.06f,
0.3722f, 0.2963f, 43.06f,
0.3871f, 0.2906f, 43.06f,
0.404f, 0.2834f, 43.06f,
0.4195f, 0.2762f, 43.06f,
0.4346f, 0.2689f, 43.06f,
0.448f, 0.261f, 43.06f,
0.46f, 0.255f, 43.06f,
0.471f, 0.249f, 43.06f,
0.481f, 0.243f, 43.06f,
0.491f, 0.236f, 43.06f,
0.3258f, 0.3148f, 43.06f,
0.3446f, 0.3125f, 43.06f,
0.3648f, 0.3098f, 43.06f,
0.3851f, 0.3067f, 43.06f,
0.404f, 0.303f, 43.06f,
0.426f, 0.298f, 43.06f,
0.4456f, 0.2931f, 43.06f,
0.4648f, 0.2878f, 43.06f,
0.483f, 0.283f, 43.06f,
0.498f, 0.279f, 43.06f,
0.511f, 0.274f, 43.06f,
0.526f, 0.267f, 43.06f,
0.3284f, 0.317f, 43.06f,
0.3499f, 0.3171f, 43.06f,
0.3728f, 0.317f, 43.06f,
0.3961f, 0.316f, 43.06f,
0.4183f, 0.3144f, 43.06f,
0.4435f, 0.3119f, 43.06f,
0.466f, 0.3082f, 43.06f,
0.4885f, 0.3039f, 43.06f,
0.507f, 0.3f, 43.06f,
0.523f, 0.296f, 43.06f,
0.536f, 0.291f, 43.06f,
0.553f, 0.287f, 43.06f,
0.3306f, 0.319f, 43.06f,
0.3552f, 0.3222f, 43.06f,
0.3805f, 0.3244f, 43.06f,
0.4067f, 0.3256f, 43.06f,
0.432f, 0.326f, 43.06f,
0.4595f, 0.3252f, 43.06f,
0.4848f, 0.3238f, 43.06f,
0.51f, 0.321f, 43.06f,
0.53f, 0.318f, 43.06f,
0.547f, 0.315f, 43.06f,
0.563f, 0.311f, 43.06f,
0.58f, 0.306f, 43.06f,
0.3335f, 0.322f, 43.06f,
0.3611f, 0.3282f, 43.06f,
0.3888f, 0.3336f, 43.06f,
0.4196f, 0.3382f, 43.06f,
0.447f, 0.3413f, 43.06f,
0.4777f, 0.3435f, 43.06f,
0.5059f, 0.345f, 43.06f,
0.5341f, 0.3452f, 43.06f,
0.554f, 0.343f, 43.06f,
0.573f, 0.341f, 43.06f,
0.592f, 0.338f, 43.06f,
0.607f, 0.335f, 43.06f,
0.622f, 0.332f, 43.06f,
0.336f, 0.3253f, 43.06f,
0.3671f, 0.336f, 43.06f,
0.3984f, 0.3452f, 43.06f,
0.4308f, 0.3533f, 43.06f,
0.46f, 0.3596f, 43.06f,
0.493f, 0.3659f, 43.06f,
0.5234f, 0.37f, 43.06f,
0.5519f, 0.3729f, 43.06f,
0.571f, 0.373f, 43.06f,
0.592f, 0.374f, 43.06f,
0.614f, 0.374f, 43.06f,
0.63f, 0.372f, 43.06f,
0.647f, 0.369f, 43.06f,
0.3392f, 0.3298f, 43.06f,
0.3715f, 0.3439f, 43.06f,
0.4053f, 0.357f, 43.06f,
0.4371f, 0.3679f, 43.06f,
0.4671f, 0.3768f, 43.06f,
0.5001f, 0.3861f, 43.06f,
0.5297f, 0.3938f, 43.06f,
0.5522f, 0.3989f, 43.06f,
0.5695f, 0.4024f, 43.06f,
0.5824f, 0.4046f, 43.06f,
0.594f, 0.407f, 43.06f,
0.602f, 0.409f, 43.06f,
0.3421f, 0.3349f, 43.06f,
0.375f, 0.353f, 43.06f,
0.4091f, 0.3701f, 43.06f,
0.4402f, 0.3842f, 43.06f,
0.4711f, 0.3972f, 43.06f,
0.5007f, 0.4081f, 43.06f,
0.5252f, 0.4168f, 43.06f,
0.5437f, 0.4228f, 43.06f,
0.5564f, 0.4267f, 43.06f,
0.5657f, 0.4298f, 43.06f,
0.575f, 0.434f, 43.06f,
0.3437f, 0.3397f, 43.06f,
0.3772f, 0.3613f, 43.06f,
0.4107f, 0.382f, 43.06f,
0.4415f, 0.3996f, 43.06f,
0.4704f, 0.4151f, 43.06f,
0.497f, 0.4282f, 43.06f,
0.5174f, 0.4381f, 43.06f,
0.5319f, 0.4449f, 43.06f,
0.5417f, 0.4492f, 43.06f,
0.548f, 0.453f, 43.06f,
0.556f, 0.456f, 43.06f,
0.3443f, 0.3454f, 43.06f,
0.3778f, 0.3719f, 43.06f,
0.4102f, 0.396f, 43.06f,
0.4399f, 0.4164f, 43.06f,
0.4667f, 0.4335f, 43.06f,
0.49f, 0.448f, 43.06f,
0.5074f, 0.4581f, 43.06f,
0.5188f, 0.465f, 43.06f,
0.5276f, 0.47f, 43.06f,
0.532f, 0.474f, 43.06f,
0.3436f, 0.3507f, 43.06f,
0.3761f, 0.38f, 43.06f,
0.4073f, 0.4073f, 43.06f,
0.4353f, 0.4312f, 43.06f,
0.4606f, 0.4516f, 43.06f,
0.4806f, 0.4666f, 43.06f,
0.495f, 0.4773f, 43.06f,
0.5049f, 0.4843f, 43.06f,
0.511f, 0.488f, 43.06f,
0.516f, 0.492f, 43.06f,
0.3419f, 0.354f, 43.06f,
0.3718f, 0.3885f, 43.06f,
0.4009f, 0.4198f, 43.06f,
0.4271f, 0.4462f, 43.06f,
0.4509f, 0.4696f, 43.06f,
0.4677f, 0.4857f, 43.06f,
0.4791f, 0.4965f, 43.06f,
0.4875f, 0.5047f, 43.06f,
0.493f, 0.509f, 43.06f,
0.498f, 0.513f, 43.06f,
0.3396f, 0.3558f, 43.06f,
0.3677f, 0.3925f, 43.06f,
0.3943f, 0.4264f, 43.06f,
0.4184f, 0.4568f, 43.06f,
0.44f, 0.483f, 43.06f,
0.4547f, 0.5005f, 43.06f,
0.4652f, 0.5128f, 43.06f,
0.4728f, 0.5215f, 43.06f,
0.477f, 0.527f, 43.06f,
0.3359f, 0.3552f, 59.1f,
0.3581f, 0.3883f, 59.1f,
0.3803f, 0.4216f, 59.1f,
0.4008f, 0.452f, 59.1f,
0.419f, 0.4791f, 59.1f,
0.4341f, 0.502f, 59.1f,
0.445f, 0.5181f, 59.1f,
0.4525f, 0.5295f, 59.1f,
0.457f, 0.5366f, 59.1f,
0.461f, 0.542f, 59.1f,
0.3327f, 0.3555f, 59.1f,
0.3504f, 0.3887f, 59.1f,
0.369f, 0.423f, 59.1f,
0.3858f, 0.455f, 59.1f,
0.4021f, 0.4869f, 59.1f,
0.4154f, 0.5133f, 59.1f,
0.4261f, 0.5344f, 59.1f,
0.4327f, 0.5475f, 59.1f,
0.4371f, 0.5557f, 59.1f,
0.44f, 0.562f, 59.1f,
0.443f, 0.568f, 59.1f,
0.3284f, 0.3542f, 59.1f,
0.3433f, 0.3872f, 59.1f,
0.3573f, 0.4214f, 59.1f,
0.3696f, 0.4542f, 59.1f,
0.3816f, 0.4879f, 59.1f,
0.3924f, 0.5199f, 59.1f,
0.4011f, 0.5468f, 59.1f,
0.4061f, 0.5641f, 59.1f,
0.4104f, 0.5785f, 59.1f,
0.4127f, 0.5855f, 59.1f,
0.415f, 0.595f, 59.1f,
0.3194f, 0.3502f, 59.1f,
0.3266f, 0.3809f, 59.1f,
0.3339f, 0.4129f, 59.1f,
0.3408f, 0.4452f, 59.1f,
0.3463f, 0.4791f, 59.1f,
0.3511f, 0.5144f, 59.1f,
0.3546f, 0.549f, 59.1f,
0.3569f, 0.5798f, 59.1f,
0.3585f, 0.6063f, 59.1f,
0.3592f, 0.6235f, 59.1f,
0.36f, 0.645f, 59.1f,
0.36f, 0.66f, 59.1f,
0.361f, 0.679f, 59.1f,
0.361f, 0.696f, 59.1f,
0.3121f, 0.3459f, 59.1f,
0.314f, 0.3727f, 59.1f,
0.315f, 0.4014f, 59.1f,
0.3149f, 0.4284f, 59.1f,
0.314f, 0.4601f, 59.1f,
0.3124f, 0.4926f, 59.1f,
0.3091f, 0.5247f, 59.1f,
0.3043f, 0.5578f, 59.1f,
0.2987f, 0.5919f, 59.1f,
0.2918f, 0.6255f, 59.1f,
0.2846f, 0.6564f, 59.1f,
0.2781f, 0.684f, 59.1f,
0.271f, 0.702f, 59.1f,
0.262f, 0.726f, 59.1f,
0.252f, 0.752f, 59.1f,
0.24f, 0.784f, 59.1f,
0.3053f, 0.3404f, 59.1f,
0.3009f, 0.3614f, 59.1f,
0.2952f, 0.3851f, 59.1f,
0.2896f, 0.4065f, 59.1f,
0.2829f, 0.4301f, 59.1f,
0.2743f, 0.4554f, 59.1f,
0.2661f, 0.478f, 59.1f,
0.2563f, 0.5045f, 59.1f,
0.2451f, 0.5309f, 59.1f,
0.2339f, 0.5561f, 59.1f,
0.2221f, 0.5799f, 59.1f,
0.2091f, 0.6033f, 59.1f,
0.196f, 0.622f, 59.1f,
0.18f, 0.647f, 59.1f,
0.163f, 0.67f, 59.1f,
0.144f, 0.692f, 59.1f,
0.3009f, 0.3359f, 59.1f,
0.2924f, 0.3523f, 59.1f,
0.2822f, 0.3702f, 59.1f,
0.2723f, 0.3865f, 59.1f,
0.2613f, 0.4026f, 59.1f,
0.2489f, 0.4191f, 59.1f,
0.2368f, 0.4348f, 59.1f,
0.224f, 0.45f, 59.1f,
0.2103f, 0.4652f, 59.1f,
0.1956f, 0.4806f, 59.1f,
0.1821f, 0.494f, 59.1f,
0.168f, 0.507f, 59.1f,
0.151f, 0.521f, 59.1f,
0.134f, 0.537f, 59.1f,
0.115f, 0.553f, 59.1f,
0.096f, 0.564f, 59.1f,
0.2981f, 0.3326f, 59.1f,
0.2874f, 0.3464f, 59.1f,
0.2754f, 0.3608f, 59.1f,
0.2639f, 0.3733f, 59.1f,
0.2515f, 0.3867f, 59.1f,
0.238f, 0.4002f, 59.1f,
0.2254f, 0.4125f, 59.1f,
0.212f, 0.4252f, 59.1f,
0.198f, 0.4372f, 59.1f,
0.1845f, 0.4492f, 59.1f,
0.17f, 0.459f, 59.1f,
0.155f, 0.471f, 59.1f,
0.139f, 0.483f, 59.1f,
0.123f, 0.494f, 59.1f,
0.105f, 0.507f, 59.1f,
0.2957f, 0.3293f, 59.1f,
0.2828f, 0.3403f, 59.1f,
0.2693f, 0.3512f, 59.1f,
0.2564f, 0.3611f, 59.1f,
0.243f, 0.371f, 59.1f,
0.2282f, 0.3811f, 59.1f,
0.2148f, 0.3903f, 59.1f,
0.2012f, 0.3992f, 59.1f,
0.1866f, 0.4086f, 59.1f,
0.1734f, 0.4164f, 59.1f,
0.159f, 0.424f, 59.1f,
0.142f, 0.433f, 59.1f,
0.127f, 0.441f, 59.1f,
0.112f, 0.448f, 59.1f,
0.294f, 0.3268f, 59.1f,
0.2791f, 0.3351f, 59.1f,
0.2647f, 0.3429f, 59.1f,
0.25f, 0.35f, 59.1f,
0.2352f, 0.3566f, 59.1f,
0.2196f, 0.363f, 59.1f,
0.2057f, 0.3681f, 59.1f,
0.1915f, 0.3732f, 59.1f,
0.1759f, 0.3782f, 59.1f,
0.162f, 0.383f, 59.1f,
0.148f, 0.387f, 59.1f,
0.132f, 0.392f, 59.1f,
0.116f, 0.396f, 59.1f,
0.2919f, 0.3228f, 59.1f,
0.2752f, 0.3278f, 59.1f,
0.2588f, 0.3318f, 59.1f,
0.2419f, 0.3352f, 59.1f,
0.2264f, 0.3383f, 59.1f,
0.2101f, 0.3412f, 59.1f,
0.1958f, 0.3432f, 59.1f,
0.1814f, 0.345f, 59.1f,
0.165f, 0.346f, 59.1f,
0.151f, 0.348f, 59.1f,
0.138f, 0.349f, 59.1f,
0.122f, 0.351f, 59.1f,
0.105f, 0.352f, 59.1f,
0.29f, 0.3183f, 59.1f,
0.2718f, 0.32f, 59.1f,
0.2525f, 0.3198f, 59.1f,
0.2352f, 0.3198f, 59.1f,
0.2184f, 0.3196f, 59.1f,
0.201f, 0.3188f, 59.1f,
0.1868f, 0.3179f, 59.1f,
0.1721f, 0.3168f, 59.1f,
0.155f, 0.314f, 59.1f,
0.142f, 0.311f, 59.1f,
0.127f, 0.309f, 59.1f,
0.111f, 0.307f, 59.1f,
0.2894f, 0.3152f, 59.1f,
0.2686f, 0.313f, 59.1f,
0.2489f, 0.3099f, 59.1f,
0.2302f, 0.3063f, 59.1f,
0.212f, 0.3025f, 59.1f,
0.1937f, 0.2978f, 59.1f,
0.1788f, 0.2936f, 59.1f,
0.161f, 0.288f, 59.1f,
0.145f, 0.282f, 59.1f,
0.133f, 0.278f, 59.1f,
0.118f, 0.273f, 59.1f,
0.2897f, 0.3124f, 59.1f,
0.2668f, 0.3067f, 59.1f,
0.2462f, 0.3f, 59.1f,
0.2264f, 0.2923f, 59.1f,
0.2066f, 0.2839f, 59.1f,
0.1877f, 0.2752f, 59.1f,
0.172f, 0.266f, 59.1f,
0.152f, 0.256f, 59.1f,
0.137f, 0.245f, 59.1f,
0.123f, 0.235f, 59.1f,
0.2908f, 0.3096f, 59.1f,
0.2671f, 0.2998f, 59.1f,
0.2457f, 0.2888f, 59.1f,
0.2237f, 0.2761f, 59.1f,
0.204f, 0.263f, 59.1f,
0.182f, 0.247f, 59.1f,
0.166f, 0.236f, 59.1f,
0.148f, 0.221f, 59.1f,
0.132f, 0.207f, 59.1f,
0.2922f, 0.3077f, 59.1f,
0.2688f, 0.2956f, 59.1f,
0.2472f, 0.2821f, 59.1f,
0.2252f, 0.2668f, 59.1f,
0.205f, 0.25f, 59.1f,
0.184f, 0.233f, 59.1f,
0.168f, 0.219f, 59.1f,
0.151f, 0.204f, 59.1f,
0.2935f, 0.3062f, 59.1f,
0.2718f, 0.2911f, 59.1f,
0.2512f, 0.276f, 59.1f,
0.2294f, 0.2587f, 59.1f,
0.21f, 0.242f, 59.1f,
0.19f, 0.224f, 59.1f,
0.174f, 0.206f, 59.1f,
0.2957f, 0.3047f, 59.1f,
0.2758f, 0.2879f, 59.1f,
0.2562f, 0.2709f, 59.1f,
0.237f, 0.253f, 59.1f,
0.218f, 0.235f, 59.1f,
0.202f, 0.217f, 59.1f,
0.185f, 0.199f, 59.1f,
0.2974f, 0.3039f, 59.1f,
0.2798f, 0.2861f, 59.1f,
0.2614f, 0.267f, 59.1f,
0.244f, 0.249f, 59.1f,
0.227f, 0.229f, 59.1f,
0.214f, 0.214f, 59.1f,
0.2f, 0.194f, 59.1f,
0.3003f, 0.3034f, 59.1f,
0.2856f, 0.2846f, 59.1f,
0.2702f, 0.2648f, 59.1f,
0.255f, 0.244f, 59.1f,
0.241f, 0.224f, 59.1f,
0.232f, 0.21f, 59.1f,
0.221f, 0.193f, 59.1f,
0.3027f, 0.3035f, 59.1f,
0.2911f, 0.2848f, 59.1f,
0.2792f, 0.2649f, 59.1f,
0.2677f, 0.2443f, 59.1f,
0.257f, 0.225f, 59.1f,
0.248f, 0.211f, 59.1f,
0.24f, 0.196f, 59.1f,
0.233f, 0.185f, 59.1f,
0.3048f, 0.304f, 59.1f,
0.2962f, 0.285f, 59.1f,
0.2881f, 0.2671f, 59.1f,
0.28f, 0.2488f, 59.1f,
0.274f, 0.231f, 59.1f,
0.268f, 0.218f, 59.1f,
0.263f, 0.204f, 59.1f,
0.259f, 0.194f, 59.1f,
0.255f, 0.183f, 59.1f,
0.3065f, 0.3047f, 59.1f,
0.3012f, 0.2868f, 59.1f,
0.2963f, 0.2704f, 59.1f,
0.2914f, 0.2534f, 59.1f,
0.287f, 0.238f, 59.1f,
0.283f, 0.224f, 59.1f,
0.28f, 0.211f, 59.1f,
0.278f, 0.201f, 59.1f,
0.276f, 0.191f, 59.1f,
0.273f, 0.179f, 59.1f,
0.27f, 0.168f, 59.1f,
0.3107f, 0.307f, 59.1f,
0.3114f, 0.2915f, 59.1f,
0.3114f, 0.2785f, 59.1f,
0.3116f, 0.2626f, 59.1f,
0.3116f, 0.2497f, 59.1f,
0.3117f, 0.237f, 59.1f,
0.311f, 0.224f, 59.1f,
0.311f, 0.214f, 59.1f,
0.311f, 0.204f, 59.1f,
0.311f, 0.194f, 59.1f,
0.311f, 0.184f, 59.1f,
0.311f, 0.173f, 59.1f,
0.311f, 0.162f, 59.1f,
0.3131f, 0.3084f, 59.1f,
0.3175f, 0.2955f, 59.1f,
0.3213f, 0.2829f, 59.1f,
0.325f, 0.27f, 59.1f,
0.3282f, 0.2582f, 59.1f,
0.3312f, 0.247f, 59.1f,
0.3342f, 0.2349f, 59.1f,
0.337f, 0.225f, 59.1f,
0.339f, 0.217f, 59.1f,
0.341f, 0.207f, 59.1f,
0.344f, 0.196f, 59.1f,
0.346f, 0.186f, 59.1f,
0.348f, 0.176f, 59.1f,
0.3154f, 0.31f, 59.1f,
0.3239f, 0.3f, 59.1f,
0.3327f, 0.2898f, 59.1f,
0.3406f, 0.2793f, 59.1f,
0.3479f, 0.2699f, 59.1f,
0.3552f, 0.2594f, 59.1f,
0.3621f, 0.2496f, 59.1f,
0.369f, 0.24f, 59.1f,
0.373f, 0.233f, 59.1f,
0.379f, 0.224f, 59.1f,
0.385f, 0.215f, 59.1f,
0.389f, 0.206f, 59.1f,
0.394f, 0.197f, 59.1f,
0.318f, 0.312f, 59.1f,
0.3308f, 0.3052f, 59.1f,
0.344f, 0.2978f, 59.1f,
0.357f, 0.29f, 59.1f,
0.3685f, 0.2828f, 59.1f,
0.3818f, 0.2742f, 59.1f,
0.393f, 0.267f, 59.1f,
0.402f, 0.26f, 59.1f,
0.411f, 0.253f, 59.1f,
0.42f, 0.245f, 59.1f,
0.429f, 0.237f, 59.1f,
0.437f, 0.23f, 59.1f,
0.32f, 0.3136f, 59.1f,
0.336f, 0.3092f, 59.1f,
0.3521f, 0.3042f, 59.1f,
0.3682f, 0.2983f, 59.1f,
0.383f, 0.293f, 59.1f,
0.4002f, 0.2859f, 59.1f,
0.414f, 0.28f, 59.1f,
0.426f, 0.274f, 59.1f,
0.438f, 0.267f, 59.1f,
0.449f, 0.261f, 59.1f,
0.46f, 0.255f, 59.1f,
0.3218f, 0.3152f, 59.1f,
0.3412f, 0.3135f, 59.1f,
0.36f, 0.3112f, 59.1f,
0.38f, 0.3082f, 59.1f,
0.3983f, 0.3049f, 59.1f,
0.422f, 0.3f, 59.1f,
0.439f, 0.297f, 59.1f,
0.453f, 0.293f, 59.1f,
0.469f, 0.289f, 59.1f,
0.484f, 0.284f, 59.1f,
0.3236f, 0.3169f, 59.1f,
0.346f, 0.3177f, 59.1f,
0.3671f, 0.3175f, 59.1f,
0.39f, 0.3171f, 59.1f,
0.4125f, 0.316f, 59.1f,
0.439f, 0.314f, 59.1f,
0.46f, 0.311f, 59.1f,
0.476f, 0.308f, 59.1f,
0.493f, 0.306f, 59.1f,
0.51f, 0.303f, 59.1f,
0.3254f, 0.3186f, 59.1f,
0.351f, 0.3224f, 59.1f,
0.3743f, 0.3248f, 59.1f,
0.4001f, 0.3263f, 59.1f,
0.4249f, 0.327f, 59.1f,
0.454f, 0.326f, 59.1f,
0.476f, 0.325f, 59.1f,
0.494f, 0.324f, 59.1f,
0.513f, 0.322f, 59.1f,
0.3277f, 0.3211f, 59.1f,
0.3564f, 0.3279f, 59.1f,
0.383f, 0.3335f, 59.1f,
0.4118f, 0.3385f, 59.1f,
0.4388f, 0.3419f, 59.1f,
0.47f, 0.345f, 59.1f,
0.492f, 0.344f, 59.1f,
0.514f, 0.344f, 59.1f,
0.536f, 0.343f, 59.1f,
0.553f, 0.343f, 59.1f,
0.3301f, 0.3237f, 59.1f,
0.3621f, 0.3349f, 59.1f,
0.391f, 0.3442f, 59.1f,
0.4212f, 0.3526f, 59.1f,
0.449f, 0.3589f, 59.1f,
0.481f, 0.365f, 59.1f,
0.507f, 0.369f, 59.1f,
0.529f, 0.371f, 59.1f,
0.551f, 0.374f, 59.1f,
0.569f, 0.374f, 59.1f,
0.588f, 0.375f, 59.1f,
0.607f, 0.375f, 59.1f,
0.625f, 0.375f, 59.1f,
0.3334f, 0.3276f, 59.1f,
0.3667f, 0.3429f, 59.1f,
0.396f, 0.3547f, 59.1f,
0.4275f, 0.3662f, 59.1f,
0.4552f, 0.3761f, 59.1f,
0.4852f, 0.3847f, 59.1f,
0.513f, 0.391f, 59.1f,
0.533f, 0.396f, 59.1f,
0.551f, 0.399f, 59.1f,
0.566f, 0.402f, 59.1f,
0.58f, 0.403f, 59.1f,
0.592f, 0.404f, 59.1f,
0.602f, 0.405f, 59.1f,
0.3373f, 0.333f, 59.1f,
0.369f, 0.351f, 59.1f,
0.3988f, 0.3663f, 59.1f,
0.431f, 0.382f, 59.1f,
0.4576f, 0.3938f, 59.1f,
0.4849f, 0.405f, 59.1f,
0.5088f, 0.4145f, 59.1f,
0.53f, 0.421f, 59.1f,
0.542f, 0.425f, 59.1f,
0.553f, 0.427f, 59.1f,
0.561f, 0.431f, 59.1f,
0.571f, 0.433f, 59.1f,
0.578f, 0.435f, 59.1f,
0.3395f, 0.3379f, 59.1f,
0.3699f, 0.3586f, 59.1f,
0.4f, 0.377f, 59.1f,
0.4306f, 0.3952f, 59.1f,
0.4568f, 0.41f, 59.1f,
0.4816f, 0.4232f, 59.1f,
0.5025f, 0.4338f, 59.1f,
0.5195f, 0.4424f, 59.1f,
0.5316f, 0.448f, 59.1f,
0.5391f, 0.4518f, 59.1f,
0.546f, 0.454f, 59.1f,
0.553f, 0.458f, 59.1f,
0.3407f, 0.3434f, 59.1f,
0.3701f, 0.3674f, 59.1f,
0.3994f, 0.3896f, 59.1f,
0.428f, 0.4102f, 59.1f,
0.4527f, 0.4268f, 59.1f,
0.4753f, 0.4414f, 59.1f,
0.494f, 0.453f, 59.1f,
0.5079f, 0.4613f, 59.1f,
0.5179f, 0.467f, 59.1f,
0.5245f, 0.4709f, 59.1f,
0.53f, 0.474f, 59.1f,
0.3406f, 0.3484f, 59.1f,
0.3684f, 0.3751f, 59.1f,
0.3969f, 0.4009f, 59.1f,
0.4231f, 0.4231f, 59.1f,
0.4469f, 0.4423f, 59.1f,
0.4678f, 0.4589f, 59.1f,
0.4842f, 0.4712f, 59.1f,
0.4957f, 0.48f, 59.1f,
0.5033f, 0.4855f, 59.1f,
0.5091f, 0.49f, 59.1f,
0.514f, 0.494f, 59.1f,
0.3394f, 0.3518f, 59.1f,
0.365f, 0.3826f, 59.1f,
0.3913f, 0.4117f, 59.1f,
0.4158f, 0.4378f, 59.1f,
0.4376f, 0.4601f, 59.1f,
0.4562f, 0.4788f, 59.1f,
0.4699f, 0.492f, 59.1f,
0.4791f, 0.5012f, 59.1f,
0.4847f, 0.5069f, 59.1f,
0.49f, 0.511f, 59.1f,
0.493f, 0.515f, 59.1f,
0.3379f, 0.354f, 59.1f,
0.3622f, 0.3861f, 59.1f,
0.3862f, 0.4175f, 59.1f,
0.4088f, 0.4466f, 59.1f,
0.4283f, 0.4712f, 59.1f,
0.4455f, 0.4917f, 59.1f,
0.4574f, 0.5062f, 59.1f,
0.4658f, 0.5158f, 59.1f,
0.4709f, 0.522f, 59.1f,
0.475f, 0.526f, 59.1f,
0.3349f, 0.3537f, 78.66f,
0.3558f, 0.3852f, 78.66f,
0.3761f, 0.4155f, 78.66f,
0.3957f, 0.445f, 78.66f,
0.412f, 0.4694f, 78.66f,
0.4271f, 0.492f, 78.66f,
0.4393f, 0.5101f, 78.66f,
0.4477f, 0.5225f, 78.66f,
0.454f, 0.532f, 78.66f,
0.457f, 0.537f, 78.66f,
0.462f, 0.544f, 78.66f,
0.3321f, 0.3539f, 78.66f,
0.3499f, 0.3866f, 78.66f,
0.367f, 0.4178f, 78.66f,
0.3834f, 0.449f, 78.66f,
0.3973f, 0.4761f, 78.66f,
0.4108f, 0.5028f, 78.66f,
0.4212f, 0.5237f, 78.66f,
0.4288f, 0.5383f, 78.66f,
0.4354f, 0.5508f, 78.66f,
0.438f, 0.556f, 78.66f,
0.442f, 0.564f, 78.66f,
0.3284f, 0.3534f, 78.66f,
0.3437f, 0.3861f, 78.66f,
0.3572f, 0.4179f, 78.66f,
0.3698f, 0.4497f, 78.66f,
0.381f, 0.4791f, 78.66f,
0.3911f, 0.5082f, 78.66f,
0.3993f, 0.5329f, 78.66f,
0.4058f, 0.5541f, 78.66f,
0.4108f, 0.5699f, 78.66f,
0.414f, 0.58f, 78.66f,
0.417f, 0.59f, 78.66f,
0.3198f, 0.35f, 78.66f,
0.3274f, 0.3793f, 78.66f,
0.3351f, 0.4111f, 78.66f,
0.3414f, 0.4415f, 78.66f,
0.3471f, 0.4735f, 78.66f,
0.3518f, 0.5042f, 78.66f,
0.3551f, 0.5339f, 78.66f,
0.3581f, 0.5654f, 78.66f,
0.3602f, 0.592f, 78.66f,
0.361f, 0.614f, 78.66f,
0.362f, 0.638f, 78.66f,
0.36f, 0.657f, 78.66f,
0.36f, 0.682f, 78.66f,
0.36f, 0.707f, 78.66f,
0.3124f, 0.3454f, 78.66f,
0.3144f, 0.3711f, 78.66f,
0.3153f, 0.4008f, 78.66f,
0.3157f, 0.4259f, 78.66f,
0.3155f, 0.4558f, 78.66f,
0.3139f, 0.4829f, 78.66f,
0.3115f, 0.5129f, 78.66f,
0.3079f, 0.544f, 78.66f,
0.3032f, 0.5748f, 78.66f,
0.298f, 0.602f, 78.66f,
0.292f, 0.627f, 78.66f,
0.284f, 0.653f, 78.66f,
0.277f, 0.681f, 78.66f,
0.268f, 0.707f, 78.66f,
0.3058f, 0.34f, 78.66f,
0.3018f, 0.3606f, 78.66f,
0.2966f, 0.3846f, 78.66f,
0.2912f, 0.4054f, 78.66f,
0.2851f, 0.4275f, 78.66f,
0.2786f, 0.4491f, 78.66f,
0.2711f, 0.4726f, 78.66f,
0.263f, 0.4966f, 78.66f,
0.253f, 0.525f, 78.66f,
0.242f, 0.552f, 78.66f,
0.23f, 0.576f, 78.66f,
0.219f, 0.599f, 78.66f,
0.206f, 0.619f, 78.66f,
0.192f, 0.643f, 78.66f,
0.3017f, 0.3357f, 78.66f,
0.2933f, 0.3519f, 78.66f,
0.2832f, 0.3697f, 78.66f,
0.2735f, 0.3854f, 78.66f,
0.2639f, 0.4001f, 78.66f,
0.2528f, 0.416f, 78.66f,
0.242f, 0.43f, 78.66f,
0.229f, 0.446f, 78.66f,
0.214f, 0.461f, 78.66f,
0.2f, 0.474f, 78.66f,
0.185f, 0.487f, 78.66f,
0.17f, 0.499f, 78.66f,
0.157f, 0.509f, 78.66f,
0.143f, 0.519f, 78.66f,
0.2987f, 0.3323f, 78.66f,
0.2882f, 0.3461f, 78.66f,
0.2763f, 0.3607f, 78.66f,
0.2652f, 0.3738f, 78.66f,
0.2545f, 0.3855f, 78.66f,
0.2419f, 0.3985f, 78.66f,
0.229f, 0.41f, 78.66f,
0.216f, 0.423f, 78.66f,
0.201f, 0.436f, 78.66f,
0.187f, 0.446f, 78.66f,
0.174f, 0.457f, 78.66f,
0.16f, 0.467f, 78.66f,
0.2965f, 0.3293f, 78.66f,
0.284f, 0.3402f, 78.66f,
0.2703f, 0.3513f, 78.66f,
0.2574f, 0.3618f, 78.66f,
0.2457f, 0.3702f, 78.66f,
0.2325f, 0.3796f, 78.66f,
0.217f, 0.388f, 78.66f,
0.203f, 0.396f, 78.66f,
0.188f, 0.405f, 78.66f,
0.175f, 0.411f, 78.66f,
0.161f, 0.419f, 78.66f,
0.147f, 0.425f, 78.66f,
0.2947f, 0.3267f, 78.66f,
0.2805f, 0.3349f, 78.66f,
0.2652f, 0.3433f, 78.66f,
0.2509f, 0.3507f, 78.66f,
0.2382f, 0.3568f, 78.66f,
0.222f, 0.364f, 78.66f,
0.208f, 0.37f, 78.66f,
0.194f, 0.376f, 78.66f,
0.178f, 0.382f, 78.66f,
0.166f, 0.386f, 78.66f,
0.152f, 0.391f, 78.66f,
0.293f, 0.3232f, 78.66f,
0.2768f, 0.3287f, 78.66f,
0.2599f, 0.3338f, 78.66f,
0.2437f, 0.3378f, 78.66f,
0.2301f, 0.3405f, 78.66f,
0.212f, 0.344f, 78.66f,
0.196f, 0.346f, 78.66f,
0.18f, 0.348f, 78.66f,
0.164f, 0.349f, 78.66f,
0.15f, 0.35f, 78.66f,
0.2911f, 0.3188f, 78.66f,
0.2728f, 0.3208f, 78.66f,
0.2543f, 0.322f, 78.66f,
0.2361f, 0.3225f, 78.66f,
0.2215f, 0.3226f, 78.66f,
0.203f, 0.323f, 78.66f,
0.187f, 0.323f, 78.66f,
0.17f, 0.323f, 78.66f,
0.156f, 0.322f, 78.66f,
0.2907f, 0.3159f, 78.66f,
0.27f, 0.314f, 78.66f,
0.2501f, 0.3118f, 78.66f,
0.232f, 0.31f, 78.66f,
0.214f, 0.306f, 78.66f,
0.196f, 0.304f, 78.66f,
0.18f, 0.301f, 78.66f,
0.162f, 0.298f, 78.66f,
0.147f, 0.294f, 78.66f,
0.2909f, 0.3125f, 78.66f,
0.268f, 0.3073f, 78.66f,
0.247f, 0.302f, 78.66f,
0.228f, 0.296f, 78.66f,
0.211f, 0.29f, 78.66f,
0.193f, 0.284f, 78.66f,
0.176f, 0.278f, 78.66f,
0.158f, 0.271f, 78.66f,
0.2919f, 0.3102f, 78.66f,
0.2675f, 0.3005f, 78.66f,
0.246f, 0.29f, 78.66f,
0.228f, 0.281f, 78.66f,
0.21f, 0.272f, 78.66f,
0.191f, 0.26f, 78.66f,
0.175f, 0.251f, 78.66f,
0.157f, 0.241f, 78.66f,
0.2937f, 0.3087f, 78.66f,
0.2688f, 0.2961f, 78.66f,
0.247f, 0.285f, 78.66f,
0.228f, 0.273f, 78.66f,
0.211f, 0.262f, 78.66f,
0.194f, 0.252f, 78.66f,
0.2949f, 0.3076f, 78.66f,
0.2712f, 0.2924f, 78.66f,
0.25f, 0.278f, 78.66f,
0.233f, 0.265f, 78.66f,
0.216f, 0.25f, 78.66f,
0.2975f, 0.3063f, 78.66f,
0.276f, 0.289f, 78.66f,
0.256f, 0.272f, 78.66f,
0.239f, 0.257f, 78.66f,
0.224f, 0.243f, 78.66f,
0.2991f, 0.3057f, 78.66f,
0.281f, 0.287f, 78.66f,
0.262f, 0.268f, 78.66f,
0.247f, 0.252f, 78.66f,
0.232f, 0.235f, 78.66f,
0.3015f, 0.3052f, 78.66f,
0.286f, 0.285f, 78.66f,
0.271f, 0.266f, 78.66f,
0.257f, 0.245f, 78.66f,
0.247f, 0.227f, 78.66f,
0.3038f, 0.3054f, 78.66f,
0.291f, 0.285f, 78.66f,
0.278f, 0.266f, 78.66f,
0.267f, 0.245f, 78.66f,
0.256f, 0.226f, 78.66f,
0.305f, 0.3051f, 78.66f,
0.2963f, 0.2865f, 78.66f,
0.288f, 0.268f, 78.66f,
0.28f, 0.249f, 78.66f,
0.273f, 0.23f, 78.66f,
0.3067f, 0.306f, 78.66f,
0.3003f, 0.287f, 78.66f,
0.296f, 0.271f, 78.66f,
0.292f, 0.253f, 78.66f,
0.286f, 0.235f, 78.66f,
0.284f, 0.221f, 78.66f,
0.281f, 0.208f, 78.66f,
0.3107f, 0.3081f, 78.66f,
0.3117f, 0.2928f, 78.66f,
0.312f, 0.2788f, 78.66f,
0.311f, 0.262f, 78.66f,
0.31f, 0.247f, 78.66f,
0.308f, 0.233f, 78.66f,
0.306f, 0.22f, 78.66f,
0.305f, 0.208f, 78.66f,
0.3128f, 0.3094f, 78.66f,
0.3176f, 0.2966f, 78.66f,
0.3218f, 0.2845f, 78.66f,
0.326f, 0.27f, 78.66f,
0.33f, 0.257f, 78.66f,
0.334f, 0.246f, 78.66f,
0.336f, 0.235f, 78.66f,
0.339f, 0.224f, 78.66f,
0.3149f, 0.3108f, 78.66f,
0.3234f, 0.301f, 78.66f,
0.3322f, 0.291f, 78.66f,
0.34f, 0.28f, 78.66f,
0.349f, 0.271f, 78.66f,
0.356f, 0.261f, 78.66f,
0.364f, 0.251f, 78.66f,
0.371f, 0.243f, 78.66f,
0.3172f, 0.3126f, 78.66f,
0.3301f, 0.306f, 78.66f,
0.3431f, 0.2988f, 78.66f,
0.355f, 0.292f, 78.66f,
0.368f, 0.284f, 78.66f,
0.38f, 0.276f, 78.66f,
0.389f, 0.269f, 78.66f,
0.4f, 0.263f, 78.66f,
0.319f, 0.3141f, 78.66f,
0.335f, 0.3099f, 78.66f,
0.3512f, 0.3052f, 78.66f,
0.364f, 0.3f, 78.66f,
0.382f, 0.295f, 78.66f,
0.397f, 0.289f, 78.66f,
0.41f, 0.284f, 78.66f,
0.3205f, 0.3155f, 78.66f,
0.34f, 0.314f, 78.66f,
0.359f, 0.3118f, 78.66f,
0.376f, 0.31f, 78.66f,
0.394f, 0.306f, 78.66f,
0.414f, 0.302f, 78.66f,
0.431f, 0.298f, 78.66f,
0.322f, 0.3168f, 78.66f,
0.3445f, 0.3179f, 78.66f,
0.3665f, 0.3183f, 78.66f,
0.384f, 0.318f, 78.66f,
0.406f, 0.316f, 78.66f,
0.429f, 0.314f, 78.66f,
0.448f, 0.311f, 78.66f,
0.324f, 0.3188f, 78.66f,
0.3495f, 0.3226f, 78.66f,
0.3734f, 0.3256f, 78.66f,
0.395f, 0.326f, 78.66f,
0.418f, 0.326f, 78.66f,
0.444f, 0.325f, 78.66f,
0.3263f, 0.321f, 78.66f,
0.3551f, 0.3283f, 78.66f,
0.3812f, 0.3348f, 78.66f,
0.407f, 0.338f, 78.66f,
0.431f, 0.34f, 78.66f,
0.457f, 0.34f, 78.66f,
0.48f, 0.34f, 78.66f,
0.3284f, 0.3233f, 78.66f,
0.36f, 0.3348f, 78.66f,
0.388f, 0.3439f, 78.66f,
0.416f, 0.35f, 78.66f,
0.441f, 0.356f, 78.66f,
0.465f, 0.361f, 78.66f,
0.49f, 0.364f, 78.66f,
0.51f, 0.368f, 78.66f,
0.332f, 0.3273f, 78.66f,
0.3641f, 0.3422f, 78.66f,
0.3927f, 0.355f, 78.66f,
0.422f, 0.365f, 78.66f,
0.446f, 0.373f, 78.66f,
0.469f, 0.38f, 78.66f,
0.492f, 0.387f, 78.66f,
0.513f, 0.392f, 78.66f,
0.532f, 0.396f, 78.66f,
0.3353f, 0.3325f, 78.66f,
0.3668f, 0.3509f, 78.66f,
0.3948f, 0.3659f, 78.66f,
0.422f, 0.379f, 78.66f,
0.448f, 0.39f, 78.66f,
0.47f, 0.4f, 78.66f,
0.491f, 0.408f, 78.66f,
0.51f, 0.416f, 78.66f,
0.525f, 0.421f, 78.66f,
0.541f, 0.426f, 78.66f,
0.55f, 0.43f, 78.66f,
0.559f, 0.433f, 78.66f,
0.567f, 0.435f, 78.66f,
0.338f, 0.3377f, 78.66f,
0.3679f, 0.3585f, 78.66f,
0.395f, 0.3763f, 78.66f,
0.422f, 0.393f, 78.66f,
0.447f, 0.407f, 78.66f,
0.468f, 0.418f, 78.66f,
0.486f, 0.428f, 78.66f,
0.503f, 0.436f, 78.66f,
0.517f, 0.444f, 78.66f,
0.529f, 0.45f, 78.66f,
0.537f, 0.454f, 78.66f,
0.545f, 0.459f, 78.66f,
0.553f, 0.463f, 78.66f,
0.3392f, 0.343f, 78.66f,
0.3677f, 0.3668f, 78.66f,
0.3941f, 0.3877f, 78.66f,
0.4199f, 0.4069f, 78.66f,
0.444f, 0.424f, 78.66f,
0.463f, 0.436f, 78.66f,
0.48f, 0.447f, 78.66f,
0.495f, 0.455f, 78.66f,
0.506f, 0.462f, 78.66f,
0.516f, 0.468f, 78.66f,
0.524f, 0.473f, 78.66f,
0.532f, 0.478f, 78.66f,
0.339f, 0.3472f, 78.66f,
0.3655f, 0.3738f, 78.66f,
0.391f, 0.3972f, 78.66f,
0.4154f, 0.4186f, 78.66f,
0.437f, 0.4369f, 78.66f,
0.4569f, 0.4527f, 78.66f,
0.473f, 0.465f, 78.66f,
0.486f, 0.476f, 78.66f,
0.494f, 0.483f, 78.66f,
0.501f, 0.488f, 78.66f,
0.509f, 0.494f, 78.66f,
0.515f, 0.499f, 78.66f,
0.3378f, 0.3504f, 78.66f,
0.3621f, 0.3799f, 78.66f,
0.3858f, 0.4071f, 78.66f,
0.408f, 0.4319f, 78.66f,
0.4275f, 0.4529f, 78.66f,
0.4455f, 0.4719f, 78.66f,
0.4602f, 0.4869f, 78.66f,
0.4711f, 0.4977f, 78.66f,
0.4782f, 0.5049f, 78.66f,
0.483f, 0.5092f, 78.66f,
0.489f, 0.515f, 78.66f,
0.495f, 0.522f, 78.66f,
0.3365f, 0.3527f, 78.66f,
0.3591f, 0.3832f, 78.66f,
0.3811f, 0.4123f, 78.66f,
0.4019f, 0.4392f, 78.66f,
0.4201f, 0.4622f, 78.66f,
0.4369f, 0.4829f, 78.66f,
0.4503f, 0.4993f, 78.66f,
0.4595f, 0.5104f, 78.66f,
0.4663f, 0.5188f, 78.66f,
0.471f, 0.523f, 78.66f,
0.476f, 0.528f, 78.66f,
0.334f, 0.352f, 102.57f,
0.355f, 0.382f, 102.57f,
0.371f, 0.409f, 102.57f,
0.39f, 0.437f, 102.57f,
0.405f, 0.46f, 102.57f,
0.42f, 0.481f, 102.57f,
0.433f, 0.502f, 102.57f,
0.442f, 0.515f, 102.57f,
0.45f, 0.527f, 102.57f,
0.455f, 0.534f, 102.57f,
0.46f, 0.541f, 102.57f,
0.332f, 0.354f, 102.57f,
0.348f, 0.384f, 102.57f,
0.365f, 0.413f, 102.57f,
0.38f, 0.442f, 102.57f,
0.393f, 0.466f, 102.57f,
0.406f, 0.492f, 102.57f,
0.416f, 0.514f, 102.57f,
0.424f, 0.529f, 102.57f,
0.432f, 0.546f, 102.57f,
0.436f, 0.552f, 102.57f,
0.44f, 0.56f, 102.57f,
0.328f, 0.354f, 102.57f,
0.343f, 0.384f, 102.57f,
0.356f, 0.414f, 102.57f,
0.37f, 0.446f, 102.57f,
0.38f, 0.47f, 102.57f,
0.391f, 0.497f, 102.57f,
0.398f, 0.518f, 102.57f,
0.405f, 0.538f, 102.57f,
0.41f, 0.56f, 102.57f,
0.413f, 0.572f, 102.57f,
0.416f, 0.58f, 102.57f,
0.32f, 0.351f, 102.57f,
0.327f, 0.378f, 102.57f,
0.334f, 0.41f, 102.57f,
0.342f, 0.439f, 102.57f,
0.347f, 0.47f, 102.57f,
0.351f, 0.493f, 102.57f,
0.354f, 0.518f, 102.57f,
0.357f, 0.545f, 102.57f,
0.36f, 0.571f, 102.57f,
0.361f, 0.592f, 102.57f,
0.36f, 0.608f, 102.57f,
0.312f, 0.346f, 102.57f,
0.314f, 0.37f, 102.57f,
0.314f, 0.4f, 102.57f,
0.314f, 0.423f, 102.57f,
0.314f, 0.454f, 102.57f,
0.314f, 0.474f, 102.57f,
0.313f, 0.5f, 102.57f,
0.31f, 0.527f, 102.57f,
0.307f, 0.556f, 102.57f,
0.303f, 0.58f, 102.57f,
0.299f, 0.6f, 102.57f,
0.306f, 0.342f, 102.57f,
0.303f, 0.361f, 102.57f,
0.298f, 0.385f, 102.57f,
0.293f, 0.404f, 102.57f,
0.286f, 0.427f, 102.57f,
0.282f, 0.444f, 102.57f,
0.276f, 0.467f, 102.57f,
0.27f, 0.49f, 102.57f,
0.262f, 0.517f, 102.57f,
0.254f, 0.543f, 102.57f,
0.248f, 0.563f, 102.57f,
0.301f, 0.337f, 102.57f,
0.293f, 0.353f, 102.57f,
0.283f, 0.369f, 102.57f,
0.274f, 0.384f, 102.57f,
0.265f, 0.398f, 102.57f,
0.256f, 0.412f, 102.57f,
0.245f, 0.426f, 102.57f,
0.235f, 0.44f, 102.57f,
0.222f, 0.457f, 102.57f,
0.298f, 0.333f, 102.57f,
0.288f, 0.346f, 102.57f,
0.277f, 0.36f, 102.57f,
0.266f, 0.374f, 102.57f,
0.256f, 0.385f, 102.57f,
0.246f, 0.397f, 102.57f,
0.235f, 0.409f, 102.57f,
0.224f, 0.42f, 102.57f,
0.296f, 0.331f, 102.57f,
0.284f, 0.341f, 102.57f,
0.271f, 0.351f, 102.57f,
0.258f, 0.361f, 102.57f,
0.248f, 0.369f, 102.57f,
0.235f, 0.378f, 102.57f,
0.223f, 0.387f, 102.57f,
0.294f, 0.327f, 102.57f,
0.28f, 0.335f, 102.57f,
0.265f, 0.343f, 102.57f,
0.251f, 0.35f, 102.57f,
0.241f, 0.357f, 102.57f,
0.227f, 0.362f, 102.57f,
0.213f, 0.368f, 102.57f,
0.293f, 0.323f, 102.57f,
0.277f, 0.33f, 102.57f,
0.262f, 0.335f, 102.57f,
0.246f, 0.34f, 102.57f,
0.233f, 0.342f, 102.57f,
0.22f, 0.345f, 102.57f,
0.203f, 0.348f, 102.57f,
0.293f, 0.318f, 102.57f,
0.273f, 0.32f, 102.57f,
0.256f, 0.321f, 102.57f,
0.238f, 0.322f, 102.57f,
0.224f, 0.322f, 102.57f,
0.209f, 0.322f, 102.57f,
0.293f, 0.315f, 102.57f,
0.27f, 0.313f, 102.57f,
0.251f, 0.311f, 102.57f,
0.234f, 0.31f, 102.57f,
0.219f, 0.308f, 102.57f,
0.203f, 0.305f, 102.57f,
0.293f, 0.313f, 102.57f,
0.27f, 0.308f, 102.57f,
0.249f, 0.304f, 102.57f,
0.232f, 0.299f, 102.57f,
0.215f, 0.293f, 102.57f,
0.294f, 0.312f, 102.57f,
0.268f, 0.302f, 102.57f,
0.248f, 0.296f, 102.57f,
0.23f, 0.288f, 102.57f,
0.295f, 0.31f, 102.57f,
0.269f, 0.298f, 102.57f,
0.249f, 0.287f, 102.57f,
0.296f, 0.309f, 102.57f,
0.272f, 0.294f, 102.57f,
0.251f, 0.28f, 102.57f,
0.298f, 0.307f, 102.57f,
0.278f, 0.29f, 102.57f,
0.26f, 0.274f, 102.57f,
0.299f, 0.307f, 102.57f,
0.282f, 0.288f, 102.57f,
0.265f, 0.27f, 102.57f,
0.302f, 0.307f, 102.57f,
0.286f, 0.286f, 102.57f,
0.273f, 0.268f, 102.57f,
0.303f, 0.307f, 102.57f,
0.291f, 0.286f, 102.57f,
0.28f, 0.268f, 102.57f,
0.305f, 0.307f, 102.57f,
0.296f, 0.288f, 102.57f,
0.289f, 0.27f, 102.57f,
0.307f, 0.307f, 102.57f,
0.302f, 0.289f, 102.57f,
0.298f, 0.274f, 102.57f,
0.294f, 0.258f, 102.57f,
0.31f, 0.308f, 102.57f,
0.311f, 0.294f, 102.57f,
0.311f, 0.28f, 102.57f,
0.311f, 0.266f, 102.57f,
0.313f, 0.309f, 102.57f,
0.317f, 0.297f, 102.57f,
0.321f, 0.284f, 102.57f,
0.326f, 0.273f, 102.57f,
0.328f, 0.264f, 102.57f,
0.315f, 0.311f, 102.57f,
0.323f, 0.301f, 102.57f,
0.332f, 0.291f, 102.57f,
0.339f, 0.282f, 102.57f,
0.344f, 0.275f, 102.57f,
0.318f, 0.313f, 102.57f,
0.332f, 0.307f, 102.57f,
0.345f, 0.3f, 102.57f,
0.355f, 0.293f, 102.57f,
0.363f, 0.288f, 102.57f,
0.32f, 0.314f, 102.57f,
0.335f, 0.31f, 102.57f,
0.351f, 0.305f, 102.57f,
0.365f, 0.301f, 102.57f,
0.322f, 0.316f, 102.57f,
0.342f, 0.315f, 102.57f,
0.361f, 0.314f, 102.57f,
0.378f, 0.311f, 102.57f,
0.324f, 0.318f, 102.57f,
0.345f, 0.318f, 102.57f,
0.366f, 0.318f, 102.57f,
0.385f, 0.318f, 102.57f,
0.326f, 0.32f, 102.57f,
0.348f, 0.322f, 102.57f,
0.372f, 0.325f, 102.57f,
0.392f, 0.326f, 102.57f,
0.329f, 0.322f, 102.57f,
0.354f, 0.329f, 102.57f,
0.38f, 0.334f, 102.57f,
0.402f, 0.337f, 102.57f,
0.332f, 0.326f, 102.57f,
0.359f, 0.336f, 102.57f,
0.386f, 0.344f, 102.57f,
0.411f, 0.349f, 102.57f,
0.334f, 0.329f, 102.57f,
0.362f, 0.342f, 102.57f,
0.389f, 0.354f, 102.57f,
0.415f, 0.363f, 102.57f,
0.336f, 0.333f, 102.57f,
0.364f, 0.35f, 102.57f,
0.391f, 0.365f, 102.57f,
0.416f, 0.378f, 102.57f,
0.44f, 0.388f, 102.57f,
0.337f, 0.338f, 102.57f,
0.366f, 0.357f, 102.57f,
0.391f, 0.375f, 102.57f,
0.415f, 0.391f, 102.57f,
0.439f, 0.405f, 102.57f,
0.455f, 0.416f, 102.57f,
0.338f, 0.343f, 102.57f,
0.366f, 0.367f, 102.57f,
0.389f, 0.385f, 102.57f,
0.412f, 0.402f, 102.57f,
0.435f, 0.42f, 102.57f,
0.452f, 0.431f, 102.57f,
0.467f, 0.442f, 102.57f,
0.483f, 0.453f, 102.57f,
0.337f, 0.347f, 102.57f,
0.363f, 0.373f, 102.57f,
0.385f, 0.395f, 102.57f,
0.407f, 0.413f, 102.57f,
0.428f, 0.431f, 102.57f,
0.446f, 0.446f, 102.57f,
0.463f, 0.46f, 102.57f,
0.476f, 0.47f, 102.57f,
0.487f, 0.477f, 102.57f,
0.496f, 0.486f, 102.57f,
0.503f, 0.49f, 102.57f,
0.336f, 0.348f, 102.57f,
0.36f, 0.377f, 102.57f,
0.381f, 0.402f, 102.57f,
0.4f, 0.425f, 102.57f,
0.418f, 0.446f, 102.57f,
0.435f, 0.465f, 102.57f,
0.45f, 0.481f, 102.57f,
0.462f, 0.494f, 102.57f,
0.472f, 0.502f, 102.57f,
0.478f, 0.508f, 102.57f,
0.484f, 0.514f, 102.57f,
0.335f, 0.351f, 102.57f,
0.357f, 0.38f, 102.57f,
0.376f, 0.407f, 102.57f,
0.395f, 0.432f, 102.57f,
0.412f, 0.454f, 102.57f,
0.427f, 0.473f, 102.57f,
0.442f, 0.492f, 102.57f,
0.453f, 0.505f, 102.57f,
0.462f, 0.515f, 102.57f,
0.467f, 0.521f, 102.57f,
0.472f, 0.528f, 102.57f
};
